/* A Bison parser, made by GNU Bison 3.7.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2020 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30704

/* Bison version string.  */
#define YYBISON_VERSION "3.7.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 79 "cfg.y"


#include <stdlib.h>
#include <stdio.h>
#include <sys/socket.h>
#include <unistd.h>
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <arpa/inet.h>
#include <string.h>
#include <errno.h>
#include "route_struct.h"
#include "globals.h"
#include "route.h"
#include "dprint.h"
#include "cfg_pp.h"
#include "sr_module.h"
#include "modparam.h"
#include "ip_addr.h"
#include "resolve.h"
#include "socket_info.h"
#include "name_alias.h"
#include "ut.h"
#include "pt_scaling.h"
#include "dset.h"
#include "pvar.h"
#include "blacklists.h"
#include "xlog.h"
#include "db/db_insertq.h"
#include "bin_interface.h"
#include "net/trans.h"
#include "config.h"
#include "mem/rpm_mem.h"
#include "poll_types.h"

#ifdef SHM_EXTRA_STATS
#include "mem/module_info.h"
#endif

#ifdef DEBUG_DMALLOC
#include <dmalloc.h>
#endif

/* hack to avoid alloca usage in the generated C file (needed for compiler
 with no built in alloca, like icc*/
#undef _ALLOCA_H

#undef MIN
#undef MAX

extern int yylex();
static void yyerror(char* s);
static void yyerrorf(char* fmt, ...);
static char* tmp;
static int i_tmp, rc;
static struct socket_id* lst_tmp;
static int rt;  /* Type of route block for find_export */
static str s_tmp;
static str tstr;
static struct net* net_tmp;
static pv_spec_t *spec;
static pv_elem_t *elem;
static struct bl_rule *bl_head = 0;
static struct bl_rule *bl_tail = 0;
static struct script_route_ref *rt_ref = NULL;

action_elem_t elems[MAX_ACTION_ELEMS];
static action_elem_t route_elems[MAX_ACTION_ELEMS];
action_elem_t *a_tmp;

static inline void warn(char* s);
static struct socket_id* mk_listen_id(char*, enum sip_protos, int);
static struct socket_id* set_listen_id_adv(struct socket_id *, char *, int);
static struct multi_str *new_string(char *s);
static int parse_ipnet(char *in, int len, struct net **ipnet);

extern int line;
extern int column;
extern int startcolumn;
extern char *finame;

struct listen_param {
	enum si_flags flags;
	int workers;
	struct socket_id *socket;
	char *tag;
	char *auto_scaling_profile;
} p_tmp;
static void fill_socket_id(struct listen_param *param, struct socket_id *s);

union route_name_var {
	int iname;
	struct _pv_spec *sname;
	struct _pv_elem *ename;
	void *data;
} rn_tmp;

#ifndef SHM_EXTRA_STATS
struct multi_str{
	char *s;
	struct multi_str* next;
};
#else
static struct multi_str *tmp_mod;
#endif

#define get_cfg_file_name \
	((finame) ? finame : cfg_file ? cfg_file : "default")



#define mk_action_(_res, _type, _no, _elems) \
	do { \
		_res = mk_action(_type, _no, _elems, line, get_cfg_file_name); \
	} while(0)
#define mk_action0(_res, _type) \
	do { \
		_res = mk_action(_type, 0, 0, line, get_cfg_file_name); \
	} while(0)
#define mk_action1(_res, _type, _p1_type, _p1) \
	do { \
		elems[0].type = _p1_type; \
		elems[0].u.data = _p1; \
		_res = mk_action(_type, 1, elems, line, get_cfg_file_name); \
	} while(0)
#define	mk_action2(_res, _type, _p1_type, _p2_type, _p1, _p2) \
	do { \
		elems[0].type = _p1_type; \
		elems[0].u.data = _p1; \
		elems[1].type = _p2_type; \
		elems[1].u.data = _p2; \
		_res = mk_action(_type, 2, elems, line, get_cfg_file_name); \
	} while(0)
#define mk_action3(_res, _type, _p1_type, _p2_type, _p3_type, _p1, _p2, _p3) \
	do { \
		elems[0].type = _p1_type; \
		elems[0].u.data = _p1; \
		elems[1].type = _p2_type; \
		elems[1].u.data = _p2; \
		elems[2].type = _p3_type; \
		elems[2].u.data = _p3; \
		_res = mk_action(_type, 3, elems, line, get_cfg_file_name); \
	} while(0)

extern int cfg_parse_only_routes;
#define IFOR(_instr) \
	if (cfg_parse_only_routes==1) {_instr;break;}


#line 222 "cfg.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "cfg.tab.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_DROP = 3,                       /* DROP  */
  YYSYMBOL_ASSERT = 4,                     /* ASSERT  */
  YYSYMBOL_EXIT = 5,                       /* EXIT  */
  YYSYMBOL_RETURN = 6,                     /* RETURN  */
  YYSYMBOL_LOG_TOK = 7,                    /* LOG_TOK  */
  YYSYMBOL_ERROR = 8,                      /* ERROR  */
  YYSYMBOL_ROUTE = 9,                      /* ROUTE  */
  YYSYMBOL_ROUTE_FAILURE = 10,             /* ROUTE_FAILURE  */
  YYSYMBOL_ROUTE_ONREPLY = 11,             /* ROUTE_ONREPLY  */
  YYSYMBOL_ROUTE_BRANCH = 12,              /* ROUTE_BRANCH  */
  YYSYMBOL_ROUTE_ERROR = 13,               /* ROUTE_ERROR  */
  YYSYMBOL_ROUTE_LOCAL = 14,               /* ROUTE_LOCAL  */
  YYSYMBOL_ROUTE_STARTUP = 15,             /* ROUTE_STARTUP  */
  YYSYMBOL_ROUTE_TIMER = 16,               /* ROUTE_TIMER  */
  YYSYMBOL_ROUTE_EVENT = 17,               /* ROUTE_EVENT  */
  YYSYMBOL_IF = 18,                        /* IF  */
  YYSYMBOL_ELSE = 19,                      /* ELSE  */
  YYSYMBOL_SWITCH = 20,                    /* SWITCH  */
  YYSYMBOL_CASE = 21,                      /* CASE  */
  YYSYMBOL_DEFAULT = 22,                   /* DEFAULT  */
  YYSYMBOL_BREAK = 23,                     /* BREAK  */
  YYSYMBOL_WHILE = 24,                     /* WHILE  */
  YYSYMBOL_FOR = 25,                       /* FOR  */
  YYSYMBOL_IN = 26,                        /* IN  */
  YYSYMBOL_READONLY = 27,                  /* READONLY  */
  YYSYMBOL_EXPIRE = 28,                    /* EXPIRE  */
  YYSYMBOL_NULLV = 29,                     /* NULLV  */
  YYSYMBOL_XDBG = 30,                      /* XDBG  */
  YYSYMBOL_XLOG = 31,                      /* XLOG  */
  YYSYMBOL_XLOG_BUF_SIZE = 32,             /* XLOG_BUF_SIZE  */
  YYSYMBOL_XLOG_FORCE_COLOR = 33,          /* XLOG_FORCE_COLOR  */
  YYSYMBOL_XLOG_PRINT_LEVEL = 34,          /* XLOG_PRINT_LEVEL  */
  YYSYMBOL_XLOG_LEVEL = 35,                /* XLOG_LEVEL  */
  YYSYMBOL_PV_PRINT_BUF_SIZE = 36,         /* PV_PRINT_BUF_SIZE  */
  YYSYMBOL_DEBUG_MODE = 37,                /* DEBUG_MODE  */
  YYSYMBOL_ENABLE_ASSERTS = 38,            /* ENABLE_ASSERTS  */
  YYSYMBOL_ABORT_ON_ASSERT = 39,           /* ABORT_ON_ASSERT  */
  YYSYMBOL_LOGLEVEL = 40,                  /* LOGLEVEL  */
  YYSYMBOL_LOGPREFIX = 41,                 /* LOGPREFIX  */
  YYSYMBOL_LOGSTDOUT = 42,                 /* LOGSTDOUT  */
  YYSYMBOL_LOGSTDERROR = 43,               /* LOGSTDERROR  */
  YYSYMBOL_STDERROR_ENABLED = 44,          /* STDERROR_ENABLED  */
  YYSYMBOL_SYSLOG_ENABLED = 45,            /* SYSLOG_ENABLED  */
  YYSYMBOL_LOG_EVENT_ENABLED = 46,         /* LOG_EVENT_ENABLED  */
  YYSYMBOL_STDERROR_LEVEL_FILTER = 47,     /* STDERROR_LEVEL_FILTER  */
  YYSYMBOL_SYSLOG_LEVEL_FILTER = 48,       /* SYSLOG_LEVEL_FILTER  */
  YYSYMBOL_STDERROR_FORMAT = 49,           /* STDERROR_FORMAT  */
  YYSYMBOL_SYSLOG_FORMAT = 50,             /* SYSLOG_FORMAT  */
  YYSYMBOL_LOG_JSON_BUF_SIZE = 51,         /* LOG_JSON_BUF_SIZE  */
  YYSYMBOL_LOG_MSG_BUF_SIZE = 52,          /* LOG_MSG_BUF_SIZE  */
  YYSYMBOL_LOGFACILITY = 53,               /* LOGFACILITY  */
  YYSYMBOL_SYSLOG_FACILITY = 54,           /* SYSLOG_FACILITY  */
  YYSYMBOL_LOGNAME = 55,                   /* LOGNAME  */
  YYSYMBOL_SYSLOG_NAME = 56,               /* SYSLOG_NAME  */
  YYSYMBOL_AVP_ALIASES = 57,               /* AVP_ALIASES  */
  YYSYMBOL_LISTEN = 58,                    /* LISTEN  */
  YYSYMBOL_SOCKET = 59,                    /* SOCKET  */
  YYSYMBOL_MEMGROUP = 60,                  /* MEMGROUP  */
  YYSYMBOL_ALIAS = 61,                     /* ALIAS  */
  YYSYMBOL_AUTO_ALIASES = 62,              /* AUTO_ALIASES  */
  YYSYMBOL_TAG = 63,                       /* TAG  */
  YYSYMBOL_DNS = 64,                       /* DNS  */
  YYSYMBOL_REV_DNS = 65,                   /* REV_DNS  */
  YYSYMBOL_DNS_TRY_IPV6 = 66,              /* DNS_TRY_IPV6  */
  YYSYMBOL_DNS_TRY_NAPTR = 67,             /* DNS_TRY_NAPTR  */
  YYSYMBOL_DNS_RETR_TIME = 68,             /* DNS_RETR_TIME  */
  YYSYMBOL_DNS_RETR_NO = 69,               /* DNS_RETR_NO  */
  YYSYMBOL_DNS_SERVERS_NO = 70,            /* DNS_SERVERS_NO  */
  YYSYMBOL_DNS_USE_SEARCH = 71,            /* DNS_USE_SEARCH  */
  YYSYMBOL_MAX_WHILE_LOOPS = 72,           /* MAX_WHILE_LOOPS  */
  YYSYMBOL_UDP_WORKERS = 73,               /* UDP_WORKERS  */
  YYSYMBOL_CHECK_VIA = 74,                 /* CHECK_VIA  */
  YYSYMBOL_SHM_HASH_SPLIT_PERCENTAGE = 75, /* SHM_HASH_SPLIT_PERCENTAGE  */
  YYSYMBOL_SHM_SECONDARY_HASH_SIZE = 76,   /* SHM_SECONDARY_HASH_SIZE  */
  YYSYMBOL_MEM_WARMING_ENABLED = 77,       /* MEM_WARMING_ENABLED  */
  YYSYMBOL_MEM_WARMING_PATTERN_FILE = 78,  /* MEM_WARMING_PATTERN_FILE  */
  YYSYMBOL_MEM_WARMING_PERCENTAGE = 79,    /* MEM_WARMING_PERCENTAGE  */
  YYSYMBOL_RPM_MEM_FILE = 80,              /* RPM_MEM_FILE  */
  YYSYMBOL_RPM_MEM_SIZE = 81,              /* RPM_MEM_SIZE  */
  YYSYMBOL_MEMLOG = 82,                    /* MEMLOG  */
  YYSYMBOL_MEMDUMP = 83,                   /* MEMDUMP  */
  YYSYMBOL_SHM_MEMLOG_SIZE = 84,           /* SHM_MEMLOG_SIZE  */
  YYSYMBOL_EXECMSGTHRESHOLD = 85,          /* EXECMSGTHRESHOLD  */
  YYSYMBOL_EXECDNSTHRESHOLD = 86,          /* EXECDNSTHRESHOLD  */
  YYSYMBOL_TCPTHRESHOLD = 87,              /* TCPTHRESHOLD  */
  YYSYMBOL_EVENT_SHM_THRESHOLD = 88,       /* EVENT_SHM_THRESHOLD  */
  YYSYMBOL_EVENT_PKG_THRESHOLD = 89,       /* EVENT_PKG_THRESHOLD  */
  YYSYMBOL_QUERYBUFFERSIZE = 90,           /* QUERYBUFFERSIZE  */
  YYSYMBOL_QUERYFLUSHTIME = 91,            /* QUERYFLUSHTIME  */
  YYSYMBOL_SIP_WARNING = 92,               /* SIP_WARNING  */
  YYSYMBOL_SERVER_SIGNATURE = 93,          /* SERVER_SIGNATURE  */
  YYSYMBOL_SERVER_HEADER = 94,             /* SERVER_HEADER  */
  YYSYMBOL_USER_AGENT_HEADER = 95,         /* USER_AGENT_HEADER  */
  YYSYMBOL_LOADMODULE = 96,                /* LOADMODULE  */
  YYSYMBOL_MPATH = 97,                     /* MPATH  */
  YYSYMBOL_MODPARAM = 98,                  /* MODPARAM  */
  YYSYMBOL_MAXBUFFER = 99,                 /* MAXBUFFER  */
  YYSYMBOL_CHROOT = 100,                   /* CHROOT  */
  YYSYMBOL_WDIR = 101,                     /* WDIR  */
  YYSYMBOL_MHOMED = 102,                   /* MHOMED  */
  YYSYMBOL_POLL_METHOD = 103,              /* POLL_METHOD  */
  YYSYMBOL_TCP_ACCEPT_ALIASES = 104,       /* TCP_ACCEPT_ALIASES  */
  YYSYMBOL_TCP_WORKERS = 105,              /* TCP_WORKERS  */
  YYSYMBOL_TCP_CONNECT_TIMEOUT = 106,      /* TCP_CONNECT_TIMEOUT  */
  YYSYMBOL_TCP_CON_LIFETIME = 107,         /* TCP_CON_LIFETIME  */
  YYSYMBOL_TCP_SOCKET_BACKLOG = 108,       /* TCP_SOCKET_BACKLOG  */
  YYSYMBOL_TCP_MAX_CONNECTIONS = 109,      /* TCP_MAX_CONNECTIONS  */
  YYSYMBOL_TCP_NO_NEW_CONN_BFLAG = 110,    /* TCP_NO_NEW_CONN_BFLAG  */
  YYSYMBOL_TCP_NO_NEW_CONN_RPLFLAG = 111,  /* TCP_NO_NEW_CONN_RPLFLAG  */
  YYSYMBOL_TCP_KEEPALIVE = 112,            /* TCP_KEEPALIVE  */
  YYSYMBOL_TCP_KEEPCOUNT = 113,            /* TCP_KEEPCOUNT  */
  YYSYMBOL_TCP_KEEPIDLE = 114,             /* TCP_KEEPIDLE  */
  YYSYMBOL_TCP_KEEPINTERVAL = 115,         /* TCP_KEEPINTERVAL  */
  YYSYMBOL_TCP_MAX_MSG_TIME = 116,         /* TCP_MAX_MSG_TIME  */
  YYSYMBOL_TCP_PARALLEL_READ_ON_WORKERS = 117, /* TCP_PARALLEL_READ_ON_WORKERS  */
  YYSYMBOL_ADVERTISED_ADDRESS = 118,       /* ADVERTISED_ADDRESS  */
  YYSYMBOL_ADVERTISED_PORT = 119,          /* ADVERTISED_PORT  */
  YYSYMBOL_DISABLE_CORE = 120,             /* DISABLE_CORE  */
  YYSYMBOL_OPEN_FD_LIMIT = 121,            /* OPEN_FD_LIMIT  */
  YYSYMBOL_MCAST_LOOPBACK = 122,           /* MCAST_LOOPBACK  */
  YYSYMBOL_MCAST_TTL = 123,                /* MCAST_TTL  */
  YYSYMBOL_TOS = 124,                      /* TOS  */
  YYSYMBOL_DISABLE_DNS_FAILOVER = 125,     /* DISABLE_DNS_FAILOVER  */
  YYSYMBOL_DISABLE_DNS_BLACKLIST = 126,    /* DISABLE_DNS_BLACKLIST  */
  YYSYMBOL_DST_BLACKLIST = 127,            /* DST_BLACKLIST  */
  YYSYMBOL_DISABLE_STATELESS_FWD = 128,    /* DISABLE_STATELESS_FWD  */
  YYSYMBOL_DB_VERSION_TABLE = 129,         /* DB_VERSION_TABLE  */
  YYSYMBOL_DB_DEFAULT_URL = 130,           /* DB_DEFAULT_URL  */
  YYSYMBOL_DB_MAX_ASYNC_CONNECTIONS = 131, /* DB_MAX_ASYNC_CONNECTIONS  */
  YYSYMBOL_DISABLE_503_TRANSLATION = 132,  /* DISABLE_503_TRANSLATION  */
  YYSYMBOL_SYNC_TOKEN = 133,               /* SYNC_TOKEN  */
  YYSYMBOL_ASYNC_TOKEN = 134,              /* ASYNC_TOKEN  */
  YYSYMBOL_LAUNCH_TOKEN = 135,             /* LAUNCH_TOKEN  */
  YYSYMBOL_AUTO_SCALING_PROFILE = 136,     /* AUTO_SCALING_PROFILE  */
  YYSYMBOL_AUTO_SCALING_CYCLE = 137,       /* AUTO_SCALING_CYCLE  */
  YYSYMBOL_TIMER_WORKERS = 138,            /* TIMER_WORKERS  */
  YYSYMBOL_EQUAL = 139,                    /* EQUAL  */
  YYSYMBOL_EQUAL_T = 140,                  /* EQUAL_T  */
  YYSYMBOL_GT = 141,                       /* GT  */
  YYSYMBOL_LT = 142,                       /* LT  */
  YYSYMBOL_GTE = 143,                      /* GTE  */
  YYSYMBOL_LTE = 144,                      /* LTE  */
  YYSYMBOL_DIFF = 145,                     /* DIFF  */
  YYSYMBOL_MATCH = 146,                    /* MATCH  */
  YYSYMBOL_NOTMATCH = 147,                 /* NOTMATCH  */
  YYSYMBOL_COLONEQ = 148,                  /* COLONEQ  */
  YYSYMBOL_PLUSEQ = 149,                   /* PLUSEQ  */
  YYSYMBOL_MINUSEQ = 150,                  /* MINUSEQ  */
  YYSYMBOL_SLASHEQ = 151,                  /* SLASHEQ  */
  YYSYMBOL_MULTEQ = 152,                   /* MULTEQ  */
  YYSYMBOL_MODULOEQ = 153,                 /* MODULOEQ  */
  YYSYMBOL_BANDEQ = 154,                   /* BANDEQ  */
  YYSYMBOL_BOREQ = 155,                    /* BOREQ  */
  YYSYMBOL_BXOREQ = 156,                   /* BXOREQ  */
  YYSYMBOL_OR = 157,                       /* OR  */
  YYSYMBOL_AND = 158,                      /* AND  */
  YYSYMBOL_BOR = 159,                      /* BOR  */
  YYSYMBOL_BAND = 160,                     /* BAND  */
  YYSYMBOL_BXOR = 161,                     /* BXOR  */
  YYSYMBOL_BLSHIFT = 162,                  /* BLSHIFT  */
  YYSYMBOL_BRSHIFT = 163,                  /* BRSHIFT  */
  YYSYMBOL_PLUS = 164,                     /* PLUS  */
  YYSYMBOL_MINUS = 165,                    /* MINUS  */
  YYSYMBOL_MULT = 166,                     /* MULT  */
  YYSYMBOL_MODULO = 167,                   /* MODULO  */
  YYSYMBOL_NOT = 168,                      /* NOT  */
  YYSYMBOL_BNOT = 169,                     /* BNOT  */
  YYSYMBOL_NUMBER = 170,                   /* NUMBER  */
  YYSYMBOL_ZERO = 171,                     /* ZERO  */
  YYSYMBOL_ID = 172,                       /* ID  */
  YYSYMBOL_STRING = 173,                   /* STRING  */
  YYSYMBOL_SCRIPTVAR = 174,                /* SCRIPTVAR  */
  YYSYMBOL_IPV6ADDR = 175,                 /* IPV6ADDR  */
  YYSYMBOL_IPV4ADDR = 176,                 /* IPV4ADDR  */
  YYSYMBOL_IPNET = 177,                    /* IPNET  */
  YYSYMBOL_COMMA = 178,                    /* COMMA  */
  YYSYMBOL_SEMICOLON = 179,                /* SEMICOLON  */
  YYSYMBOL_RPAREN = 180,                   /* RPAREN  */
  YYSYMBOL_LPAREN = 181,                   /* LPAREN  */
  YYSYMBOL_LBRACE = 182,                   /* LBRACE  */
  YYSYMBOL_RBRACE = 183,                   /* RBRACE  */
  YYSYMBOL_LBRACK = 184,                   /* LBRACK  */
  YYSYMBOL_RBRACK = 185,                   /* RBRACK  */
  YYSYMBOL_SLASH = 186,                    /* SLASH  */
  YYSYMBOL_AS = 187,                       /* AS  */
  YYSYMBOL_USE_WORKERS = 188,              /* USE_WORKERS  */
  YYSYMBOL_USE_AUTO_SCALING_PROFILE = 189, /* USE_AUTO_SCALING_PROFILE  */
  YYSYMBOL_MAX = 190,                      /* MAX  */
  YYSYMBOL_MIN = 191,                      /* MIN  */
  YYSYMBOL_DOT = 192,                      /* DOT  */
  YYSYMBOL_CR = 193,                       /* CR  */
  YYSYMBOL_COLON = 194,                    /* COLON  */
  YYSYMBOL_ANY = 195,                      /* ANY  */
  YYSYMBOL_ANYCAST = 196,                  /* ANYCAST  */
  YYSYMBOL_FRAG = 197,                     /* FRAG  */
  YYSYMBOL_REUSE_PORT = 198,               /* REUSE_PORT  */
  YYSYMBOL_SCRIPTVARERR = 199,             /* SCRIPTVARERR  */
  YYSYMBOL_SCALE_UP_TO = 200,              /* SCALE_UP_TO  */
  YYSYMBOL_SCALE_DOWN_TO = 201,            /* SCALE_DOWN_TO  */
  YYSYMBOL_ON = 202,                       /* ON  */
  YYSYMBOL_CYCLES = 203,                   /* CYCLES  */
  YYSYMBOL_CYCLES_WITHIN = 204,            /* CYCLES_WITHIN  */
  YYSYMBOL_PERCENTAGE = 205,               /* PERCENTAGE  */
  YYSYMBOL_YYACCEPT = 206,                 /* $accept  */
  YYSYMBOL_cfg = 207,                      /* cfg  */
  YYSYMBOL_statements = 208,               /* statements  */
  YYSYMBOL_statement = 209,                /* statement  */
  YYSYMBOL_210_1 = 210,                    /* $@1  */
  YYSYMBOL_211_2 = 211,                    /* $@2  */
  YYSYMBOL_212_3 = 212,                    /* $@3  */
  YYSYMBOL_213_4 = 213,                    /* $@4  */
  YYSYMBOL_214_5 = 214,                    /* $@5  */
  YYSYMBOL_215_6 = 215,                    /* $@6  */
  YYSYMBOL_216_7 = 216,                    /* $@7  */
  YYSYMBOL_217_8 = 217,                    /* $@8  */
  YYSYMBOL_218_9 = 218,                    /* $@9  */
  YYSYMBOL_listen_id = 219,                /* listen_id  */
  YYSYMBOL_host_sep = 220,                 /* host_sep  */
  YYSYMBOL_host = 221,                     /* host  */
  YYSYMBOL_proto = 222,                    /* proto  */
  YYSYMBOL_port = 223,                     /* port  */
  YYSYMBOL_snumber = 224,                  /* snumber  */
  YYSYMBOL_phostport = 225,                /* phostport  */
  YYSYMBOL_panyhostport = 226,             /* panyhostport  */
  YYSYMBOL_alias_def = 227,                /* alias_def  */
  YYSYMBOL_id_lst = 228,                   /* id_lst  */
  YYSYMBOL_listen_id_def = 229,            /* listen_id_def  */
  YYSYMBOL_socket_def_param = 230,         /* socket_def_param  */
  YYSYMBOL_socket_def_params = 231,        /* socket_def_params  */
  YYSYMBOL_socket_def = 232,               /* socket_def  */
  YYSYMBOL_233_10 = 233,                   /* $@10  */
  YYSYMBOL_234_11 = 234,                   /* $@11  */
  YYSYMBOL_any_proto = 235,                /* any_proto  */
  YYSYMBOL_multi_string = 236,             /* multi_string  */
  YYSYMBOL_blst_elem = 237,                /* blst_elem  */
  YYSYMBOL_blst_def = 238,                 /* blst_def  */
  YYSYMBOL_blst_flag = 239,                /* blst_flag  */
  YYSYMBOL_blst_flags = 240,               /* blst_flags  */
  YYSYMBOL_blst_elem_list = 241,           /* blst_elem_list  */
  YYSYMBOL_auto_scale_profile_def = 242,   /* auto_scale_profile_def  */
  YYSYMBOL_assign_stm = 243,               /* assign_stm  */
  YYSYMBOL_module_stm = 244,               /* module_stm  */
  YYSYMBOL_ip = 245,                       /* ip  */
  YYSYMBOL_ipv4 = 246,                     /* ipv4  */
  YYSYMBOL_ipv6addr = 247,                 /* ipv6addr  */
  YYSYMBOL_ipv6 = 248,                     /* ipv6  */
  YYSYMBOL_ipnet = 249,                    /* ipnet  */
  YYSYMBOL_folded_string = 250,            /* folded_string  */
  YYSYMBOL_route_name = 251,               /* route_name  */
  YYSYMBOL_route_name_var = 252,           /* route_name_var  */
  YYSYMBOL_route_stm = 253,                /* route_stm  */
  YYSYMBOL_failure_route_stm = 254,        /* failure_route_stm  */
  YYSYMBOL_onreply_route_stm = 255,        /* onreply_route_stm  */
  YYSYMBOL_branch_route_stm = 256,         /* branch_route_stm  */
  YYSYMBOL_error_route_stm = 257,          /* error_route_stm  */
  YYSYMBOL_local_route_stm = 258,          /* local_route_stm  */
  YYSYMBOL_startup_route_stm = 259,        /* startup_route_stm  */
  YYSYMBOL_timer_route_stm = 260,          /* timer_route_stm  */
  YYSYMBOL_event_route_stm = 261,          /* event_route_stm  */
  YYSYMBOL_exp = 262,                      /* exp  */
  YYSYMBOL_equalop = 263,                  /* equalop  */
  YYSYMBOL_compop = 264,                   /* compop  */
  YYSYMBOL_matchop = 265,                  /* matchop  */
  YYSYMBOL_intop = 266,                    /* intop  */
  YYSYMBOL_strop = 267,                    /* strop  */
  YYSYMBOL_script_var = 268,               /* script_var  */
  YYSYMBOL_exp_elem = 269,                 /* exp_elem  */
  YYSYMBOL_exp_cond = 270,                 /* exp_cond  */
  YYSYMBOL_assignop = 271,                 /* assignop  */
  YYSYMBOL_assignexp = 272,                /* assignexp  */
  YYSYMBOL_assign_cmd = 273,               /* assign_cmd  */
  YYSYMBOL_exp_stm = 274,                  /* exp_stm  */
  YYSYMBOL_brk_stm = 275,                  /* brk_stm  */
  YYSYMBOL_stm = 276,                      /* stm  */
  YYSYMBOL_actions = 277,                  /* actions  */
  YYSYMBOL_brk_actions = 278,              /* brk_actions  */
  YYSYMBOL_action = 279,                   /* action  */
  YYSYMBOL_brk_action = 280,               /* brk_action  */
  YYSYMBOL_brk_if_cmd = 281,               /* brk_if_cmd  */
  YYSYMBOL_if_cmd = 282,                   /* if_cmd  */
  YYSYMBOL_while_cmd = 283,                /* while_cmd  */
  YYSYMBOL_foreach_cmd = 284,              /* foreach_cmd  */
  YYSYMBOL_switch_cmd = 285,               /* switch_cmd  */
  YYSYMBOL_switch_stm = 286,               /* switch_stm  */
  YYSYMBOL_case_stms = 287,                /* case_stms  */
  YYSYMBOL_case_stm = 288,                 /* case_stm  */
  YYSYMBOL_default_stm = 289,              /* default_stm  */
  YYSYMBOL_func_param = 290,               /* func_param  */
  YYSYMBOL_route_param = 291,              /* route_param  */
  YYSYMBOL_async_func = 292,               /* async_func  */
  YYSYMBOL_cmd = 293                       /* cmd  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  232
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2283

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  206
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  88
/* YYNRULES -- Number of rules.  */
#define YYNRULES  517
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  986

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   460


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   499,   499,   502,   503,   504,   507,   508,   509,   509,
     510,   510,   511,   511,   512,   512,   513,   513,   514,   514,
     515,   515,   516,   516,   517,   517,   519,   522,   537,   546,
     561,   562,   565,   566,   580,   585,   595,   596,   599,   600,
     601,   605,   607,   609,   614,   620,   622,   626,   628,   630,
     632,   636,   639,   640,   643,   645,   647,   653,   656,   659,
     662,   665,   668,   671,   676,   677,   680,   681,   682,   682,
     687,   687,   694,   695,   697,   698,   701,   709,   718,   724,
     731,   737,   744,   750,   757,   763,   770,   776,   785,   786,
     787,   790,   791,   792,   795,   796,   799,   800,   801,   805,
     813,   821,   827,   835,   839,   851,   852,   853,   854,   855,
     856,   871,   873,   876,   877,   898,   899,   910,   911,   922,
     923,   932,   933,   939,   940,   946,   947,   967,   987,   995,
     996,  1004,  1005,  1012,  1013,  1019,  1020,  1023,  1024,  1025,
    1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,
    1036,  1037,  1038,  1039,  1040,  1041,  1042,  1043,  1044,  1045,
    1046,  1047,  1051,  1052,  1055,  1059,  1060,  1061,  1069,  1077,
    1085,  1093,  1101,  1109,  1117,  1125,  1133,  1141,  1144,  1145,
    1148,  1149,  1150,  1151,  1152,  1153,  1154,  1155,  1156,  1157,
    1158,  1159,  1160,  1161,  1171,  1172,  1186,  1187,  1188,  1189,
    1190,  1191,  1192,  1193,  1194,  1195,  1196,  1197,  1198,  1199,
    1200,  1201,  1211,  1221,  1222,  1227,  1228,  1231,  1235,  1236,
    1241,  1242,  1245,  1246,  1249,  1250,  1253,  1254,  1261,  1262,
    1269,  1271,  1274,  1275,  1278,  1279,  1282,  1285,  1292,  1293,
    1300,  1301,  1308,  1309,  1311,  1312,  1316,  1317,  1320,  1321,
    1323,  1324,  1326,  1328,  1330,  1331,  1332,  1333,  1335,  1336,
    1343,  1346,  1354,  1357,  1401,  1402,  1407,  1409,  1411,  1412,
    1418,  1420,  1434,  1436,  1439,  1440,  1443,  1444,  1451,  1452,
    1459,  1460,  1464,  1492,  1493,  1495,  1496,  1499,  1500,  1503,
    1504,  1514,  1524,  1526,  1528,  1529,  1531,  1532,  1534,  1537,
    1539,  1542,  1543,  1546,  1548,  1551,  1554,  1558,  1559,  1565,
    1571,  1577,  1581,  1582,  1585,  1601,  1617,  1618,  1621,  1627,
    1637,  1647,  1658,  1661,  1670,  1675,  1698,  1703,  1711,  1727,
    1730,  1736,  1739,  1747,  1753,  1756,  1762,  1765,  1773,  1776,
    1784,  1787,  1795,  1798,  1811,  1814,  1820,  1825,  1826,  1827,
    1828,  1829,  1830,  1833,  1834,  1837,  1838,  1839,  1840,  1842,
    1843,  1846,  1847,  1850,  1851,  1852,  1855,  1871,  1876,  1877,
    1878,  1880,  1885,  1888,  1891,  1894,  1897,  1903,  1904,  1905,
    1906,  1907,  1908,  1909,  1910,  1911,  1912,  1916,  1917,  1918,
    1919,  1920,  1921,  1924,  1927,  1930,  1933,  1936,  1939,  1942,
    1945,  1948,  1951,  1954,  1957,  1970,  1983,  2005,  2006,  2007,
    2008,  2009,  2012,  2013,  2014,  2017,  2018,  2019,  2022,  2023,
    2024,  2028,  2029,  2030,  2033,  2034,  2035,  2036,  2037,  2038,
    2039,  2040,  2043,  2044,  2045,  2046,  2047,  2048,  2049,  2050,
    2051,  2054,  2062,  2072,  2080,  2090,  2098,  2116,  2125,  2126,
    2128,  2129,  2132,  2138,  2144,  2150,  2158,  2161,  2164,  2169,
    2179,  2186,  2193,  2203,  2208,  2215,  2225,  2230,  2237,  2249,
    2254,  2259,  2264,  2269,  2279,  2289,  2299,  2311,  2329,  2360,
    2364,  2370,  2373,  2374,  2375,  2376,  2377,  2379,  2381,  2383,
    2385,  2387,  2388,  2391,  2397,  2398,  2400,  2406,  2407,  2409,
    2413,  2432,  2433,  2435,  2458,  2494,  2496,  2499,  2501,  2503,
    2505,  2507,  2509,  2511,  2518,  2525,  2532,  2539
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "DROP", "ASSERT",
  "EXIT", "RETURN", "LOG_TOK", "ERROR", "ROUTE", "ROUTE_FAILURE",
  "ROUTE_ONREPLY", "ROUTE_BRANCH", "ROUTE_ERROR", "ROUTE_LOCAL",
  "ROUTE_STARTUP", "ROUTE_TIMER", "ROUTE_EVENT", "IF", "ELSE", "SWITCH",
  "CASE", "DEFAULT", "BREAK", "WHILE", "FOR", "IN", "READONLY", "EXPIRE",
  "NULLV", "XDBG", "XLOG", "XLOG_BUF_SIZE", "XLOG_FORCE_COLOR",
  "XLOG_PRINT_LEVEL", "XLOG_LEVEL", "PV_PRINT_BUF_SIZE", "DEBUG_MODE",
  "ENABLE_ASSERTS", "ABORT_ON_ASSERT", "LOGLEVEL", "LOGPREFIX",
  "LOGSTDOUT", "LOGSTDERROR", "STDERROR_ENABLED", "SYSLOG_ENABLED",
  "LOG_EVENT_ENABLED", "STDERROR_LEVEL_FILTER", "SYSLOG_LEVEL_FILTER",
  "STDERROR_FORMAT", "SYSLOG_FORMAT", "LOG_JSON_BUF_SIZE",
  "LOG_MSG_BUF_SIZE", "LOGFACILITY", "SYSLOG_FACILITY", "LOGNAME",
  "SYSLOG_NAME", "AVP_ALIASES", "LISTEN", "SOCKET", "MEMGROUP", "ALIAS",
  "AUTO_ALIASES", "TAG", "DNS", "REV_DNS", "DNS_TRY_IPV6", "DNS_TRY_NAPTR",
  "DNS_RETR_TIME", "DNS_RETR_NO", "DNS_SERVERS_NO", "DNS_USE_SEARCH",
  "MAX_WHILE_LOOPS", "UDP_WORKERS", "CHECK_VIA",
  "SHM_HASH_SPLIT_PERCENTAGE", "SHM_SECONDARY_HASH_SIZE",
  "MEM_WARMING_ENABLED", "MEM_WARMING_PATTERN_FILE",
  "MEM_WARMING_PERCENTAGE", "RPM_MEM_FILE", "RPM_MEM_SIZE", "MEMLOG",
  "MEMDUMP", "SHM_MEMLOG_SIZE", "EXECMSGTHRESHOLD", "EXECDNSTHRESHOLD",
  "TCPTHRESHOLD", "EVENT_SHM_THRESHOLD", "EVENT_PKG_THRESHOLD",
  "QUERYBUFFERSIZE", "QUERYFLUSHTIME", "SIP_WARNING", "SERVER_SIGNATURE",
  "SERVER_HEADER", "USER_AGENT_HEADER", "LOADMODULE", "MPATH", "MODPARAM",
  "MAXBUFFER", "CHROOT", "WDIR", "MHOMED", "POLL_METHOD",
  "TCP_ACCEPT_ALIASES", "TCP_WORKERS", "TCP_CONNECT_TIMEOUT",
  "TCP_CON_LIFETIME", "TCP_SOCKET_BACKLOG", "TCP_MAX_CONNECTIONS",
  "TCP_NO_NEW_CONN_BFLAG", "TCP_NO_NEW_CONN_RPLFLAG", "TCP_KEEPALIVE",
  "TCP_KEEPCOUNT", "TCP_KEEPIDLE", "TCP_KEEPINTERVAL", "TCP_MAX_MSG_TIME",
  "TCP_PARALLEL_READ_ON_WORKERS", "ADVERTISED_ADDRESS", "ADVERTISED_PORT",
  "DISABLE_CORE", "OPEN_FD_LIMIT", "MCAST_LOOPBACK", "MCAST_TTL", "TOS",
  "DISABLE_DNS_FAILOVER", "DISABLE_DNS_BLACKLIST", "DST_BLACKLIST",
  "DISABLE_STATELESS_FWD", "DB_VERSION_TABLE", "DB_DEFAULT_URL",
  "DB_MAX_ASYNC_CONNECTIONS", "DISABLE_503_TRANSLATION", "SYNC_TOKEN",
  "ASYNC_TOKEN", "LAUNCH_TOKEN", "AUTO_SCALING_PROFILE",
  "AUTO_SCALING_CYCLE", "TIMER_WORKERS", "EQUAL", "EQUAL_T", "GT", "LT",
  "GTE", "LTE", "DIFF", "MATCH", "NOTMATCH", "COLONEQ", "PLUSEQ",
  "MINUSEQ", "SLASHEQ", "MULTEQ", "MODULOEQ", "BANDEQ", "BOREQ", "BXOREQ",
  "OR", "AND", "BOR", "BAND", "BXOR", "BLSHIFT", "BRSHIFT", "PLUS",
  "MINUS", "MULT", "MODULO", "NOT", "BNOT", "NUMBER", "ZERO", "ID",
  "STRING", "SCRIPTVAR", "IPV6ADDR", "IPV4ADDR", "IPNET", "COMMA",
  "SEMICOLON", "RPAREN", "LPAREN", "LBRACE", "RBRACE", "LBRACK", "RBRACK",
  "SLASH", "AS", "USE_WORKERS", "USE_AUTO_SCALING_PROFILE", "MAX", "MIN",
  "DOT", "CR", "COLON", "ANY", "ANYCAST", "FRAG", "REUSE_PORT",
  "SCRIPTVARERR", "SCALE_UP_TO", "SCALE_DOWN_TO", "ON", "CYCLES",
  "CYCLES_WITHIN", "PERCENTAGE", "$accept", "cfg", "statements",
  "statement", "$@1", "$@2", "$@3", "$@4", "$@5", "$@6", "$@7", "$@8",
  "$@9", "listen_id", "host_sep", "host", "proto", "port", "snumber",
  "phostport", "panyhostport", "alias_def", "id_lst", "listen_id_def",
  "socket_def_param", "socket_def_params", "socket_def", "$@10", "$@11",
  "any_proto", "multi_string", "blst_elem", "blst_def", "blst_flag",
  "blst_flags", "blst_elem_list", "auto_scale_profile_def", "assign_stm",
  "module_stm", "ip", "ipv4", "ipv6addr", "ipv6", "ipnet", "folded_string",
  "route_name", "route_name_var", "route_stm", "failure_route_stm",
  "onreply_route_stm", "branch_route_stm", "error_route_stm",
  "local_route_stm", "startup_route_stm", "timer_route_stm",
  "event_route_stm", "exp", "equalop", "compop", "matchop", "intop",
  "strop", "script_var", "exp_elem", "exp_cond", "assignop", "assignexp",
  "assign_cmd", "exp_stm", "brk_stm", "stm", "actions", "brk_actions",
  "action", "brk_action", "brk_if_cmd", "if_cmd", "while_cmd",
  "foreach_cmd", "switch_cmd", "switch_stm", "case_stms", "case_stm",
  "default_stm", "func_param", "route_param", "async_func", "cmd", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460
};
#endif

#define YYPACT_NINF (-837)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-457)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    2090,   -80,   -70,   -65,   -60,   -56,   -36,   -17,    11,    86,
     212,   242,   275,   283,   286,   294,   297,   302,   303,   319,
     324,   329,   343,   357,   374,   451,   473,   477,   514,   545,
     562,   566,   570,   582,   342,   354,   364,   414,   415,   417,
     592,   614,   617,   634,   635,   655,   659,   661,   666,   667,
     685,   701,   703,   716,   717,   726,   727,   731,   733,   739,
     743,   747,   758,   768,    26,   769,    56,   775,   787,   788,
     793,   804,   809,   819,   825,   834,   839,   845,   852,   856,
     868,   870,   872,   873,   875,   883,   884,   886,   888,   889,
     890,   895,   896,   418,   419,   902,   906,   909,   910,   913,
     914,   926,   929,   930,  -837,   202,  1928,  -837,   326,   535,
     341,   627,   663,   748,   641,   752,   755,  -837,  -837,  -837,
     178,   296,   346,   196,   352,   362,   366,   367,   -26,   104,
     390,   398,   409,   410,   436,   379,   402,   782,   882,   437,
     438,    34,   136,   107,   111,    63,   151,   897,    90,   439,
     443,   444,  -837,   648,  -837,   722,  -837,   746,  -837,   772,
    -837,   807,  -837,   904,   445,   463,   470,   472,   482,   487,
     113,   488,   120,   489,   406,   427,   429,   494,   498,   499,
     500,   501,   504,   513,   517,   518,   123,   128,  -837,  -837,
     133,  -837,   899,   528,   127,   142,   534,   144,   537,   546,
     547,   560,   576,   594,   152,   155,   595,   620,   621,   622,
     623,   629,   103,   633,   643,   678,   679,   680,   170,  -837,
     915,  -837,   917,   907,   919,   139,   145,   689,   698,   156,
     699,   924,  -837,   -80,  -837,     7,  -837,    23,  -837,    64,
    -837,    42,  -837,    45,  -837,    46,  -837,    54,  -837,    70,
    -837,    74,  -837,  -837,  -837,  -837,  -837,  -837,  -837,  -837,
     928,   931,  -837,  -837,  -837,  -837,  -837,  -837,  -837,  -837,
    -837,  -837,  -837,  -837,  -837,  -837,  -837,  -837,  -837,  -837,
    -837,  -837,  -837,  -837,  -837,  -837,  -837,  -837,  -837,  -837,
    -837,  -837,  -837,  -837,  -837,  -837,  -837,  -837,  -837,  -837,
    -837,  -837,  -837,  -837,   951,  -837,   892,   692,   707,  -837,
    -837,  -837,   918,  -837,   920,  -837,  -837,  -837,   901,   922,
    -837,   -98,   927,  -837,   967,  -837,  -837,  -837,  -837,  -837,
    -837,  -837,  -837,  -837,  -837,  -837,  -837,  -837,  -837,  -837,
    -837,  -837,  -837,  -837,  -837,   921,  -837,  -837,  -837,  -837,
    -837,  -837,  -837,  -837,  -837,  -837,  -837,  -837,  -837,  -837,
    -837,  -837,  -837,  -837,  -837,  -837,  -837,  -837,  -837,  -837,
    -837,  -837,  -837,  -837,  -837,  -837,  -837,  -837,  -837,  -837,
    -837,  -837,  -837,  -837,  -837,  -837,  -837,  -837,  -837,  -837,
    -837,  -837,   933,  -837,  -837,  -837,  -837,  -837,  -837,  -837,
    -837,  -837,  -837,  -837,  -837,  -837,  -837,  -837,  -837,   936,
    -837,  -837,  -837,  -837,  -837,  -837,  -837,  -837,  -837,  -837,
    -837,  -837,  -837,  -837,  -837,  -837,  -837,  -837,  -837,  -837,
    -837,  -837,  -837,  -837,  -837,  -837,  -837,  -837,  -837,  -837,
    -837,  -837,  -837,  -837,  -837,  -837,  -837,  -837,  -837,  -837,
    -837,  -837,   176,  -837,  -837,  -837,  -837,  -837,  -837,  -837,
    -837,  -837,  -837,   932,  -837,  -837,  -837,   937,  -837,  1753,
     691,  -837,   691,  -837,  1753,   691,  -837,   691,  -837,  1753,
    -837,  1753,  -837,  1753,  -837,   691,  -837,   691,  -837,  -837,
    -837,   585,   741,   741,   146,   935,   891,  -837,   160,   941,
     891,  -837,   946,   949,   955,   713,   953,  -837,   939,   956,
     950,   952,   957,   645,    83,    88,    92,   963,   968,   978,
     979,   982,   983,   984,   985,   100,  -837,  -837,  -837,  1712,
     969,   719,  -837,  -837,  -837,  -837,  -837,     6,  -837,  -837,
    -837,   986,   987,   777,   990,   991,   827,   916,   962,   992,
     993,   974,   988,  1005,   891,  1011,  1018,  -837,  -837,  -837,
     741,  -837,  -837,  -837,  1010,  -837,  -837,   995,  -837,  -837,
    -837,  1019,  -837,  -837,  -837,  -837,  -837,  -118,   863,   994,
    -837,  1029,  1384,  1030,   568,  -837,  -837,  -837,   125,  -837,
     147,  -837,    39,  1384,   -86,  1384,   -86,  1026,  1039,  1041,
    1041,  -837,     2,  1185,  1186,  -837,  -837,  -837,  -837,  -837,
    -837,  -837,  -837,  1235,  -837,  -837,  -837,  -837,  -837,  -837,
    1034,  1036,  -837,  1038,  1040,  -837,  -837,  -837,  1051,  1044,
     -75,    60,  -837,  1037,  -837,  -837,  -837,  -837,  -837,    61,
     -10,   713,  -837,   662,  -837,   813,  -837,  -837,    10,  -837,
    -837,  1058,  -837,  1384,  1384,  1435,  1235,  -837,   -27,  1767,
    -837,  -837,  -837,  -837,  -837,  -837,  -837,  -837,  1055,  1057,
    1065,  1066,  1069,  1068,  1071,  1070,  -837,   -88,  -837,   -47,
    1080,   -39,  1236,   184,   213,   251,   229,   101,  1083,   300,
    1084,  -837,   736,  -837,  -837,  -837,   556,  -837,  -837,  1235,
    -837,  1235,  -837,  1623,  -837,  1683,  -837,  1753,  1753,  1753,
    1753,  1078,  1753,  -837,  -837,  -837,  -837,  -837,    62,  -837,
    -837,   287,  1087,   289,  -837,   813,  -837,  -837,  -837,  1091,
     567,  -837,  1017,  -837,  1105,  -837,     1,  -837,  1012,  1630,
    1384,  1384,  1103,  -837,  -837,  -837,  -837,  -837,  -837,  -837,
    -837,   700,  -101,  -837,   -26,   -57,  -837,  -837,  -837,  -837,
    1104,  -837,  1106,  -837,   455,  -837,  1573,  1112,  1467,   -86,
    -837,  -837,  -837,  -837,  1113,  -837,  -837,  -837,    30,   691,
     691,  -837,  -837,  -837,  -837,  -837,   780,  -837,  -837,  1640,
    1235,  1235,  1235,  1235,  1235,  1235,  1235,  1235,  1235,  1235,
    1053,  1099,  1149,  1199,  1114,  1250,  -837,  -837,  -837,  -837,
    -837,  1117,   649,   612,   -75,  -837,  -837,  1272,  -837,  -837,
    -837,  -837,  -837,  1119,  -837,  -837,  -837,  -837,  -837,  1120,
    1121,  -837,  -837,  -837,  -837,   705,  1653,  1286,  -837,  1282,
    1125,  1128,  -837,  1520,  1131,  -837,  -837,  -837,  -837,  -837,
    -837,    19,  1132,   505,   530,  1133,  -837,   735,   753,   779,
    -837,  -837,  -837,  -837,   838,   838,   838,   838,   838,  -837,
    -837,  -837,  -837,  -837,  -837,  -837,  -837,  -837,  1753,  -837,
     612,   -75,  -837,   794,  1136,  1141,  -837,  -837,  -837,   462,
    -837,  -837,  1284,  1573,   647,  1134,    85,  -837,  1384,  -837,
    -837,   642,  -837,  -837,  -837,  -837,  1467,  -837,  -837,  -837,
    -837,  1148,  -837,  1146,  -837,  1334,   803,  1140,   -75,  -837,
    -837,   135,  -837,  -837,  -837,  -837,  -837,  -837,  1130,  1135,
    -837,  1137,  -837,  -837,   243,  -837,  -837,  -837,  -837,  1142,
    1145,  -837,   -75,  -837,  -837,   816,  1126,  1156,  1706,  1706,
    1706,  1467,  -837,  -837,   820,  1157,  -837,  1166,  1143,   503,
     580,   688,  1326,  1173,  -837,  1167,  1147,  1180,  1467,  1171,
    -837,  1183,  1153,  -837,  -837,  1189,  1187,  1335,  1194,  1192,
    1338,  1163,  1197,  -837,  1165,  -837
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    26,     0,     0,     4,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     6,     7,   305,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   145,     0,   147,     0,   149,     0,   151,     0,
     153,     0,   155,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   307,   306,
       0,   311,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   287,
       0,   289,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     1,     5,     3,     0,     9,     0,    11,     0,
      13,     0,    15,     0,    17,     0,    19,     0,    21,     0,
      23,     0,    25,   254,   251,   255,   252,   256,   253,   258,
       0,     0,    38,   257,   250,   249,   111,   110,   107,   106,
     109,   108,   103,   105,   104,   113,   112,   115,   114,   117,
     116,   119,   118,   121,   120,   123,   122,   125,   124,   126,
     127,   129,   128,   131,   130,   133,   132,   135,   134,   137,
     136,   139,   138,   262,     0,    35,     0,    67,    66,   261,
     260,   259,     0,   266,    32,    28,   315,   314,     0,     0,
      47,    29,     0,    51,    52,   265,    27,   312,   316,   313,
     268,   267,   141,   140,   143,   142,   144,   146,   148,   150,
     152,   154,   157,   156,   162,   160,   166,   165,   168,   167,
     170,   169,   172,   171,   174,   173,   176,   175,   178,   177,
     180,   179,   182,   181,   186,   185,   184,   183,   188,   187,
     190,   189,   192,   191,   194,   193,   196,   195,   198,   197,
     200,   199,   202,   201,   244,   243,   246,   245,   248,   247,
     285,   284,     0,   159,   158,   205,   204,   203,   208,   207,
     206,   210,   209,   213,   211,   212,   215,   214,   218,   216,
     220,   219,   222,   221,   224,   223,   226,   225,   228,   227,
     230,   229,   232,   231,   238,   237,   240,   239,   242,   241,
     234,   233,   236,   235,   270,    32,   269,   272,   271,   274,
     273,   276,   275,   278,   277,   280,   279,   283,   281,   282,
     286,   288,    90,   292,   294,   293,   296,   295,   298,   297,
     300,   299,   302,     0,   301,   304,   303,   163,   329,     0,
       0,   331,     0,   334,     0,     0,   336,     0,   338,     0,
     340,     0,   342,     0,   344,     0,   346,     0,    39,    40,
      44,     0,     0,     0,     0,     0,     0,    31,     0,     0,
       0,    53,     0,     0,     0,     0,     0,   291,     0,     0,
     482,     0,   484,   491,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   366,   430,   367,     0,
       0,     0,   419,   425,   426,   427,   428,     0,   323,   322,
     324,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    45,    41,     0,     0,     0,     0,    57,    58,    59,
      64,    71,    69,   264,    74,   263,   317,    48,    34,    33,
     161,     0,   217,    93,    91,    92,    95,    90,     0,     0,
     164,     0,     0,     0,     0,   488,   486,   494,     0,   497,
       0,   501,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   506,     0,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,     0,   429,   420,   327,   418,   431,   424,
       0,     0,   332,     0,     0,   337,   339,   341,     0,     0,
       0,     0,    62,    54,    61,    60,    63,    65,    75,     0,
       0,     0,   290,     0,   318,     0,    89,    97,     0,   319,
      86,     0,   483,     0,     0,     0,     0,   370,     0,   371,
     352,   368,   409,   369,   408,   407,   485,   490,     0,     0,
       0,     0,     0,     0,     0,     0,   325,     0,   326,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   458,   460,   503,   463,   466,     0,   405,   406,     0,
     388,     0,   387,   389,   390,   404,   391,     0,     0,     0,
       0,     0,     0,    36,    37,    46,    43,    42,     0,    50,
      49,     0,     0,     0,    94,     0,    87,    72,    73,     0,
       0,    98,     0,    88,     0,   349,     0,   411,     0,     0,
       0,     0,     0,   353,   355,   356,   357,   358,   354,   359,
     360,   361,   362,   365,     0,     0,   489,   487,   495,   492,
       0,   498,     0,   502,     0,   499,     0,     0,     0,     0,
     320,   507,   321,   508,     0,   509,   510,   480,     0,     0,
       0,   517,   505,   461,   464,   467,   462,   504,   402,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    56,    55,   308,   310,
     309,     0,     0,     0,     0,    84,    96,     0,   350,   410,
     351,   348,   347,     0,   375,   376,   374,   373,   372,     0,
       0,   471,   469,   470,   472,     0,     0,   443,   415,     0,
       0,     0,   439,     0,     0,   445,   412,   434,   435,   436,
     437,     0,     0,     0,     0,     0,   477,     0,     0,     0,
     459,   465,   468,   403,   398,   397,   399,   400,   401,   392,
     393,   394,   396,   395,   328,   330,   333,   335,     0,   345,
       0,     0,    85,     0,     0,     0,   481,   493,   496,     0,
     500,   417,     0,     0,     0,     0,   449,   451,     0,   432,
     414,     0,   422,   438,   440,   433,     0,   511,   512,   479,
     478,     0,   513,     0,   516,     0,     0,     0,     0,    80,
      82,     0,   476,   473,   474,   475,   416,   444,     0,     0,
     447,     0,   450,   448,     0,   423,   413,   421,   446,     0,
       0,   343,     0,    81,    83,     0,   102,     0,   455,   453,
     457,     0,   514,   515,     0,     0,    78,     0,   101,     0,
       0,     0,   441,     0,    79,     0,     0,     0,     0,     0,
      76,     0,     0,   442,    77,     0,     0,     0,     0,     0,
       0,     0,     0,   100,     0,    99
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -837,  -837,  -837,  1266,  -837,  -837,  -837,  -837,  -837,  -837,
    -837,  -837,  -837,  -208,  -837,  -837,  -147,  -609,  -123,   -90,
    -837,  -837,  1050,  -837,  -837,  -425,  1229,  -837,  -837,   651,
     815,   654,   800,   740,  -837,  -837,  -837,  -837,  -837,  -146,
    -837,  1062,  -837,  -589,  -513,  -443,  -837,  -837,  -837,  -837,
    -837,  -837,  -837,  -837,  -837,  -837,  -554,  -837,  -837,  -837,
    -837,  -837,  -343,  -837,  -567,  -837,   833,  -572,  -837,  -836,
     490,  -465,  -544,  -498,   132,  -837,  -557,  -474,  -409,  -386,
    -837,  -837,   507,  -837,   616,  -837,   795,  -576
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   320,   499,   321,   306,   715,   702,   307,
     308,   324,   325,   634,   560,   561,   309,   493,   492,   729,
     565,   647,   507,   576,   577,   648,   464,   117,   118,   649,
     327,   328,   329,   650,   684,   541,   677,   236,   238,   240,
     242,   244,   246,   248,   250,   252,   658,   751,   752,   753,
     754,   755,   529,   660,   704,   613,   705,   530,   663,   845,
     837,   531,   901,   532,   846,   847,   533,   534,   535,   536,
     895,   896,   897,   933,   696,   835,   688,   537
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     263,   322,   326,   690,   436,   272,   665,   618,   468,   543,
     662,   731,   286,   288,   546,   661,   547,   665,   548,   665,
     904,   662,   717,   662,   471,   664,   661,   188,   661,   542,
     720,   855,   544,   617,   545,   295,   664,   706,   664,   679,
     675,   681,   549,   476,   550,   617,   478,   480,   617,   617,
     617,   363,   365,   367,   726,   482,   730,   191,   323,   119,
     641,   716,   719,   806,   303,   473,   326,   497,   562,   120,
     938,   484,  -364,  -364,   121,   486,   506,   665,   665,   122,
     706,   662,   662,   123,   587,   686,   661,   661,   526,   589,
     764,   313,   765,   591,   498,   713,   664,   664,  -364,   735,
     736,   601,   777,   124,   434,   273,   894,   931,   299,   807,
     740,   741,   301,   528,   354,   962,   827,   526,   740,   741,
     714,   358,   125,   706,   386,   706,   670,   723,   395,   388,
     740,   741,   973,   766,   390,   637,   812,   297,   260,   261,
     454,   768,   528,   398,   262,   403,   456,   563,   673,   676,
     126,   742,   310,   418,   260,   261,   420,   462,   740,   741,
     262,   568,   825,   721,   665,   665,   260,   261,   662,   662,
     586,   447,   262,   661,   661,   691,   526,   322,   326,   253,
     692,   818,   693,   664,   664,   619,   821,   822,   732,   469,
     738,   470,   851,   733,   260,   261,   844,   259,   905,   189,
     262,   528,   232,   691,   526,   884,   296,   472,   692,   538,
     856,   539,   540,   526,   706,   706,   706,   706,   706,   706,
     706,   706,   706,   706,   883,   127,   477,   479,   481,   528,
     713,   713,   713,   304,   323,   305,   483,   192,   528,   659,
     617,   669,   800,   801,   802,   803,   474,   805,   475,   678,
     659,   680,   659,   682,   485,   714,   714,   714,   487,   695,
     304,   854,   314,   315,   588,   316,   317,   851,   838,   590,
     703,   844,   917,   592,   318,   435,   315,   274,   316,   317,
     300,   602,   778,   552,   302,   319,   355,   318,   567,   260,
     261,   916,   552,   359,   848,   262,   387,   255,   671,   396,
     397,   389,   617,   617,   617,   617,   391,   617,   298,   945,
     659,   659,   455,   703,   399,   400,   404,   405,   457,   564,
     674,   304,   665,   305,   419,   851,   662,   421,   463,   844,
     851,   661,   -30,   954,   844,   235,   858,   859,   946,   947,
     448,   664,   449,   152,   934,   326,   633,   257,   254,   785,
     326,   128,   239,   264,   326,   154,   703,   770,   703,   849,
     260,   261,   505,   266,   771,   156,   262,   268,   270,   848,
     506,   892,   851,   851,   851,   851,   844,   844,   844,   844,
     285,   129,   850,   851,   851,   851,   772,   844,   844,   844,
     585,   275,   851,   773,   617,   838,   844,   659,   659,   277,
     740,   741,   772,   287,   959,   960,   961,   362,   326,   776,
     279,   281,   828,   915,   130,   158,   160,   617,   162,   219,
     221,   834,   131,   951,   770,   132,   852,   848,   364,   774,
     366,   775,   848,   133,   849,   695,   134,   283,   291,   293,
     330,   135,   136,   862,   332,   334,   342,   703,   703,   703,
     703,   703,   703,   703,   703,   703,   703,   850,   137,   657,
     770,   668,   772,   138,   344,   672,   256,   808,   139,   810,
     657,   346,   657,   348,   848,   848,   848,   848,   780,   694,
     781,   153,   140,   350,   831,   848,   848,   848,   352,   356,
     360,   922,   849,   155,   848,   368,   141,   849,   728,   370,
     372,   374,   376,   157,   935,   378,   510,   511,   512,   513,
     514,   515,   516,   142,   380,   850,   258,   722,   382,   384,
     850,   840,   265,   518,  -454,  -454,   841,   519,   520,   393,
     657,   657,   267,   521,   522,   401,   269,   271,   406,   849,
     849,   849,   849,   260,   261,   237,   925,   408,   410,   262,
     849,   849,   849,   159,   161,   659,   163,   220,   222,   849,
     276,   412,   850,   850,   850,   850,   260,   261,   278,   784,
     260,   261,   262,   850,   850,   850,   262,   414,   728,   280,
     282,   935,   850,   510,   511,   512,   513,   514,   515,   516,
     143,   260,   261,   260,   261,   416,   422,   262,   840,   262,
     518,  -452,  -452,   841,   519,   520,   284,   292,   294,   331,
     521,   522,   144,   333,   335,   343,   145,   657,   657,   260,
     261,   424,   426,   428,   430,   262,   260,   261,   832,   526,
     432,   826,   262,   345,   437,   923,   526,   523,   524,   241,
     347,   833,   349,   935,   439,   510,   511,   512,   513,   514,
     515,   516,   351,   146,   528,   694,   247,   353,   357,   361,
     840,   528,   518,   861,   369,   841,   519,   520,   371,   373,
     375,   377,   521,   522,   379,   525,   243,   526,   770,   441,
     443,   445,   842,   381,   147,   907,  -454,   383,   385,   935,
     458,   510,   511,   512,   513,   514,   515,   516,   394,   460,
     465,   148,   528,   772,   402,   149,   840,   407,   518,   150,
     908,   841,   519,   520,   523,   524,   409,   411,   521,   522,
     615,   151,   510,   511,   512,   513,   514,   515,   516,   824,
     413,   164,   260,   261,   786,   573,   787,   517,   262,   518,
     574,   575,   526,   519,   520,   814,   415,   815,   667,   521,
     522,   551,   525,   165,   526,   -70,   166,   435,   315,   842,
     316,   317,   245,  -452,   417,   423,   924,   528,   249,   318,
     -68,   929,   251,   167,   168,   657,   523,   524,   615,   528,
     510,   511,   512,   513,   514,   515,   516,   316,   317,   644,
     425,   427,   429,   431,   169,   517,   318,   518,   170,   433,
     171,   519,   520,   438,   553,   172,   173,   521,   522,   260,
     261,   260,   261,   440,   525,   262,   526,   262,   336,   526,
     928,   842,   523,   524,   174,   936,   584,   881,   615,   882,
     510,   511,   512,   513,   514,   515,   516,   316,   317,   644,
     175,   528,   176,   725,   528,   517,   318,   518,   442,   444,
     446,   519,   520,   523,   524,   177,   178,   521,   522,   459,
     525,   538,   526,   539,   540,   179,   180,   842,   461,   466,
     181,  -456,   182,  -363,  -363,   316,   317,   644,   183,   -70,
     -70,   -70,   184,   889,   318,   890,   185,   528,   -70,   -70,
     -70,   525,   337,   526,   -68,   -68,   -68,   186,   527,  -363,
     260,   261,   616,   -68,   -68,   -68,   262,   187,   190,   783,
     526,   523,   524,   786,   193,   910,   338,   615,   528,   510,
     511,   512,   513,   514,   515,   516,   194,   195,   554,   555,
     556,   911,   196,   912,   517,   528,   518,   557,   558,   559,
     519,   520,   339,   197,   260,   261,   521,   522,   198,   525,
     262,   526,   490,   860,   526,   289,   527,   913,   199,   914,
     622,   523,   524,   615,   200,   510,   511,   512,   513,   514,
     515,   516,   918,   201,   919,   902,   528,   340,   202,   528,
     517,   942,   518,   943,   203,   305,   519,   520,   316,   317,
     644,   204,   521,   522,   955,   205,   956,   318,   963,   525,
     964,   526,   795,   796,   797,   798,   527,   206,   727,   207,
     625,   208,   209,   615,   210,   510,   511,   512,   513,   514,
     515,   516,   211,   212,   799,   213,   528,   214,   215,   216,
     517,   643,   518,   937,   217,   218,   519,   520,   316,   317,
     644,   223,   521,   522,   645,   224,   646,   318,   225,   226,
     523,   524,   227,   228,   615,   290,   510,   511,   512,   513,
     514,   515,   516,   435,   315,   229,   316,   317,   230,   231,
     312,   517,   392,   518,   341,   318,   316,   519,   520,   452,
     902,   902,   902,   521,   522,   450,   491,   451,   525,   453,
     526,   937,   937,   937,   467,   527,   523,   524,   488,   626,
     615,   489,   510,   511,   512,   513,   514,   515,   516,   579,
     502,   503,   494,   569,   -35,   528,   496,   517,   570,   518,
     566,   500,   571,   519,   520,   504,   509,   572,   580,   521,
     522,   581,   508,   582,   525,   578,   526,   304,   583,   314,
     315,   527,   316,   317,   593,   627,   523,   524,   614,   594,
     615,   318,   510,   511,   512,   513,   514,   515,   516,   595,
     596,   528,   319,   597,   598,   599,   600,   517,   630,   518,
     628,   620,   621,   519,   520,   623,   624,   632,   629,   521,
     522,   635,   631,   564,   525,   643,   526,   523,   524,   639,
     636,   527,   316,   317,   644,   819,   651,   640,   645,   683,
     615,   318,   510,   511,   512,   513,   514,   515,   516,   652,
     666,   528,   685,   687,   697,   698,   707,   517,   708,   518,
     709,   711,   710,   519,   520,   525,   712,   526,   734,   521,
     522,   718,   527,   523,   524,   756,   874,   757,   510,   511,
     512,   513,   514,   515,   516,   758,   759,   760,   761,   762,
     763,   615,   528,   510,   511,   512,   513,   514,   515,   516,
     767,   779,   769,   804,   782,   521,   522,   809,   517,   813,
     518,   525,   817,   526,   519,   520,   823,   829,   527,   830,
     521,   522,   875,   523,   524,   615,   853,   510,   511,   512,
     513,   514,   515,   516,   839,   880,   878,   885,   528,   886,
     887,   888,   517,   894,   518,   893,   898,   899,   519,   520,
     903,   921,   906,   909,   521,   522,   920,   930,   939,   940,
     944,   525,   952,   526,   948,   953,   958,   957,   527,   949,
     965,   950,   876,   523,   524,   615,   966,   510,   511,   512,
     513,   514,   515,   516,   967,   968,   969,   970,   528,   971,
     972,   974,   517,   975,   518,   976,   977,   978,   519,   520,
     979,   980,   981,   982,   521,   522,   983,   984,   985,   523,
     524,   525,   234,   526,   501,   311,   811,   642,   527,   638,
     495,   724,   877,   927,   523,   524,   816,   510,   511,   512,
     513,   514,   515,   516,   857,   689,     0,     0,   528,   260,
     261,     0,   517,   932,   699,   262,     0,   525,   700,   526,
       0,     0,     0,     0,   521,   522,   701,     0,   523,   524,
       0,     0,   525,     0,   526,     0,     0,     0,     0,   527,
       0,     0,     0,   879,   528,     0,     0,     0,   510,   511,
     512,   513,   514,   515,   516,     0,     0,     0,     0,   528,
       0,     0,     0,   517,     0,   518,   525,     0,   526,   519,
     520,     0,     0,   527,     0,   521,   522,   926,   523,   524,
     510,   511,   512,   513,   514,   515,   516,     0,     0,     0,
       0,     0,     0,   528,     0,   840,     0,   518,     0,   739,
     841,   519,   520,     0,     0,     0,     0,   521,   522,     0,
       0,     0,     0,     0,     0,     0,   525,     0,   526,     0,
       0,     0,     0,   527,     0,     0,     0,   941,   523,   524,
       0,     0,     0,   510,   511,   512,   513,   514,   515,   516,
       0,     0,   788,   528,   789,     0,     0,     0,   840,     0,
     518,     0,     0,   841,   519,   520,     0,     0,   260,   261,
     521,   522,   653,     0,   262,     0,   525,     0,   526,     0,
       0,     0,     0,     0,     0,   654,   655,     0,   656,   523,
     524,     0,     0,     0,     0,     0,   510,   511,   512,   513,
     514,   515,   516,   528,     0,     0,     0,     0,     0,     0,
       0,   517,     0,   518,     0,     0,     0,   519,   520,     0,
       0,   523,   524,   521,   522,     0,     0,   525,     0,   526,
       0,     0,     0,     0,   527,     0,     0,     0,   737,     0,
       0,     0,     0,   864,   865,   866,   867,   868,   869,   870,
     871,   872,   873,     0,   528,     0,     0,     0,     0,   525,
       0,   526,     0,     0,     0,     0,   842,     0,     0,   843,
       0,     0,     0,     0,   523,   524,   510,   511,   512,   513,
     514,   515,   516,     0,     0,     0,   528,     0,     0,     0,
       0,   517,     0,   518,     0,     0,     0,   519,   520,     0,
       0,     0,     0,   521,   522,     0,     0,     0,     0,     0,
       0,     0,   525,     0,   526,     0,     0,     0,     0,   842,
       0,     0,     0,   900,     0,     0,     0,   523,   524,   510,
     511,   512,   513,   514,   515,   516,     0,     0,     0,   528,
       0,     0,     0,     0,   840,     0,   518,     0,     0,   841,
     519,   520,     0,     0,     0,     0,   521,   522,     0,     0,
       0,     0,     0,     0,     0,   525,     0,   526,     0,     0,
       0,     0,   527,     0,     0,   836,   510,   511,   512,   513,
     514,   515,   516,   743,   744,   745,   746,   747,   748,   749,
     750,   517,   528,   518,     0,     0,     0,   519,   520,     0,
       0,     0,     0,   521,   522,     0,     0,   523,   524,   790,
     791,   792,   793,   794,   795,   796,   797,   798,     0,   790,
     791,   792,   793,   794,   795,   796,   797,   798,     0,     0,
       0,     0,     0,     0,     0,   820,   799,     0,     0,     0,
     863,     0,     0,     0,     0,   525,   799,   526,     0,     0,
       0,     0,   527,     0,     0,     0,   891,     0,     0,     0,
     523,   524,   790,   791,   792,   793,   794,   795,   796,   797,
     798,   603,   528,     0,     0,     0,     0,     0,     0,     0,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   799,
       0,     0,     0,     0,     0,     0,     0,     0,   525,     0,
     526,     0,     0,     0,     0,   842,     0,   523,   524,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   528,   603,   743,   744,   745,
     746,   747,   748,   749,   750,   604,   605,   606,   607,   608,
     609,   610,   611,   612,     0,   525,     0,   526,    -2,   233,
       0,     0,   527,     0,     0,     0,     0,    -8,   -10,   -12,
     -14,   -16,   -18,   -20,   -22,   -24,     0,     0,     0,     0,
       0,     0,   528,     0,     0,     0,     0,     0,     0,     0,
       2,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,     0,    27,    28,    29,    30,
      31,     0,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,     0,     0,     0,   101,   102,   103,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     1,     0,     0,     0,     0,     0,     0,     0,    -8,
     -10,   -12,   -14,   -16,   -18,   -20,   -22,   -24,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   104,     2,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,     0,    27,    28,
      29,    30,    31,     0,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,     0,     0,     0,   101,   102,   103,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   104
};

static const yytype_int16 yycheck[] =
{
     123,   148,   148,     1,   212,   128,   582,     1,     1,   474,
     582,     1,   135,   136,   479,   582,   481,   593,   483,   595,
       1,   593,   631,   595,     1,   582,   593,     1,   595,   472,
     639,     1,   475,   531,   477,     1,   593,   613,   595,   593,
       1,   595,   485,     1,   487,   543,     1,     1,   546,   547,
     548,   174,   175,   176,   643,     1,   645,     1,   148,   139,
     178,     1,     1,     1,     1,     1,   212,   165,   493,   139,
     906,     1,   173,   174,   139,     1,   194,   653,   654,   139,
     656,   653,   654,   139,     1,   598,   653,   654,   174,     1,
     178,     1,   180,     1,   192,   170,   653,   654,   199,   653,
     654,     1,     1,   139,     1,     1,    21,    22,     1,   718,
     157,   158,     1,   199,     1,   951,   173,   174,   157,   158,
     195,     1,   139,   699,     1,   701,     1,   640,     1,     1,
     157,   158,   968,   180,     1,   560,   725,     1,   164,   165,
       1,   180,   199,     1,   170,     1,     1,     1,     1,   592,
     139,   178,     1,     1,   164,   165,     1,     1,   157,   158,
     170,     1,   751,   173,   740,   741,   164,   165,   740,   741,
     513,     1,   170,   740,   741,   173,   174,   324,   324,     1,
     178,   180,   180,   740,   741,   179,   740,   741,   178,   182,
     655,   184,   768,   183,   164,   165,   768,     1,   179,   173,
     170,   199,     0,   173,   174,   814,   172,   184,   178,   170,
     180,   172,   173,   174,   790,   791,   792,   793,   794,   795,
     796,   797,   798,   799,   813,   139,   184,   182,   182,   199,
     170,   170,   170,   170,   324,   172,   182,   181,   199,   582,
     738,   584,   707,   708,   709,   710,   182,   712,   184,   592,
     593,   594,   595,   596,   184,   195,   195,   195,   184,   602,
     170,   774,   172,   173,   181,   175,   176,   843,   766,   181,
     613,   843,   881,   181,   184,   172,   173,   173,   175,   176,
     173,   181,   181,   491,   173,   195,   173,   184,   496,   164,
     165,   880,   500,   173,   768,   170,   173,     1,   173,   172,
     173,   173,   800,   801,   802,   803,   173,   805,   172,   918,
     653,   654,   173,   656,   172,   173,   172,   173,   173,   173,
     173,   170,   898,   172,   172,   901,   898,   172,   172,   901,
     906,   898,   172,   942,   906,     9,   779,   780,   203,   204,
     170,   898,   172,     1,   898,   491,   554,     1,   170,   692,
     496,   139,    11,     1,   500,     1,   699,   173,   701,   768,
     164,   165,   186,     1,   180,     1,   170,     1,     1,   843,
     194,   836,   948,   949,   950,   951,   948,   949,   950,   951,
       1,   139,   768,   959,   960,   961,   173,   959,   960,   961,
     513,     1,   968,   180,   892,   893,   968,   740,   741,     1,
     157,   158,   173,     1,   948,   949,   950,     1,   554,   180,
       1,     1,   755,   878,   139,     1,     1,   915,     1,     1,
       1,   764,   139,   180,   173,   139,   769,   901,     1,   178,
       1,   180,   906,   139,   843,   778,   139,     1,     1,     1,
       1,   139,   139,   786,     1,     1,     1,   790,   791,   792,
     793,   794,   795,   796,   797,   798,   799,   843,   139,   582,
     173,   584,   173,   139,     1,   588,   170,   180,   139,   180,
     593,     1,   595,     1,   948,   949,   950,   951,   178,   602,
     180,   139,   139,     1,    29,   959,   960,   961,     1,     1,
       1,    29,   901,   139,   968,     1,   139,   906,   645,     1,
       1,     1,     1,   139,     1,     1,     3,     4,     5,     6,
       7,     8,     9,   139,     1,   901,   170,   640,     1,     1,
     906,    18,   170,    20,    21,    22,    23,    24,    25,     1,
     653,   654,   170,    30,    31,     1,   170,   170,     1,   948,
     949,   950,   951,   164,   165,    10,   889,     1,     1,   170,
     959,   960,   961,   139,   139,   898,   139,   139,   139,   968,
     170,     1,   948,   949,   950,   951,   164,   165,   170,   692,
     164,   165,   170,   959,   960,   961,   170,     1,   725,   170,
     170,     1,   968,     3,     4,     5,     6,     7,     8,     9,
     139,   164,   165,   164,   165,     1,     1,   170,    18,   170,
      20,    21,    22,    23,    24,    25,   170,   170,   170,   170,
      30,    31,   139,   170,   170,   170,   139,   740,   741,   164,
     165,     1,     1,     1,     1,   170,   164,   165,   173,   174,
       1,   754,   170,   170,     1,   173,   174,   134,   135,    12,
     170,   764,   170,     1,     1,     3,     4,     5,     6,     7,
       8,     9,   170,   139,   199,   778,    15,   170,   170,   170,
      18,   199,    20,   786,   170,    23,    24,    25,   170,   170,
     170,   170,    30,    31,   170,   172,    13,   174,   173,     1,
       1,     1,   179,   170,   139,   180,   183,   170,   170,     1,
       1,     3,     4,     5,     6,     7,     8,     9,   170,     1,
       1,   139,   199,   173,   170,   139,    18,   170,    20,   139,
     180,    23,    24,    25,   134,   135,   170,   170,    30,    31,
       1,   139,     3,     4,     5,     6,     7,     8,     9,    29,
     170,   139,   164,   165,   178,    22,   180,    18,   170,    20,
      27,    28,   174,    24,    25,   178,   170,   180,   180,    30,
      31,   166,   172,   139,   174,    63,   139,   172,   173,   179,
     175,   176,    14,   183,   170,   170,   889,   199,    16,   184,
      63,   894,    17,   139,   139,   898,   134,   135,     1,   199,
       3,     4,     5,     6,     7,     8,     9,   175,   176,   177,
     170,   170,   170,   170,   139,    18,   184,    20,   139,   170,
     139,    24,    25,   170,    63,   139,   139,    30,    31,   164,
     165,   164,   165,   170,   172,   170,   174,   170,   170,   174,
     173,   179,   134,   135,   139,   183,   181,   178,     1,   180,
       3,     4,     5,     6,     7,     8,     9,   175,   176,   177,
     139,   199,   139,   181,   199,    18,   184,    20,   170,   170,
     170,    24,    25,   134,   135,   139,   139,    30,    31,   170,
     172,   170,   174,   172,   173,   139,   139,   179,   170,   170,
     139,   183,   139,   173,   174,   175,   176,   177,   139,   187,
     188,   189,   139,   178,   184,   180,   139,   199,   196,   197,
     198,   172,   170,   174,   187,   188,   189,   139,   179,   199,
     164,   165,   183,   196,   197,   198,   170,   139,   139,   173,
     174,   134,   135,   178,   139,   180,   170,     1,   199,     3,
       4,     5,     6,     7,     8,     9,   139,   139,   187,   188,
     189,   178,   139,   180,    18,   199,    20,   196,   197,   198,
      24,    25,   170,   139,   164,   165,    30,    31,   139,   172,
     170,   174,     1,   173,   174,   173,   179,   178,   139,   180,
     183,   134,   135,     1,   139,     3,     4,     5,     6,     7,
       8,     9,   178,   139,   180,   843,   199,   170,   139,   199,
      18,   178,    20,   180,   139,   172,    24,    25,   175,   176,
     177,   139,    30,    31,   178,   139,   180,   184,   178,   172,
     180,   174,   164,   165,   166,   167,   179,   139,   195,   139,
     183,   139,   139,     1,   139,     3,     4,     5,     6,     7,
       8,     9,   139,   139,   186,   139,   199,   139,   139,   139,
      18,   168,    20,   901,   139,   139,    24,    25,   175,   176,
     177,   139,    30,    31,   181,   139,   183,   184,   139,   139,
     134,   135,   139,   139,     1,   173,     3,     4,     5,     6,
       7,     8,     9,   172,   173,   139,   175,   176,   139,   139,
     173,    18,   173,    20,   170,   184,   175,    24,    25,   172,
     948,   949,   950,    30,    31,   170,   194,   170,   172,   170,
     174,   959,   960,   961,   170,   179,   134,   135,   170,   183,
       1,   170,     3,     4,     5,     6,     7,     8,     9,   170,
     189,   178,   194,   172,   194,   199,   194,    18,   172,    20,
     185,   194,   173,    24,    25,   189,   189,   172,   172,    30,
      31,   181,   200,   181,   172,   182,   174,   170,   181,   172,
     173,   179,   175,   176,   181,   183,   134,   135,   179,   181,
       1,   184,     3,     4,     5,     6,     7,     8,     9,   181,
     181,   199,   195,   181,   181,   181,   181,    18,   194,    20,
     178,   185,   185,    24,    25,   185,   185,   172,   185,    30,
      31,   170,   194,   173,   172,   168,   174,   134,   135,   194,
     172,   179,   175,   176,   177,   183,   202,   178,   181,   173,
       1,   184,     3,     4,     5,     6,     7,     8,     9,   180,
     180,   199,   173,   172,    29,    29,   182,    18,   182,    20,
     182,   170,   182,    24,    25,   172,   182,   174,   170,    30,
      31,   194,   179,   134,   135,   180,   183,   180,     3,     4,
       5,     6,     7,     8,     9,   180,   180,   178,   180,   178,
     180,     1,   199,     3,     4,     5,     6,     7,     8,     9,
     180,   178,    26,   185,   180,    30,    31,   180,    18,   178,
      20,   172,   167,   174,    24,    25,   173,   173,   179,   173,
      30,    31,   183,   134,   135,     1,   173,     3,     4,     5,
       6,     7,     8,     9,   182,   178,   182,    25,   199,   180,
     180,   180,    18,    21,    20,    19,   181,   179,    24,    25,
     179,   170,   180,   180,    30,    31,   180,   183,   170,   173,
     180,   172,   180,   174,   194,   180,   170,   201,   179,   194,
     173,   194,   183,   134,   135,     1,   170,     3,     4,     5,
       6,     7,     8,     9,   201,    19,   173,   180,   199,   202,
     170,   180,    18,   170,    20,   202,   167,   170,    24,    25,
      25,   167,   170,    25,    30,    31,   203,   170,   203,   134,
     135,   172,   106,   174,   324,   146,   725,   577,   179,   564,
     318,   641,   183,   893,   134,   135,   732,     3,     4,     5,
       6,     7,     8,     9,   778,   600,    -1,    -1,   199,   164,
     165,    -1,    18,   896,   169,   170,    -1,   172,   173,   174,
      -1,    -1,    -1,    -1,    30,    31,   181,    -1,   134,   135,
      -1,    -1,   172,    -1,   174,    -1,    -1,    -1,    -1,   179,
      -1,    -1,    -1,   183,   199,    -1,    -1,    -1,     3,     4,
       5,     6,     7,     8,     9,    -1,    -1,    -1,    -1,   199,
      -1,    -1,    -1,    18,    -1,    20,   172,    -1,   174,    24,
      25,    -1,    -1,   179,    -1,    30,    31,   183,   134,   135,
       3,     4,     5,     6,     7,     8,     9,    -1,    -1,    -1,
      -1,    -1,    -1,   199,    -1,    18,    -1,    20,    -1,   656,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    31,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   172,    -1,   174,    -1,
      -1,    -1,    -1,   179,    -1,    -1,    -1,   183,   134,   135,
      -1,    -1,    -1,     3,     4,     5,     6,     7,     8,     9,
      -1,    -1,   699,   199,   701,    -1,    -1,    -1,    18,    -1,
      20,    -1,    -1,    23,    24,    25,    -1,    -1,   164,   165,
      30,    31,   168,    -1,   170,    -1,   172,    -1,   174,    -1,
      -1,    -1,    -1,    -1,    -1,   181,   182,    -1,   184,   134,
     135,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,     6,
       7,     8,     9,   199,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    18,    -1,    20,    -1,    -1,    -1,    24,    25,    -1,
      -1,   134,   135,    30,    31,    -1,    -1,   172,    -1,   174,
      -1,    -1,    -1,    -1,   179,    -1,    -1,    -1,   183,    -1,
      -1,    -1,    -1,   790,   791,   792,   793,   794,   795,   796,
     797,   798,   799,    -1,   199,    -1,    -1,    -1,    -1,   172,
      -1,   174,    -1,    -1,    -1,    -1,   179,    -1,    -1,   182,
      -1,    -1,    -1,    -1,   134,   135,     3,     4,     5,     6,
       7,     8,     9,    -1,    -1,    -1,   199,    -1,    -1,    -1,
      -1,    18,    -1,    20,    -1,    -1,    -1,    24,    25,    -1,
      -1,    -1,    -1,    30,    31,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   172,    -1,   174,    -1,    -1,    -1,    -1,   179,
      -1,    -1,    -1,   183,    -1,    -1,    -1,   134,   135,     3,
       4,     5,     6,     7,     8,     9,    -1,    -1,    -1,   199,
      -1,    -1,    -1,    -1,    18,    -1,    20,    -1,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,    -1,   174,    -1,    -1,
      -1,    -1,   179,    -1,    -1,   182,     3,     4,     5,     6,
       7,     8,     9,   140,   141,   142,   143,   144,   145,   146,
     147,    18,   199,    20,    -1,    -1,    -1,    24,    25,    -1,
      -1,    -1,    -1,    30,    31,    -1,    -1,   134,   135,   159,
     160,   161,   162,   163,   164,   165,   166,   167,    -1,   159,
     160,   161,   162,   163,   164,   165,   166,   167,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   185,   186,    -1,    -1,    -1,
     180,    -1,    -1,    -1,    -1,   172,   186,   174,    -1,    -1,
      -1,    -1,   179,    -1,    -1,    -1,   183,    -1,    -1,    -1,
     134,   135,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   139,   199,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   186,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,    -1,
     174,    -1,    -1,    -1,    -1,   179,    -1,   134,   135,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   199,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,    -1,   172,    -1,   174,     0,     1,
      -1,    -1,   179,    -1,    -1,    -1,    -1,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    -1,    -1,    -1,    -1,
      -1,    -1,   199,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    -1,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,    -1,    -1,    -1,   136,   137,   138,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   193,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    -1,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,    -1,    -1,    -1,   136,   137,   138,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   193
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,     1,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    58,    59,    60,
      61,    62,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   136,   137,   138,   193,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   243,   244,   139,
     139,   139,   139,   139,   139,   139,   139,   139,   139,   139,
     139,   139,   139,   139,   139,   139,   139,   139,   139,   139,
     139,   139,   139,   139,   139,   139,   139,   139,   139,   139,
     139,   139,     1,   139,     1,   139,     1,   139,     1,   139,
       1,   139,     1,   139,   139,   139,   139,   139,   139,   139,
     139,   139,   139,   139,   139,   139,   139,   139,   139,   139,
     139,   139,   139,   139,   139,   139,   139,   139,     1,   173,
     139,     1,   181,   139,   139,   139,   139,   139,   139,   139,
     139,   139,   139,   139,   139,   139,   139,   139,   139,   139,
     139,   139,   139,   139,   139,   139,   139,   139,   139,     1,
     139,     1,   139,   139,   139,   139,   139,   139,   139,   139,
     139,   139,     0,     1,   209,     9,   253,    10,   254,    11,
     255,    12,   256,    13,   257,    14,   258,    15,   259,    16,
     260,    17,   261,     1,   170,     1,   170,     1,   170,     1,
     164,   165,   170,   224,     1,   170,     1,   170,     1,   170,
       1,   170,   224,     1,   173,     1,   170,     1,   170,     1,
     170,     1,   170,     1,   170,     1,   224,     1,   224,   173,
     173,     1,   170,     1,   170,     1,   172,     1,   172,     1,
     173,     1,   173,     1,   170,   172,   222,   225,   226,   232,
       1,   232,   173,     1,   172,   173,   175,   176,   184,   195,
     219,   221,   222,   225,   227,   228,   245,   246,   247,   248,
       1,   170,     1,   170,     1,   170,   170,   170,   170,   170,
     170,   170,     1,   170,     1,   170,     1,   170,     1,   170,
       1,   170,     1,   170,     1,   173,     1,   170,     1,   173,
       1,   170,     1,   224,     1,   224,     1,   224,     1,   170,
       1,   170,     1,   170,     1,   170,     1,   170,     1,   170,
       1,   170,     1,   170,     1,   170,     1,   173,     1,   173,
       1,   173,   173,     1,   170,     1,   172,   173,     1,   172,
     173,     1,   170,     1,   172,   173,     1,   170,     1,   170,
       1,   170,     1,   170,     1,   170,     1,   170,     1,   172,
       1,   172,     1,   170,     1,   170,     1,   170,     1,   170,
       1,   170,     1,   170,     1,   172,   219,     1,   170,     1,
     170,     1,   170,     1,   170,     1,   170,     1,   170,   172,
     170,   170,   172,   170,     1,   173,     1,   173,     1,   170,
       1,   170,     1,   172,   242,     1,   170,   170,     1,   182,
     184,     1,   184,     1,   182,   184,     1,   184,     1,   182,
       1,   182,     1,   182,     1,   184,     1,   184,   170,   170,
       1,   194,   234,   233,   194,   247,   194,   165,   192,   220,
     194,   228,   189,   178,   189,   186,   194,   238,   200,   189,
       3,     4,     5,     6,     7,     8,     9,    18,    20,    24,
      25,    30,    31,   134,   135,   172,   174,   179,   199,   268,
     273,   277,   279,   282,   283,   284,   285,   293,   170,   172,
     173,   251,   251,   277,   251,   251,   277,   277,   277,   251,
     251,   166,   219,    63,   187,   188,   189,   196,   197,   198,
     230,   231,   231,     1,   173,   236,   185,   219,     1,   172,
     172,   173,   172,    22,    27,    28,   239,   240,   182,   170,
     172,   181,   181,   181,   181,   224,   268,     1,   181,     1,
     181,     1,   181,   181,   181,   181,   181,   181,   181,   181,
     181,     1,   181,   139,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   271,   179,     1,   183,   279,     1,   179,
     185,   185,   183,   185,   185,   183,   183,   183,   178,   185,
     194,   194,   172,   219,   229,   170,   172,   231,   236,   194,
     178,   178,   238,   168,   177,   181,   183,   237,   241,   245,
     249,   202,   180,   168,   181,   182,   184,   224,   262,   268,
     269,   270,   273,   274,   282,   293,   180,   180,   224,   268,
       1,   173,   224,     1,   173,     1,   251,   252,   268,   262,
     268,   262,   268,   173,   250,   173,   250,   172,   292,   292,
       1,   173,   178,   180,   224,   268,   290,    29,    29,   169,
     173,   181,   224,   268,   270,   272,   293,   182,   182,   182,
     182,   170,   182,   170,   195,   223,     1,   223,   194,     1,
     223,   173,   224,   250,   239,   181,   249,   195,   222,   235,
     249,     1,   178,   183,   170,   262,   262,   183,   277,   272,
     157,   158,   178,   140,   141,   142,   143,   144,   145,   146,
     147,   263,   264,   265,   266,   267,   180,   180,   180,   180,
     178,   180,   178,   180,   178,   180,   180,   180,   180,    26,
     173,   180,   173,   180,   178,   180,   180,     1,   181,   178,
     178,   180,   180,   173,   224,   268,   178,   180,   272,   272,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   186,
     277,   277,   277,   277,   185,   277,     1,   223,   180,   180,
     180,   235,   249,   178,   178,   180,   237,   167,   180,   183,
     185,   262,   262,   173,    29,   249,   224,   173,   268,   173,
     173,    29,   173,   224,   268,   291,   182,   276,   279,   182,
      18,    23,   179,   182,   273,   275,   280,   281,   283,   284,
     285,   293,   268,   173,   250,     1,   180,   290,   251,   251,
     173,   224,   268,   180,   272,   272,   272,   272,   272,   272,
     272,   272,   272,   272,   183,   183,   183,   183,   182,   183,
     178,   178,   180,   249,   223,    25,   180,   180,   180,   178,
     180,   183,   277,    19,    21,   286,   287,   288,   181,   179,
     183,   278,   280,   179,     1,   179,   180,   180,   180,   180,
     180,   178,   180,   178,   180,   277,   249,   223,   178,   180,
     180,   170,    29,   173,   224,   268,   183,   276,   173,   224,
     183,    22,   288,   289,   262,     1,   183,   280,   275,   170,
     173,   183,   178,   180,   180,   223,   203,   204,   194,   194,
     194,   180,   180,   180,   223,   178,   180,   201,   170,   278,
     278,   278,   275,   178,   180,   173,   170,   201,    19,   173,
     180,   202,   170,   275,   180,   170,   202,   167,   170,    25,
     167,   170,    25,   203,   170,   203
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_int16 yyr1[] =
{
       0,   206,   207,   208,   208,   208,   209,   209,   210,   209,
     211,   209,   212,   209,   213,   209,   214,   209,   215,   209,
     216,   209,   217,   209,   218,   209,   209,   219,   219,   219,
     220,   220,   221,   221,   221,   222,   223,   223,   224,   224,
     224,   225,   225,   225,   225,   226,   226,   227,   227,   227,
     227,   227,   228,   228,   229,   229,   229,   230,   230,   230,
     230,   230,   230,   230,   231,   231,   232,   232,   233,   232,
     234,   232,   235,   235,   236,   236,   237,   237,   237,   237,
     237,   237,   237,   237,   237,   237,   237,   237,   238,   238,
     238,   239,   239,   239,   240,   240,   241,   241,   241,   242,
     242,   242,   242,   243,   243,   243,   243,   243,   243,   243,
     243,   243,   243,   243,   243,   243,   243,   243,   243,   243,
     243,   243,   243,   243,   243,   243,   243,   243,   243,   243,
     243,   243,   243,   243,   243,   243,   243,   243,   243,   243,
     243,   243,   243,   243,   243,   243,   243,   243,   243,   243,
     243,   243,   243,   243,   243,   243,   243,   243,   243,   243,
     243,   243,   243,   243,   243,   243,   243,   243,   243,   243,
     243,   243,   243,   243,   243,   243,   243,   243,   243,   243,
     243,   243,   243,   243,   243,   243,   243,   243,   243,   243,
     243,   243,   243,   243,   243,   243,   243,   243,   243,   243,
     243,   243,   243,   243,   243,   243,   243,   243,   243,   243,
     243,   243,   243,   243,   243,   243,   243,   243,   243,   243,
     243,   243,   243,   243,   243,   243,   243,   243,   243,   243,
     243,   243,   243,   243,   243,   243,   243,   243,   243,   243,
     243,   243,   243,   243,   243,   243,   243,   243,   243,   243,
     243,   243,   243,   243,   243,   243,   243,   243,   243,   243,
     243,   243,   243,   243,   243,   243,   243,   243,   243,   243,
     243,   243,   243,   243,   243,   243,   243,   243,   243,   243,
     243,   243,   243,   243,   243,   243,   243,   243,   243,   243,
     243,   243,   243,   243,   243,   243,   243,   243,   243,   243,
     243,   243,   243,   243,   243,   243,   244,   244,   244,   244,
     244,   244,   245,   245,   246,   247,   248,   248,   249,   249,
     250,   250,   251,   251,   251,   252,   252,   253,   253,   253,
     254,   254,   255,   255,   255,   256,   256,   257,   257,   258,
     258,   259,   259,   260,   260,   261,   261,   262,   262,   262,
     262,   262,   262,   263,   263,   264,   264,   264,   264,   265,
     265,   266,   266,   267,   267,   267,   268,   268,   269,   269,
     269,   269,   270,   270,   270,   270,   270,   271,   271,   271,
     271,   271,   271,   271,   271,   271,   271,   272,   272,   272,
     272,   272,   272,   272,   272,   272,   272,   272,   272,   272,
     272,   272,   272,   272,   273,   273,   273,   274,   274,   274,
     274,   274,   275,   275,   275,   276,   276,   276,   277,   277,
     277,   278,   278,   278,   279,   279,   279,   279,   279,   279,
     279,   279,   280,   280,   280,   280,   280,   280,   280,   280,
     280,   281,   281,   282,   282,   283,   284,   285,   286,   286,
     287,   287,   288,   288,   288,   288,   289,   289,   290,   290,
     290,   290,   290,   290,   290,   290,   290,   290,   290,   291,
     291,   291,   291,   291,   291,   291,   291,   292,   292,   292,
     292,   293,   293,   293,   293,   293,   293,   293,   293,   293,
     293,   293,   293,   293,   293,   293,   293,   293,   293,   293,
     293,   293,   293,   293,   293,   293,   293,   293,   293,   293,
     293,   293,   293,   293,   293,   293,   293,   293
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     2,     1,     2,     1,     1,     0,     2,
       0,     2,     0,     2,     0,     2,     0,     2,     0,     2,
       0,     2,     0,     2,     0,     2,     1,     1,     1,     1,
       1,     1,     1,     3,     3,     1,     1,     1,     1,     2,
       2,     3,     5,     5,     2,     3,     5,     1,     3,     5,
       5,     1,     1,     2,     1,     3,     3,     1,     1,     1,
       2,     2,     2,     2,     1,     2,     1,     1,     0,     3,
       0,     3,     1,     1,     1,     2,     9,    10,     7,     8,
       5,     6,     5,     6,     3,     4,     1,     2,     4,     3,
       0,     1,     1,     1,     3,     1,     3,     1,     2,    18,
      17,    10,     9,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     3,     3,     3,
       3,     5,     3,     3,     5,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     5,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     5,     5,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     2,     3,     2,
       6,     4,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     2,     2,     8,     8,
       8,     2,     1,     1,     1,     1,     1,     3,     1,     1,
       2,     2,     1,     1,     1,     1,     1,     4,     7,     2,
       7,     2,     4,     7,     2,     7,     2,     4,     2,     4,
       2,     4,     2,     9,     2,     7,     2,     3,     3,     2,
       3,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     3,     3,     3,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     2,     3,     3,     3,     3,     1,     1,     1,
       3,     2,     1,     3,     2,     1,     3,     2,     2,     1,
       2,     2,     1,     2,     2,     1,     1,     1,     1,     2,
       1,     2,     2,     2,     1,     1,     1,     1,     2,     1,
       2,     5,     7,     5,     7,     5,     7,     7,     2,     1,
       2,     1,     4,     3,     4,     3,     3,     2,     1,     3,
       1,     2,     2,     1,     2,     3,     1,     2,     3,     1,
       1,     1,     1,     3,     3,     3,     3,     3,     4,     4,
       2,     6,     1,     3,     1,     3,     2,     4,     2,     4,
       3,     1,     4,     6,     2,     4,     6,     2,     4,     4,
       6,     2,     4,     3,     4,     4,     2,     4,     4,     4,
       4,     6,     6,     6,     8,     8,     6,     4
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
# ifndef YY_LOCATION_PRINT
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 3: /* statements: statements statement  */
#line 502 "cfg.y"
                                     {}
#line 2502 "cfg.tab.c"
    break;

  case 4: /* statements: statement  */
#line 503 "cfg.y"
                            {}
#line 2508 "cfg.tab.c"
    break;

  case 5: /* statements: statements error  */
#line 504 "cfg.y"
                                   { yyerror(""); YYABORT;}
#line 2514 "cfg.tab.c"
    break;

  case 8: /* $@1: %empty  */
#line 509 "cfg.y"
                  {rt=REQUEST_ROUTE;}
#line 2520 "cfg.tab.c"
    break;

  case 10: /* $@2: %empty  */
#line 510 "cfg.y"
                  {rt=FAILURE_ROUTE;}
#line 2526 "cfg.tab.c"
    break;

  case 12: /* $@3: %empty  */
#line 511 "cfg.y"
                  {rt=ONREPLY_ROUTE;}
#line 2532 "cfg.tab.c"
    break;

  case 14: /* $@4: %empty  */
#line 512 "cfg.y"
                  {rt=BRANCH_ROUTE;}
#line 2538 "cfg.tab.c"
    break;

  case 16: /* $@5: %empty  */
#line 513 "cfg.y"
                  {rt=ERROR_ROUTE;}
#line 2544 "cfg.tab.c"
    break;

  case 18: /* $@6: %empty  */
#line 514 "cfg.y"
                  {rt=LOCAL_ROUTE;}
#line 2550 "cfg.tab.c"
    break;

  case 20: /* $@7: %empty  */
#line 515 "cfg.y"
                  {rt=STARTUP_ROUTE;}
#line 2556 "cfg.tab.c"
    break;

  case 22: /* $@8: %empty  */
#line 516 "cfg.y"
                  {rt=TIMER_ROUTE;}
#line 2562 "cfg.tab.c"
    break;

  case 24: /* $@9: %empty  */
#line 517 "cfg.y"
                  {rt=EVENT_ROUTE;}
#line 2568 "cfg.tab.c"
    break;

  case 27: /* listen_id: ip  */
#line 522 "cfg.y"
                                        { IFOR();
							tmp=ip_addr2a((yyvsp[0].ipaddr));
							if(tmp==0){
								LM_CRIT("cfg. parser: bad ip address.\n");
								(yyval.strval)=0;
							}else{
								(yyval.strval)=pkg_malloc(strlen(tmp)+1);
								if ((yyval.strval)==0){
									LM_CRIT("cfg. parser: out of memory.\n");
									YYABORT;
								}else{
									memcpy((yyval.strval), tmp, strlen(tmp)+1);
								}
							}
						}
#line 2588 "cfg.tab.c"
    break;

  case 28: /* listen_id: STRING  */
#line 537 "cfg.y"
                                        { IFOR();
							(yyval.strval)=pkg_malloc(strlen((yyvsp[0].strval))+1);
							if ((yyval.strval)==0){
									LM_CRIT("cfg. parser: out of memory.\n");
									YYABORT;
							}else{
									memcpy((yyval.strval), (yyvsp[0].strval), strlen((yyvsp[0].strval))+1);
							}
						}
#line 2602 "cfg.tab.c"
    break;

  case 29: /* listen_id: host  */
#line 546 "cfg.y"
                                        { IFOR();
							if ((yyvsp[0].strval)==0) {
								(yyval.strval) = 0;
							} else {
								(yyval.strval)=pkg_malloc(strlen((yyvsp[0].strval))+1);
								if ((yyval.strval)==0){
									LM_CRIT("cfg. parser: out of memory.\n");
									YYABORT;
								}else{
									memcpy((yyval.strval), (yyvsp[0].strval), strlen((yyvsp[0].strval))+1);
								}
							}
						}
#line 2620 "cfg.tab.c"
    break;

  case 30: /* host_sep: DOT  */
#line 561 "cfg.y"
                    {(yyval.strval)=".";}
#line 2626 "cfg.tab.c"
    break;

  case 31: /* host_sep: MINUS  */
#line 562 "cfg.y"
                              {(yyval.strval)="-"; }
#line 2632 "cfg.tab.c"
    break;

  case 32: /* host: ID  */
#line 565 "cfg.y"
                                        { (yyval.strval)=(yyvsp[0].strval); }
#line 2638 "cfg.tab.c"
    break;

  case 33: /* host: host host_sep ID  */
#line 566 "cfg.y"
                                { IFOR();
						(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))+1);
						if ((yyval.strval)==0){
							LM_CRIT("cfg. parser: memory allocation"
										" failure while parsing host\n");
							YYABORT;
						}else{
							memcpy((yyval.strval), (yyvsp[-2].strval), strlen((yyvsp[-2].strval)));
							(yyval.strval)[strlen((yyvsp[-2].strval))]=*(yyvsp[-1].strval);
							memcpy((yyval.strval)+strlen((yyvsp[-2].strval))+1, (yyvsp[0].strval), strlen((yyvsp[0].strval)));
							(yyval.strval)[strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))]=0;
						}
						pkg_free((yyvsp[-2].strval)); pkg_free((yyvsp[0].strval));
					}
#line 2657 "cfg.tab.c"
    break;

  case 34: /* host: host DOT error  */
#line 580 "cfg.y"
                         { (yyval.strval)=0; pkg_free((yyvsp[-2].strval));
					yyerror("invalid hostname (use quotes if hostname "
						"has config keywords)"); }
#line 2665 "cfg.tab.c"
    break;

  case 35: /* proto: ID  */
#line 585 "cfg.y"
           { IFOR();
		if (parse_proto((unsigned char *)(yyvsp[0].strval), strlen((yyvsp[0].strval)), &i_tmp) < 0) {
			yyerrorf("cannot handle protocol <%s>\n", (yyvsp[0].strval));
			YYABORT;
		}
		pkg_free((yyvsp[0].strval));
		(yyval.intval) = i_tmp;
	 }
#line 2678 "cfg.tab.c"
    break;

  case 36: /* port: NUMBER  */
#line 595 "cfg.y"
                        { (yyval.intval)=(yyvsp[0].intval); }
#line 2684 "cfg.tab.c"
    break;

  case 37: /* port: ANY  */
#line 596 "cfg.y"
                                { (yyval.intval)=0; }
#line 2690 "cfg.tab.c"
    break;

  case 38: /* snumber: NUMBER  */
#line 599 "cfg.y"
                        { (yyval.intval)=(yyvsp[0].intval); }
#line 2696 "cfg.tab.c"
    break;

  case 39: /* snumber: PLUS NUMBER  */
#line 600 "cfg.y"
                                { (yyval.intval)=(yyvsp[0].intval); }
#line 2702 "cfg.tab.c"
    break;

  case 40: /* snumber: MINUS NUMBER  */
#line 601 "cfg.y"
                                { (yyval.intval)=-(yyvsp[0].intval); }
#line 2708 "cfg.tab.c"
    break;

  case 41: /* phostport: proto COLON listen_id  */
#line 605 "cfg.y"
                                        { IFOR();
				(yyval.sockid)=mk_listen_id((yyvsp[0].strval), (yyvsp[-2].intval), 0); }
#line 2715 "cfg.tab.c"
    break;

  case 42: /* phostport: proto COLON listen_id COLON port  */
#line 607 "cfg.y"
                                                                { IFOR();
				(yyval.sockid)=mk_listen_id((yyvsp[-2].strval), (yyvsp[-4].intval), (yyvsp[0].intval));}
#line 2722 "cfg.tab.c"
    break;

  case 43: /* phostport: proto COLON listen_id COLON error  */
#line 609 "cfg.y"
                                                            {
				(yyval.sockid)=0;
				yyerror("port number expected");
				YYABORT;
				}
#line 2732 "cfg.tab.c"
    break;

  case 44: /* phostport: NUMBER error  */
#line 614 "cfg.y"
                                       { (yyval.sockid)=0;
				yyerror("protocol expected");
				YYABORT;
			}
#line 2741 "cfg.tab.c"
    break;

  case 45: /* panyhostport: proto COLON MULT  */
#line 620 "cfg.y"
                                                        { IFOR();
				(yyval.sockid)=mk_listen_id(0, (yyvsp[-2].intval), 0); }
#line 2748 "cfg.tab.c"
    break;

  case 46: /* panyhostport: proto COLON MULT COLON port  */
#line 622 "cfg.y"
                                                        { IFOR();
				(yyval.sockid)=mk_listen_id(0, (yyvsp[-4].intval), (yyvsp[0].intval)); }
#line 2755 "cfg.tab.c"
    break;

  case 47: /* alias_def: listen_id  */
#line 626 "cfg.y"
                                                                        { IFOR();
				(yyval.sockid)=mk_listen_id((yyvsp[0].strval), PROTO_NONE, 0); }
#line 2762 "cfg.tab.c"
    break;

  case 48: /* alias_def: ANY COLON listen_id  */
#line 628 "cfg.y"
                                                                        { IFOR();
		 		(yyval.sockid)=mk_listen_id((yyvsp[0].strval), PROTO_NONE, 0); }
#line 2769 "cfg.tab.c"
    break;

  case 49: /* alias_def: ANY COLON listen_id COLON port  */
#line 630 "cfg.y"
                                                        { IFOR();
		 		(yyval.sockid)=mk_listen_id((yyvsp[-2].strval), PROTO_NONE, (yyvsp[0].intval)); }
#line 2776 "cfg.tab.c"
    break;

  case 50: /* alias_def: ANY COLON listen_id COLON error  */
#line 632 "cfg.y"
                                                        {
				(yyval.sockid)=0;
				yyerror(" port number expected");
				}
#line 2785 "cfg.tab.c"
    break;

  case 52: /* id_lst: alias_def  */
#line 639 "cfg.y"
                                        { IFOR();  (yyval.sockid)=(yyvsp[0].sockid) ; }
#line 2791 "cfg.tab.c"
    break;

  case 53: /* id_lst: alias_def id_lst  */
#line 640 "cfg.y"
                                        { IFOR(); (yyval.sockid)=(yyvsp[-1].sockid); (yyval.sockid)->next=(yyvsp[0].sockid); }
#line 2797 "cfg.tab.c"
    break;

  case 54: /* listen_id_def: listen_id  */
#line 643 "cfg.y"
                                                                { IFOR();
					(yyval.sockid)=mk_listen_id((yyvsp[0].strval), PROTO_NONE, 0); }
#line 2804 "cfg.tab.c"
    break;

  case 55: /* listen_id_def: listen_id COLON port  */
#line 645 "cfg.y"
                                                                { IFOR();
			 		(yyval.sockid)=mk_listen_id((yyvsp[-2].strval), PROTO_NONE, (yyvsp[0].intval)); }
#line 2811 "cfg.tab.c"
    break;

  case 56: /* listen_id_def: listen_id COLON error  */
#line 647 "cfg.y"
                                                      {
					(yyval.sockid)=0;
					yyerror(" port number expected");
					}
#line 2820 "cfg.tab.c"
    break;

  case 57: /* socket_def_param: ANYCAST  */
#line 653 "cfg.y"
                          { IFOR();
					p_tmp.flags |= SI_IS_ANYCAST;
					}
#line 2828 "cfg.tab.c"
    break;

  case 58: /* socket_def_param: FRAG  */
#line 656 "cfg.y"
                                       { IFOR();
					p_tmp.flags |= SI_FRAG;
					}
#line 2836 "cfg.tab.c"
    break;

  case 59: /* socket_def_param: REUSE_PORT  */
#line 659 "cfg.y"
                                             { IFOR();
					p_tmp.flags |= SI_REUSEPORT;
					}
#line 2844 "cfg.tab.c"
    break;

  case 60: /* socket_def_param: USE_WORKERS NUMBER  */
#line 662 "cfg.y"
                                                     { IFOR();
					p_tmp.workers=(yyvsp[0].intval);
					}
#line 2852 "cfg.tab.c"
    break;

  case 61: /* socket_def_param: AS listen_id_def  */
#line 665 "cfg.y"
                                                   { IFOR();
					p_tmp.socket = (yyvsp[0].sockid);
					}
#line 2860 "cfg.tab.c"
    break;

  case 62: /* socket_def_param: TAG ID  */
#line 668 "cfg.y"
                                         { IFOR();
					p_tmp.tag = (yyvsp[0].strval);
					}
#line 2868 "cfg.tab.c"
    break;

  case 63: /* socket_def_param: USE_AUTO_SCALING_PROFILE ID  */
#line 671 "cfg.y"
                                                              { IFOR();
					p_tmp.auto_scaling_profile=(yyvsp[0].strval);
					}
#line 2876 "cfg.tab.c"
    break;

  case 66: /* socket_def: panyhostport  */
#line 680 "cfg.y"
                                                { (yyval.sockid)=(yyvsp[0].sockid); }
#line 2882 "cfg.tab.c"
    break;

  case 67: /* socket_def: phostport  */
#line 681 "cfg.y"
                                                                { (yyval.sockid)=(yyvsp[0].sockid); }
#line 2888 "cfg.tab.c"
    break;

  case 68: /* $@10: %empty  */
#line 682 "cfg.y"
                                       { IFOR();
					memset(&p_tmp, 0, sizeof(p_tmp));
				}
#line 2896 "cfg.tab.c"
    break;

  case 69: /* socket_def: panyhostport $@10 socket_def_params  */
#line 684 "cfg.y"
                                                        { IFOR();
					(yyval.sockid)=(yyvsp[-2].sockid); fill_socket_id(&p_tmp, (yyval.sockid));
				}
#line 2904 "cfg.tab.c"
    break;

  case 70: /* $@11: %empty  */
#line 687 "cfg.y"
                                    { IFOR();
					memset(&p_tmp, 0, sizeof(p_tmp));
				}
#line 2912 "cfg.tab.c"
    break;

  case 71: /* socket_def: phostport $@11 socket_def_params  */
#line 689 "cfg.y"
                                                        { IFOR();
					(yyval.sockid)=(yyvsp[-2].sockid); fill_socket_id(&p_tmp, (yyval.sockid));
				}
#line 2920 "cfg.tab.c"
    break;

  case 72: /* any_proto: ANY  */
#line 694 "cfg.y"
                        { (yyval.intval)=PROTO_NONE; }
#line 2926 "cfg.tab.c"
    break;

  case 73: /* any_proto: proto  */
#line 695 "cfg.y"
                                { (yyval.intval)=(yyvsp[0].intval); }
#line 2932 "cfg.tab.c"
    break;

  case 74: /* multi_string: STRING  */
#line 697 "cfg.y"
                       {  IFOR(); (yyval.multistr)=new_string((yyvsp[0].strval)); }
#line 2938 "cfg.tab.c"
    break;

  case 75: /* multi_string: STRING multi_string  */
#line 698 "cfg.y"
                                      { IFOR(); (yyval.multistr)=new_string((yyvsp[-1].strval)); (yyval.multistr)->next=(yyvsp[0].multistr); }
#line 2944 "cfg.tab.c"
    break;

  case 76: /* blst_elem: LPAREN any_proto COMMA ipnet COMMA port COMMA STRING RPAREN  */
#line 701 "cfg.y"
                                                                       {
				IFOR(pkg_free((yyvsp[-5].ipnet)));
				s_tmp.s=(yyvsp[-1].strval);
				s_tmp.len=strlen((yyvsp[-1].strval));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-5].ipnet),&s_tmp,(yyvsp[-3].intval),(yyvsp[-7].intval),0)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 2957 "cfg.tab.c"
    break;

  case 77: /* blst_elem: NOT LPAREN any_proto COMMA ipnet COMMA port COMMA STRING RPAREN  */
#line 709 "cfg.y"
                                                                                  {
				IFOR(pkg_free((yyvsp[-5].ipnet)));
				s_tmp.s=(yyvsp[-1].strval);
				s_tmp.len=strlen((yyvsp[-1].strval));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-5].ipnet),&s_tmp,
				(yyvsp[-3].intval),(yyvsp[-7].intval),BLR_APPLY_CONTRARY)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 2971 "cfg.tab.c"
    break;

  case 78: /* blst_elem: LPAREN any_proto COMMA ipnet COMMA port RPAREN  */
#line 718 "cfg.y"
                                                                 {
				IFOR(pkg_free((yyvsp[-3].ipnet)));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-3].ipnet),NULL,(yyvsp[-1].intval),(yyvsp[-5].intval),0)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 2982 "cfg.tab.c"
    break;

  case 79: /* blst_elem: NOT LPAREN any_proto COMMA ipnet COMMA port RPAREN  */
#line 724 "cfg.y"
                                                                     {
				IFOR(pkg_free((yyvsp[-3].ipnet)));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-3].ipnet),NULL,
				(yyvsp[-1].intval),(yyvsp[-5].intval),BLR_APPLY_CONTRARY)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 2994 "cfg.tab.c"
    break;

  case 80: /* blst_elem: LPAREN any_proto COMMA ipnet RPAREN  */
#line 731 "cfg.y"
                                                      {
				IFOR(pkg_free((yyvsp[-1].ipnet)));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-1].ipnet),NULL,0,(yyvsp[-3].intval),0)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 3005 "cfg.tab.c"
    break;

  case 81: /* blst_elem: NOT LPAREN any_proto COMMA ipnet RPAREN  */
#line 737 "cfg.y"
                                                          {
				IFOR(pkg_free((yyvsp[-1].ipnet)));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-1].ipnet),NULL,
				0,(yyvsp[-3].intval),BLR_APPLY_CONTRARY)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 3017 "cfg.tab.c"
    break;

  case 82: /* blst_elem: LPAREN ipnet COMMA port RPAREN  */
#line 744 "cfg.y"
                                                 {
				IFOR(pkg_free((yyvsp[-3].ipnet)));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-3].ipnet),NULL,(yyvsp[-1].intval),PROTO_NONE,0)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 3028 "cfg.tab.c"
    break;

  case 83: /* blst_elem: NOT LPAREN ipnet COMMA port RPAREN  */
#line 750 "cfg.y"
                                                     {
				IFOR(pkg_free((yyvsp[-3].ipnet)));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-3].ipnet),NULL,
				(yyvsp[-1].intval),PROTO_NONE,BLR_APPLY_CONTRARY)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 3040 "cfg.tab.c"
    break;

  case 84: /* blst_elem: LPAREN ipnet RPAREN  */
#line 757 "cfg.y"
                                      {
				IFOR(pkg_free((yyvsp[-1].ipnet)));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-1].ipnet),NULL,0,PROTO_NONE,0)) {
					yyerror("failed to add backlist element\n"); YYABORT;
				}
			}
#line 3051 "cfg.tab.c"
    break;

  case 85: /* blst_elem: NOT LPAREN ipnet RPAREN  */
#line 763 "cfg.y"
                                          {
				IFOR(pkg_free((yyvsp[-1].ipnet)));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-1].ipnet),NULL,
				0,PROTO_NONE,BLR_APPLY_CONTRARY)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 3063 "cfg.tab.c"
    break;

  case 86: /* blst_elem: ipnet  */
#line 770 "cfg.y"
                        {
				IFOR(pkg_free((yyvsp[0].ipnet)));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[0].ipnet),NULL,0,PROTO_NONE,0)) {
					yyerror("failed to add backlist element\n"); YYABORT;
				}
			}
#line 3074 "cfg.tab.c"
    break;

  case 87: /* blst_elem: NOT ipnet  */
#line 776 "cfg.y"
                            {
				IFOR(pkg_free((yyvsp[0].ipnet)));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[0].ipnet),NULL,
				0,PROTO_NONE,BLR_APPLY_CONTRARY)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 3086 "cfg.tab.c"
    break;

  case 91: /* blst_flag: READONLY  */
#line 790 "cfg.y"
                    { (yyval.intval) = BL_READONLY_LIST; }
#line 3092 "cfg.tab.c"
    break;

  case 92: /* blst_flag: EXPIRE  */
#line 791 "cfg.y"
                          { (yyval.intval) = BL_DO_EXPIRE; }
#line 3098 "cfg.tab.c"
    break;

  case 93: /* blst_flag: DEFAULT  */
#line 792 "cfg.y"
                           { (yyval.intval) = BL_BY_DEFAULT; }
#line 3104 "cfg.tab.c"
    break;

  case 94: /* blst_flags: blst_flags COMMA blst_flag  */
#line 795 "cfg.y"
                                       { (yyval.intval) = (yyvsp[-2].intval) | (yyvsp[0].intval); }
#line 3110 "cfg.tab.c"
    break;

  case 95: /* blst_flags: blst_flag  */
#line 796 "cfg.y"
                            {}
#line 3116 "cfg.tab.c"
    break;

  case 96: /* blst_elem_list: blst_elem_list COMMA blst_elem  */
#line 799 "cfg.y"
                                               {}
#line 3122 "cfg.tab.c"
    break;

  case 97: /* blst_elem_list: blst_elem  */
#line 800 "cfg.y"
                            {}
#line 3128 "cfg.tab.c"
    break;

  case 98: /* blst_elem_list: blst_elem_list error  */
#line 801 "cfg.y"
                                       { yyerror("bad black list element");}
#line 3134 "cfg.tab.c"
    break;

  case 99: /* auto_scale_profile_def: ID SCALE_UP_TO NUMBER ON NUMBER MODULO FOR NUMBER CYCLES_WITHIN NUMBER SCALE_DOWN_TO NUMBER ON NUMBER MODULO FOR NUMBER CYCLES  */
#line 808 "cfg.y"
                                              { IFOR();
			if (create_auto_scaling_profile((yyvsp[-17].strval),(yyvsp[-15].intval),(yyvsp[-13].intval),(yyvsp[-10].intval),(yyvsp[-8].intval),
			(yyvsp[-6].intval), (yyvsp[-4].intval), (yyvsp[-1].intval),10*(yyvsp[-1].intval))<0)
				yyerror("failed to create auto scaling profile");
		 }
#line 3144 "cfg.tab.c"
    break;

  case 100: /* auto_scale_profile_def: ID SCALE_UP_TO NUMBER ON NUMBER MODULO FOR NUMBER CYCLES SCALE_DOWN_TO NUMBER ON NUMBER MODULO FOR NUMBER CYCLES  */
#line 816 "cfg.y"
                                              { IFOR();
			if (create_auto_scaling_profile((yyvsp[-16].strval),(yyvsp[-14].intval),(yyvsp[-12].intval),(yyvsp[-9].intval),(yyvsp[-9].intval),
			(yyvsp[-6].intval), (yyvsp[-4].intval), (yyvsp[-1].intval), 10*(yyvsp[-1].intval))<0)
				yyerror("failed to create auto scaling profile");
		 }
#line 3154 "cfg.tab.c"
    break;

  case 101: /* auto_scale_profile_def: ID SCALE_UP_TO NUMBER ON NUMBER MODULO FOR NUMBER CYCLES_WITHIN NUMBER  */
#line 822 "cfg.y"
                                                            { IFOR();
			if (create_auto_scaling_profile((yyvsp[-9].strval),(yyvsp[-7].intval),(yyvsp[-5].intval),(yyvsp[-2].intval),(yyvsp[0].intval),
			0, 0, 0, 0)<0)
				yyerror("failed to create auto scaling profile");
		}
#line 3164 "cfg.tab.c"
    break;

  case 102: /* auto_scale_profile_def: ID SCALE_UP_TO NUMBER ON NUMBER MODULO FOR NUMBER CYCLES  */
#line 828 "cfg.y"
                                              { IFOR();
			if (create_auto_scaling_profile((yyvsp[-8].strval),(yyvsp[-6].intval),(yyvsp[-4].intval),(yyvsp[-1].intval),(yyvsp[-1].intval),
			0, 0, 0, 0)<0)
				yyerror("failed to create auto scaling profile");
		}
#line 3174 "cfg.tab.c"
    break;

  case 103: /* assign_stm: LOGLEVEL EQUAL snumber  */
#line 835 "cfg.y"
                                   { IFOR();
			/* in debug mode, force logging to DEBUG level*/
			*log_level = debug_mode?L_DBG:(yyvsp[0].intval);
			}
#line 3183 "cfg.tab.c"
    break;

  case 104: /* assign_stm: LOGPREFIX EQUAL STRING  */
#line 839 "cfg.y"
                                         { IFOR();
			if (*(yyvsp[0].strval)) {
				int len = strlen((yyvsp[0].strval));
				char *buf = pkg_malloc(len + 2);
				if (!buf)
					yyerror("oom");
				sprintf(buf, "%s:", (yyvsp[0].strval));
				log_prefix = buf;
			} else {
				log_prefix = (yyvsp[0].strval);
			}
			}
#line 3200 "cfg.tab.c"
    break;

  case 105: /* assign_stm: LOGPREFIX EQUAL error  */
#line 851 "cfg.y"
                                         { yyerror("string value expected"); }
#line 3206 "cfg.tab.c"
    break;

  case 106: /* assign_stm: ENABLE_ASSERTS EQUAL NUMBER  */
#line 852 "cfg.y"
                                               { IFOR(); enable_asserts=(yyvsp[0].intval); }
#line 3212 "cfg.tab.c"
    break;

  case 107: /* assign_stm: ENABLE_ASSERTS EQUAL error  */
#line 853 "cfg.y"
                                              { yyerror("boolean value expected"); }
#line 3218 "cfg.tab.c"
    break;

  case 108: /* assign_stm: ABORT_ON_ASSERT EQUAL NUMBER  */
#line 854 "cfg.y"
                                                { IFOR(); abort_on_assert=(yyvsp[0].intval); }
#line 3224 "cfg.tab.c"
    break;

  case 109: /* assign_stm: ABORT_ON_ASSERT EQUAL error  */
#line 855 "cfg.y"
                                               { yyerror("boolean value expected"); }
#line 3230 "cfg.tab.c"
    break;

  case 110: /* assign_stm: DEBUG_MODE EQUAL NUMBER  */
#line 856 "cfg.y"
                                           { IFOR();
			debug_mode=(yyvsp[0].intval);
			if (debug_mode) {
				*log_level = L_DBG;
				stderr_enabled=1;
				syslog_enabled=0;

				s_tmp.s=STDERR_CONSUMER_NAME;
				s_tmp.len=strlen(STDERR_CONSUMER_NAME);
				set_log_consumer_mute_state(&s_tmp, 0);
				s_tmp.s=SYSLOG_CONSUMER_NAME;
				s_tmp.len=strlen(SYSLOG_CONSUMER_NAME);
				set_log_consumer_mute_state(&s_tmp, 1);
			}
			}
#line 3250 "cfg.tab.c"
    break;

  case 111: /* assign_stm: DEBUG_MODE EQUAL error  */
#line 872 "cfg.y"
                        { yyerror("boolean value expected for debug_mode"); }
#line 3256 "cfg.tab.c"
    break;

  case 112: /* assign_stm: LOGSTDOUT EQUAL NUMBER  */
#line 875 "cfg.y"
                        { IFOR(); log_stdout=(yyvsp[0].intval); }
#line 3262 "cfg.tab.c"
    break;

  case 113: /* assign_stm: LOGSTDOUT EQUAL error  */
#line 876 "cfg.y"
                                        { yyerror("boolean value expected"); }
#line 3268 "cfg.tab.c"
    break;

  case 114: /* assign_stm: LOGSTDERROR EQUAL NUMBER  */
#line 877 "cfg.y"
                                           {
			IFOR();
			warn("'log_stderror' is deprecated, use 'stderror_enabled' and/or"
				"'syslog_enabled' instead");
			if (!config_check && !debug_mode) {
				if ((yyvsp[0].intval)) {
					stderr_enabled=1;
					syslog_enabled=0;
				} else {
					stderr_enabled=0;
					syslog_enabled=1;
				}

				s_tmp.s=STDERR_CONSUMER_NAME;
				s_tmp.len=strlen(STDERR_CONSUMER_NAME);
				set_log_consumer_mute_state(&s_tmp, !(yyvsp[0].intval));
				s_tmp.s=SYSLOG_CONSUMER_NAME;
				s_tmp.len=strlen(SYSLOG_CONSUMER_NAME);
				set_log_consumer_mute_state(&s_tmp, (yyvsp[0].intval));
			}
			}
#line 3294 "cfg.tab.c"
    break;

  case 115: /* assign_stm: LOGSTDERROR EQUAL error  */
#line 898 "cfg.y"
                                          { yyerror("boolean value expected"); }
#line 3300 "cfg.tab.c"
    break;

  case 116: /* assign_stm: STDERROR_ENABLED EQUAL NUMBER  */
#line 899 "cfg.y"
                                                {
			/* in config-check or debug mode we force logging
			 * to standard error */
			IFOR();
			if (!config_check && !debug_mode) {
				stderr_enabled=(yyvsp[0].intval);
				s_tmp.s=STDERR_CONSUMER_NAME;
				s_tmp.len=strlen(STDERR_CONSUMER_NAME);
				set_log_consumer_mute_state(&s_tmp, !(yyvsp[0].intval));
			}
			}
#line 3316 "cfg.tab.c"
    break;

  case 117: /* assign_stm: STDERROR_ENABLED EQUAL error  */
#line 910 "cfg.y"
                                               { yyerror("boolean value expected"); }
#line 3322 "cfg.tab.c"
    break;

  case 118: /* assign_stm: SYSLOG_ENABLED EQUAL NUMBER  */
#line 911 "cfg.y"
                                              {
			IFOR();
			/* in config-check or debug mode we force logging
			 * to standard error */
			if (!config_check && !debug_mode) {
				syslog_enabled=(yyvsp[0].intval);
				s_tmp.s=SYSLOG_CONSUMER_NAME;
				s_tmp.len=strlen(SYSLOG_CONSUMER_NAME);
				set_log_consumer_mute_state(&s_tmp, !(yyvsp[0].intval));
			}
			}
#line 3338 "cfg.tab.c"
    break;

  case 119: /* assign_stm: SYSLOG_ENABLED EQUAL error  */
#line 922 "cfg.y"
                                             { yyerror("boolean value expected"); }
#line 3344 "cfg.tab.c"
    break;

  case 120: /* assign_stm: LOG_EVENT_ENABLED EQUAL NUMBER  */
#line 923 "cfg.y"
                                                 {
			IFOR();
			if ((yyvsp[0].intval)) {
				if (init_log_msg_buf(0) < 0) {
					yyerror("failed to allocate msg log buffer");
					YYABORT;
				}
			}
			log_event_enabled=(yyvsp[0].intval); }
#line 3358 "cfg.tab.c"
    break;

  case 121: /* assign_stm: LOG_EVENT_ENABLED EQUAL error  */
#line 932 "cfg.y"
                                                { yyerror("boolean value expected"); }
#line 3364 "cfg.tab.c"
    break;

  case 122: /* assign_stm: STDERROR_LEVEL_FILTER EQUAL snumber  */
#line 933 "cfg.y"
                                                      {
			IFOR();
			s_tmp.s=STDERR_CONSUMER_NAME;
			s_tmp.len=strlen(STDERR_CONSUMER_NAME);
			set_log_consumer_level_filter(&s_tmp, (yyvsp[0].intval));
			}
#line 3375 "cfg.tab.c"
    break;

  case 123: /* assign_stm: STDERROR_LEVEL_FILTER EQUAL error  */
#line 939 "cfg.y"
                                                    { yyerror("number expected"); }
#line 3381 "cfg.tab.c"
    break;

  case 124: /* assign_stm: SYSLOG_LEVEL_FILTER EQUAL snumber  */
#line 940 "cfg.y"
                                                    {
			IFOR();
			s_tmp.s=SYSLOG_CONSUMER_NAME;
			s_tmp.len=strlen(SYSLOG_CONSUMER_NAME);
			set_log_consumer_level_filter(&s_tmp, (yyvsp[0].intval));
			}
#line 3392 "cfg.tab.c"
    break;

  case 125: /* assign_stm: SYSLOG_LEVEL_FILTER EQUAL error  */
#line 946 "cfg.y"
                                                  { yyerror("number expected"); }
#line 3398 "cfg.tab.c"
    break;

  case 126: /* assign_stm: STDERROR_FORMAT EQUAL STRING  */
#line 947 "cfg.y"
                                               { IFOR();
			s_tmp.s = (yyvsp[0].strval);
			s_tmp.len = strlen((yyvsp[0].strval));
			if ((i_tmp = parse_log_format(&s_tmp)) < 0) {
				yyerror("unknown log format");
			} else {
				if (i_tmp != LOG_FORMAT_PLAIN) {
					if (init_log_json_buf(0) < 0) {
						yyerror("failed to allocate json log buffer");
						YYABORT;
					}
					if (init_log_msg_buf(0) < 0) {
						yyerror("failed to allocate msg log buffer");
						YYABORT;
					}
				}

				stderr_log_format = i_tmp;
			}
			}
#line 3423 "cfg.tab.c"
    break;

  case 127: /* assign_stm: SYSLOG_FORMAT EQUAL STRING  */
#line 967 "cfg.y"
                                             { IFOR();
			s_tmp.s = (yyvsp[0].strval);
			s_tmp.len = strlen((yyvsp[0].strval));
			if ((i_tmp = parse_log_format(&s_tmp)) < 0) {
				yyerror("unknown log format");
			} else {
				if (i_tmp != LOG_FORMAT_PLAIN) {
					if (init_log_json_buf(0) < 0) {
						yyerror("failed to allocate json log buffer");
						YYABORT;
					}
					if (init_log_msg_buf(0) < 0) {
						yyerror("failed to allocate msg log buffer");
						YYABORT;
					}
				}

				syslog_log_format = i_tmp;
			}
			}
#line 3448 "cfg.tab.c"
    break;

  case 128: /* assign_stm: LOG_JSON_BUF_SIZE EQUAL NUMBER  */
#line 987 "cfg.y"
                                                 {
			IFOR();
			log_json_buf_size = (yyvsp[0].intval);
			if (init_log_json_buf(1) < 0) {
				yyerror("failed to realloc json log buffer");
				YYABORT;
			}
			}
#line 3461 "cfg.tab.c"
    break;

  case 129: /* assign_stm: LOG_JSON_BUF_SIZE EQUAL error  */
#line 995 "cfg.y"
                                                { yyerror("number expected"); }
#line 3467 "cfg.tab.c"
    break;

  case 130: /* assign_stm: LOG_MSG_BUF_SIZE EQUAL NUMBER  */
#line 996 "cfg.y"
                                                {
			IFOR();
			log_msg_buf_size = (yyvsp[0].intval);
			if (init_log_msg_buf(1) < 0) {
				yyerror("failed to realloc msg log buffer");
				YYABORT;
			}
			}
#line 3480 "cfg.tab.c"
    break;

  case 131: /* assign_stm: LOG_MSG_BUF_SIZE EQUAL error  */
#line 1004 "cfg.y"
                                               { yyerror("number expected"); }
#line 3486 "cfg.tab.c"
    break;

  case 132: /* assign_stm: LOGFACILITY EQUAL ID  */
#line 1005 "cfg.y"
                                       { IFOR();
			warn("'log_facility' is deprecated, use 'syslog_facility' instead");
			if ( (i_tmp=str2facility((yyvsp[0].strval)))==-1)
				yyerror("bad facility (see syslog(3) man page)");
			if (!config_check)
				log_facility=i_tmp;
			}
#line 3498 "cfg.tab.c"
    break;

  case 133: /* assign_stm: LOGFACILITY EQUAL error  */
#line 1012 "cfg.y"
                                          { yyerror("ID expected"); }
#line 3504 "cfg.tab.c"
    break;

  case 134: /* assign_stm: SYSLOG_FACILITY EQUAL ID  */
#line 1013 "cfg.y"
                                           { IFOR();
			if ( (i_tmp=str2facility((yyvsp[0].strval)))==-1)
				yyerror("bad facility (see syslog(3) man page)");
			if (!config_check)
				log_facility=i_tmp;
			}
#line 3515 "cfg.tab.c"
    break;

  case 135: /* assign_stm: SYSLOG_FACILITY EQUAL error  */
#line 1019 "cfg.y"
                                              { yyerror("ID expected"); }
#line 3521 "cfg.tab.c"
    break;

  case 136: /* assign_stm: LOGNAME EQUAL STRING  */
#line 1020 "cfg.y"
                                       { IFOR();
			warn("'log_name' is deprecated, use 'syslog_name' instead");
			log_name=(yyvsp[0].strval); }
#line 3529 "cfg.tab.c"
    break;

  case 137: /* assign_stm: LOGNAME EQUAL error  */
#line 1023 "cfg.y"
                                      { yyerror("string value expected"); }
#line 3535 "cfg.tab.c"
    break;

  case 138: /* assign_stm: SYSLOG_NAME EQUAL STRING  */
#line 1024 "cfg.y"
                                           { IFOR(); log_name=(yyvsp[0].strval); }
#line 3541 "cfg.tab.c"
    break;

  case 139: /* assign_stm: SYSLOG_NAME EQUAL error  */
#line 1025 "cfg.y"
                                          { yyerror("string value expected"); }
#line 3547 "cfg.tab.c"
    break;

  case 140: /* assign_stm: DNS EQUAL NUMBER  */
#line 1026 "cfg.y"
                                     { IFOR(); received_dns|= ((yyvsp[0].intval))?DO_DNS:0; }
#line 3553 "cfg.tab.c"
    break;

  case 141: /* assign_stm: DNS EQUAL error  */
#line 1027 "cfg.y"
                                  { yyerror("boolean value expected"); }
#line 3559 "cfg.tab.c"
    break;

  case 142: /* assign_stm: REV_DNS EQUAL NUMBER  */
#line 1028 "cfg.y"
                                       { IFOR(); received_dns|= ((yyvsp[0].intval))?DO_REV_DNS:0; }
#line 3565 "cfg.tab.c"
    break;

  case 143: /* assign_stm: REV_DNS EQUAL error  */
#line 1029 "cfg.y"
                                      { yyerror("boolean value expected"); }
#line 3571 "cfg.tab.c"
    break;

  case 144: /* assign_stm: DNS_TRY_IPV6 EQUAL NUMBER  */
#line 1030 "cfg.y"
                                              { IFOR(); dns_try_ipv6=(yyvsp[0].intval); }
#line 3577 "cfg.tab.c"
    break;

  case 145: /* assign_stm: DNS_TRY_IPV6 error  */
#line 1031 "cfg.y"
                                     { yyerror("boolean value expected"); }
#line 3583 "cfg.tab.c"
    break;

  case 146: /* assign_stm: DNS_TRY_NAPTR EQUAL NUMBER  */
#line 1032 "cfg.y"
                                               { IFOR(); dns_try_naptr=(yyvsp[0].intval); }
#line 3589 "cfg.tab.c"
    break;

  case 147: /* assign_stm: DNS_TRY_NAPTR error  */
#line 1033 "cfg.y"
                                      { yyerror("boolean value expected"); }
#line 3595 "cfg.tab.c"
    break;

  case 148: /* assign_stm: DNS_RETR_TIME EQUAL NUMBER  */
#line 1034 "cfg.y"
                                               { IFOR(); dns_retr_time=(yyvsp[0].intval); }
#line 3601 "cfg.tab.c"
    break;

  case 149: /* assign_stm: DNS_RETR_TIME error  */
#line 1035 "cfg.y"
                                      { yyerror("number expected"); }
#line 3607 "cfg.tab.c"
    break;

  case 150: /* assign_stm: DNS_RETR_NO EQUAL NUMBER  */
#line 1036 "cfg.y"
                                             { IFOR(); dns_retr_no=(yyvsp[0].intval); }
#line 3613 "cfg.tab.c"
    break;

  case 151: /* assign_stm: DNS_RETR_NO error  */
#line 1037 "cfg.y"
                                    { yyerror("number expected"); }
#line 3619 "cfg.tab.c"
    break;

  case 152: /* assign_stm: DNS_SERVERS_NO EQUAL NUMBER  */
#line 1038 "cfg.y"
                                                { IFOR(); dns_servers_no=(yyvsp[0].intval); }
#line 3625 "cfg.tab.c"
    break;

  case 153: /* assign_stm: DNS_SERVERS_NO error  */
#line 1039 "cfg.y"
                                       { yyerror("number expected"); }
#line 3631 "cfg.tab.c"
    break;

  case 154: /* assign_stm: DNS_USE_SEARCH EQUAL NUMBER  */
#line 1040 "cfg.y"
                                                { IFOR(); dns_search_list=(yyvsp[0].intval); }
#line 3637 "cfg.tab.c"
    break;

  case 155: /* assign_stm: DNS_USE_SEARCH error  */
#line 1041 "cfg.y"
                                       { yyerror("boolean value expected"); }
#line 3643 "cfg.tab.c"
    break;

  case 156: /* assign_stm: MAX_WHILE_LOOPS EQUAL NUMBER  */
#line 1042 "cfg.y"
                                               { IFOR(); max_while_loops=(yyvsp[0].intval); }
#line 3649 "cfg.tab.c"
    break;

  case 157: /* assign_stm: MAX_WHILE_LOOPS EQUAL error  */
#line 1043 "cfg.y"
                                              { yyerror("number expected"); }
#line 3655 "cfg.tab.c"
    break;

  case 158: /* assign_stm: MAXBUFFER EQUAL NUMBER  */
#line 1044 "cfg.y"
                                         { IFOR(); maxbuffer=(yyvsp[0].intval); }
#line 3661 "cfg.tab.c"
    break;

  case 159: /* assign_stm: MAXBUFFER EQUAL error  */
#line 1045 "cfg.y"
                                        { yyerror("number expected"); }
#line 3667 "cfg.tab.c"
    break;

  case 160: /* assign_stm: UDP_WORKERS EQUAL NUMBER  */
#line 1046 "cfg.y"
                                           { IFOR(); udp_workers_no=(yyvsp[0].intval); }
#line 3673 "cfg.tab.c"
    break;

  case 161: /* assign_stm: UDP_WORKERS EQUAL NUMBER USE_AUTO_SCALING_PROFILE ID  */
#line 1047 "cfg.y"
                                                                       { IFOR();
				udp_workers_no=(yyvsp[-2].intval);
				udp_auto_scaling_profile=(yyvsp[0].strval);
		}
#line 3682 "cfg.tab.c"
    break;

  case 162: /* assign_stm: UDP_WORKERS EQUAL error  */
#line 1051 "cfg.y"
                                          { yyerror("number expected"); }
#line 3688 "cfg.tab.c"
    break;

  case 163: /* assign_stm: TIMER_WORKERS EQUAL NUMBER  */
#line 1052 "cfg.y"
                                             { IFOR();
				timer_workers_no=(yyvsp[0].intval);
		}
#line 3696 "cfg.tab.c"
    break;

  case 164: /* assign_stm: TIMER_WORKERS EQUAL NUMBER USE_AUTO_SCALING_PROFILE ID  */
#line 1055 "cfg.y"
                                                                         { IFOR();
				timer_workers_no=(yyvsp[-2].intval);
				timer_auto_scaling_profile=(yyvsp[0].strval);
		}
#line 3705 "cfg.tab.c"
    break;

  case 165: /* assign_stm: CHECK_VIA EQUAL NUMBER  */
#line 1059 "cfg.y"
                                         { check_via=(yyvsp[0].intval); }
#line 3711 "cfg.tab.c"
    break;

  case 166: /* assign_stm: CHECK_VIA EQUAL error  */
#line 1060 "cfg.y"
                                        { yyerror("boolean value expected"); }
#line 3717 "cfg.tab.c"
    break;

  case 167: /* assign_stm: SHM_HASH_SPLIT_PERCENTAGE EQUAL NUMBER  */
#line 1061 "cfg.y"
                                                         { IFOR();
			#ifdef HP_MALLOC
			shm_hash_split_percentage=(yyvsp[0].intval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3730 "cfg.tab.c"
    break;

  case 168: /* assign_stm: SHM_HASH_SPLIT_PERCENTAGE EQUAL error  */
#line 1069 "cfg.y"
                                                        {
			#ifdef HP_MALLOC
			yyerror("number expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
				}
#line 3743 "cfg.tab.c"
    break;

  case 169: /* assign_stm: SHM_SECONDARY_HASH_SIZE EQUAL NUMBER  */
#line 1077 "cfg.y"
                                                       { IFOR();
			#ifdef HP_MALLOC
			shm_secondary_hash_size=(yyvsp[0].intval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with support"
				" for HP_MALLOC\n");
			#endif
			}
#line 3756 "cfg.tab.c"
    break;

  case 170: /* assign_stm: SHM_SECONDARY_HASH_SIZE EQUAL error  */
#line 1085 "cfg.y"
                                                      {
			#ifdef HP_MALLOC
			yyerror("number expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3769 "cfg.tab.c"
    break;

  case 171: /* assign_stm: MEM_WARMING_ENABLED EQUAL NUMBER  */
#line 1093 "cfg.y"
                                                   { IFOR();
			#ifdef HP_MALLOC
			mem_warming_enabled = (yyvsp[0].intval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with support"
				" for HP_MALLOC\n");
			#endif
			}
#line 3782 "cfg.tab.c"
    break;

  case 172: /* assign_stm: MEM_WARMING_ENABLED EQUAL error  */
#line 1101 "cfg.y"
                                                  {
			#ifdef HP_MALLOC
			yyerror("number expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3795 "cfg.tab.c"
    break;

  case 173: /* assign_stm: MEM_WARMING_PATTERN_FILE EQUAL STRING  */
#line 1109 "cfg.y"
                                                        { IFOR();
			#ifdef HP_MALLOC
			mem_warming_pattern_file = (yyvsp[0].strval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with "
				"support for HP_MALLOC\n");
			#endif
			}
#line 3808 "cfg.tab.c"
    break;

  case 174: /* assign_stm: MEM_WARMING_PATTERN_FILE EQUAL error  */
#line 1117 "cfg.y"
                                                       {
			#ifdef HP_MALLOC
			yyerror("string expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3821 "cfg.tab.c"
    break;

  case 175: /* assign_stm: MEM_WARMING_PERCENTAGE EQUAL NUMBER  */
#line 1125 "cfg.y"
                                                      { IFOR();
			#ifdef HP_MALLOC
			mem_warming_percentage = (yyvsp[0].intval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with "
				"support for HP_MALLOC\n");
			#endif
			}
#line 3834 "cfg.tab.c"
    break;

  case 176: /* assign_stm: MEM_WARMING_PERCENTAGE EQUAL error  */
#line 1133 "cfg.y"
                                                     {
			#ifdef HP_MALLOC
			yyerror("number expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3847 "cfg.tab.c"
    break;

  case 177: /* assign_stm: RPM_MEM_FILE EQUAL STRING  */
#line 1141 "cfg.y"
                                            { IFOR();
			rpm_mem_file = (yyvsp[0].strval);
			}
#line 3855 "cfg.tab.c"
    break;

  case 178: /* assign_stm: RPM_MEM_FILE EQUAL error  */
#line 1144 "cfg.y"
                                           { yyerror("string value expected"); }
#line 3861 "cfg.tab.c"
    break;

  case 179: /* assign_stm: RPM_MEM_SIZE EQUAL NUMBER  */
#line 1145 "cfg.y"
                                            { IFOR();
			rpm_mem_size = (yyvsp[0].intval) * 1024 * 1024;
			}
#line 3869 "cfg.tab.c"
    break;

  case 180: /* assign_stm: RPM_MEM_SIZE EQUAL error  */
#line 1148 "cfg.y"
                                           { yyerror("int value expected"); }
#line 3875 "cfg.tab.c"
    break;

  case 181: /* assign_stm: MEMLOG EQUAL snumber  */
#line 1149 "cfg.y"
                                       { IFOR(); memlog=(yyvsp[0].intval); memdump=(yyvsp[0].intval); }
#line 3881 "cfg.tab.c"
    break;

  case 182: /* assign_stm: MEMLOG EQUAL error  */
#line 1150 "cfg.y"
                                     { yyerror("int value expected"); }
#line 3887 "cfg.tab.c"
    break;

  case 183: /* assign_stm: SHM_MEMLOG_SIZE EQUAL snumber  */
#line 1151 "cfg.y"
                                                { IFOR(); shm_memlog_size=(yyvsp[0].intval);}
#line 3893 "cfg.tab.c"
    break;

  case 184: /* assign_stm: SHM_MEMLOG_SIZE EQUAL error  */
#line 1152 "cfg.y"
                                              { yyerror("int value expected"); }
#line 3899 "cfg.tab.c"
    break;

  case 185: /* assign_stm: MEMDUMP EQUAL snumber  */
#line 1153 "cfg.y"
                                        { IFOR(); memdump=(yyvsp[0].intval); }
#line 3905 "cfg.tab.c"
    break;

  case 186: /* assign_stm: MEMDUMP EQUAL error  */
#line 1154 "cfg.y"
                                      { yyerror("int value expected"); }
#line 3911 "cfg.tab.c"
    break;

  case 187: /* assign_stm: EXECMSGTHRESHOLD EQUAL NUMBER  */
#line 1155 "cfg.y"
                                                {  IFOR();execmsgthreshold=(yyvsp[0].intval); }
#line 3917 "cfg.tab.c"
    break;

  case 188: /* assign_stm: EXECMSGTHRESHOLD EQUAL error  */
#line 1156 "cfg.y"
                                               { yyerror("int value expected"); }
#line 3923 "cfg.tab.c"
    break;

  case 189: /* assign_stm: EXECDNSTHRESHOLD EQUAL NUMBER  */
#line 1157 "cfg.y"
                                                { IFOR(); execdnsthreshold=(yyvsp[0].intval); }
#line 3929 "cfg.tab.c"
    break;

  case 190: /* assign_stm: EXECDNSTHRESHOLD EQUAL error  */
#line 1158 "cfg.y"
                                               { yyerror("int value expected"); }
#line 3935 "cfg.tab.c"
    break;

  case 191: /* assign_stm: TCPTHRESHOLD EQUAL NUMBER  */
#line 1159 "cfg.y"
                                            { IFOR(); tcpthreshold=(yyvsp[0].intval); }
#line 3941 "cfg.tab.c"
    break;

  case 192: /* assign_stm: TCPTHRESHOLD EQUAL error  */
#line 1160 "cfg.y"
                                           { yyerror("int value expected"); }
#line 3947 "cfg.tab.c"
    break;

  case 193: /* assign_stm: EVENT_SHM_THRESHOLD EQUAL NUMBER  */
#line 1161 "cfg.y"
                                                   { IFOR();
			#ifdef STATISTICS
			if ((yyvsp[0].intval) < 0 || (yyvsp[0].intval) > 100)
				yyerror("SHM threshold has to be a percentage between"
					" 0 and 100");
			event_shm_threshold=(yyvsp[0].intval);
			#else
			yyerror("statistics support not compiled in");
			#endif /* STATISTICS */
			}
#line 3962 "cfg.tab.c"
    break;

  case 194: /* assign_stm: EVENT_SHM_THRESHOLD EQUAL error  */
#line 1171 "cfg.y"
                                                  { yyerror("int value expected"); }
#line 3968 "cfg.tab.c"
    break;

  case 195: /* assign_stm: EVENT_PKG_THRESHOLD EQUAL NUMBER  */
#line 1172 "cfg.y"
                                                   { IFOR();
			#ifdef PKG_MALLOC
			#ifdef STATISTICS
			if ((yyvsp[0].intval) < 0 || (yyvsp[0].intval) > 100)
				yyerror("PKG threshold has to be a percentage between "
					"0 and 100");
			event_pkg_threshold=(yyvsp[0].intval);
			#else
			yyerror("statistics support not compiled in");
			#endif
			#else
			yyerror("pkg_malloc support not compiled in");
			#endif
			}
#line 3987 "cfg.tab.c"
    break;

  case 196: /* assign_stm: EVENT_PKG_THRESHOLD EQUAL error  */
#line 1186 "cfg.y"
                                                  { yyerror("int value expected"); }
#line 3993 "cfg.tab.c"
    break;

  case 197: /* assign_stm: QUERYBUFFERSIZE EQUAL NUMBER  */
#line 1187 "cfg.y"
                                               { IFOR(); query_buffer_size=(yyvsp[0].intval); }
#line 3999 "cfg.tab.c"
    break;

  case 198: /* assign_stm: QUERYBUFFERSIZE EQUAL error  */
#line 1188 "cfg.y"
                                              { yyerror("int value expected"); }
#line 4005 "cfg.tab.c"
    break;

  case 199: /* assign_stm: QUERYFLUSHTIME EQUAL NUMBER  */
#line 1189 "cfg.y"
                                              { IFOR(); query_flush_time=(yyvsp[0].intval); }
#line 4011 "cfg.tab.c"
    break;

  case 200: /* assign_stm: QUERYFLUSHTIME EQUAL error  */
#line 1190 "cfg.y"
                                             { yyerror("int value expected"); }
#line 4017 "cfg.tab.c"
    break;

  case 201: /* assign_stm: SIP_WARNING EQUAL NUMBER  */
#line 1191 "cfg.y"
                                           { IFOR(); sip_warning=(yyvsp[0].intval); }
#line 4023 "cfg.tab.c"
    break;

  case 202: /* assign_stm: SIP_WARNING EQUAL error  */
#line 1192 "cfg.y"
                                          { yyerror("boolean value expected"); }
#line 4029 "cfg.tab.c"
    break;

  case 203: /* assign_stm: CHROOT EQUAL STRING  */
#line 1193 "cfg.y"
                                          { IFOR(); chroot_dir=(yyvsp[0].strval); }
#line 4035 "cfg.tab.c"
    break;

  case 204: /* assign_stm: CHROOT EQUAL ID  */
#line 1194 "cfg.y"
                                          { IFOR(); chroot_dir=(yyvsp[0].strval); }
#line 4041 "cfg.tab.c"
    break;

  case 205: /* assign_stm: CHROOT EQUAL error  */
#line 1195 "cfg.y"
                                          { yyerror("string value expected"); }
#line 4047 "cfg.tab.c"
    break;

  case 206: /* assign_stm: WDIR EQUAL STRING  */
#line 1196 "cfg.y"
                                        { IFOR(); working_dir=(yyvsp[0].strval); }
#line 4053 "cfg.tab.c"
    break;

  case 207: /* assign_stm: WDIR EQUAL ID  */
#line 1197 "cfg.y"
                                        { IFOR(); working_dir=(yyvsp[0].strval); }
#line 4059 "cfg.tab.c"
    break;

  case 208: /* assign_stm: WDIR EQUAL error  */
#line 1198 "cfg.y"
                                        { yyerror("string value expected"); }
#line 4065 "cfg.tab.c"
    break;

  case 209: /* assign_stm: MHOMED EQUAL NUMBER  */
#line 1199 "cfg.y"
                                      { IFOR(); mhomed=(yyvsp[0].intval); }
#line 4071 "cfg.tab.c"
    break;

  case 210: /* assign_stm: MHOMED EQUAL error  */
#line 1200 "cfg.y"
                                     { yyerror("boolean value expected"); }
#line 4077 "cfg.tab.c"
    break;

  case 211: /* assign_stm: POLL_METHOD EQUAL ID  */
#line 1201 "cfg.y"
                                       { IFOR();
									io_poll_method=get_poll_type((yyvsp[0].strval));
									if (io_poll_method==POLL_NONE){
										LM_CRIT("bad poll method name:"
											" %s\n, try one of %s.\n",
											(yyvsp[0].strval), poll_support);
										yyerror("bad poll_method "
											"value");
									}
								}
#line 4092 "cfg.tab.c"
    break;

  case 212: /* assign_stm: POLL_METHOD EQUAL STRING  */
#line 1211 "cfg.y"
                                           { IFOR();
									io_poll_method=get_poll_type((yyvsp[0].strval));
									if (io_poll_method==POLL_NONE){
										LM_CRIT("bad poll method name:"
											" %s\n, try one of %s.\n",
											(yyvsp[0].strval), poll_support);
										yyerror("bad poll_method "
											"value");
									}
									}
#line 4107 "cfg.tab.c"
    break;

  case 213: /* assign_stm: POLL_METHOD EQUAL error  */
#line 1221 "cfg.y"
                                          { yyerror("poll method name expected"); }
#line 4113 "cfg.tab.c"
    break;

  case 214: /* assign_stm: TCP_ACCEPT_ALIASES EQUAL NUMBER  */
#line 1222 "cfg.y"
                                                  { IFOR();
				if ((yyvsp[0].intval) < TCP_ALIAS_NEVER || (yyvsp[0].intval) > TCP_ALIAS_ALWAYS)
					yyerror("invalid 'tcp_accept_aliases' value");
				tcp_accept_aliases=(yyvsp[0].intval);
		}
#line 4123 "cfg.tab.c"
    break;

  case 215: /* assign_stm: TCP_ACCEPT_ALIASES EQUAL error  */
#line 1227 "cfg.y"
                                                 { yyerror("boolean value expected"); }
#line 4129 "cfg.tab.c"
    break;

  case 216: /* assign_stm: TCP_WORKERS EQUAL NUMBER  */
#line 1228 "cfg.y"
                                           { IFOR();
				tcp_workers_no=(yyvsp[0].intval);
		}
#line 4137 "cfg.tab.c"
    break;

  case 217: /* assign_stm: TCP_WORKERS EQUAL NUMBER USE_AUTO_SCALING_PROFILE ID  */
#line 1231 "cfg.y"
                                                                      { IFOR();
				tcp_workers_no=(yyvsp[-2].intval);
				tcp_auto_scaling_profile=(yyvsp[0].strval);
		}
#line 4146 "cfg.tab.c"
    break;

  case 218: /* assign_stm: TCP_WORKERS EQUAL error  */
#line 1235 "cfg.y"
                                          { yyerror("number expected"); }
#line 4152 "cfg.tab.c"
    break;

  case 219: /* assign_stm: TCP_CONNECT_TIMEOUT EQUAL NUMBER  */
#line 1236 "cfg.y"
                                                   { IFOR();
				if ((yyvsp[0].intval) <= 0)
					yyerror("invalid 'tcp_connect_timeout' (value too low!)");
				tcp_connect_timeout=(yyvsp[0].intval);
		}
#line 4162 "cfg.tab.c"
    break;

  case 220: /* assign_stm: TCP_CONNECT_TIMEOUT EQUAL error  */
#line 1241 "cfg.y"
                                                  { yyerror("number expected"); }
#line 4168 "cfg.tab.c"
    break;

  case 221: /* assign_stm: TCP_CON_LIFETIME EQUAL NUMBER  */
#line 1242 "cfg.y"
                                                { IFOR();
				tcp_con_lifetime=(yyvsp[0].intval);
		}
#line 4176 "cfg.tab.c"
    break;

  case 222: /* assign_stm: TCP_CON_LIFETIME EQUAL error  */
#line 1245 "cfg.y"
                                               { yyerror("number expected"); }
#line 4182 "cfg.tab.c"
    break;

  case 223: /* assign_stm: TCP_SOCKET_BACKLOG EQUAL NUMBER  */
#line 1246 "cfg.y"
                                                  { IFOR();
				tcp_socket_backlog=(yyvsp[0].intval);
		}
#line 4190 "cfg.tab.c"
    break;

  case 224: /* assign_stm: TCP_SOCKET_BACKLOG EQUAL error  */
#line 1249 "cfg.y"
                                                 { yyerror("number expected"); }
#line 4196 "cfg.tab.c"
    break;

  case 225: /* assign_stm: TCP_MAX_CONNECTIONS EQUAL NUMBER  */
#line 1250 "cfg.y"
                                                   { IFOR();
				tcp_max_connections=(yyvsp[0].intval);
		}
#line 4204 "cfg.tab.c"
    break;

  case 226: /* assign_stm: TCP_MAX_CONNECTIONS EQUAL error  */
#line 1253 "cfg.y"
                                                  { yyerror("number expected"); }
#line 4210 "cfg.tab.c"
    break;

  case 227: /* assign_stm: TCP_NO_NEW_CONN_BFLAG EQUAL ID  */
#line 1254 "cfg.y"
                                                 { IFOR();
				tcp_no_new_conn_bflag =
					get_flag_id_by_name(FLAG_TYPE_BRANCH, (yyvsp[0].strval), 0);
				if (!flag_in_range( (flag_t)tcp_no_new_conn_bflag ) )
					yyerror("invalid TCP no_new_conn Branch Flag");
				flag_idx2mask( &tcp_no_new_conn_bflag );
		}
#line 4222 "cfg.tab.c"
    break;

  case 228: /* assign_stm: TCP_NO_NEW_CONN_BFLAG EQUAL error  */
#line 1261 "cfg.y"
                                                    { yyerror("number value expected"); }
#line 4228 "cfg.tab.c"
    break;

  case 229: /* assign_stm: TCP_NO_NEW_CONN_RPLFLAG EQUAL ID  */
#line 1262 "cfg.y"
                                                   { IFOR();
				tcp_no_new_conn_rplflag =
					get_flag_id_by_name(FLAG_TYPE_MSG, (yyvsp[0].strval), 0);
				if (!flag_in_range( (flag_t)tcp_no_new_conn_rplflag ) )
					yyerror("invalid TCP no_new_conn RePLy Flag");
				flag_idx2mask( &tcp_no_new_conn_rplflag );
		}
#line 4240 "cfg.tab.c"
    break;

  case 230: /* assign_stm: TCP_NO_NEW_CONN_RPLFLAG EQUAL error  */
#line 1269 "cfg.y"
                                                      { yyerror("number value expected"); }
#line 4246 "cfg.tab.c"
    break;

  case 231: /* assign_stm: TCP_KEEPALIVE EQUAL NUMBER  */
#line 1271 "cfg.y"
                                             { IFOR();
				tcp_keepalive=!!(yyvsp[0].intval);
		}
#line 4254 "cfg.tab.c"
    break;

  case 232: /* assign_stm: TCP_KEEPALIVE EQUAL error  */
#line 1274 "cfg.y"
                                            { yyerror("boolean value expected"); }
#line 4260 "cfg.tab.c"
    break;

  case 233: /* assign_stm: TCP_MAX_MSG_TIME EQUAL NUMBER  */
#line 1275 "cfg.y"
                                                { IFOR();
				tcp_max_msg_time=(yyvsp[0].intval);
		}
#line 4268 "cfg.tab.c"
    break;

  case 234: /* assign_stm: TCP_MAX_MSG_TIME EQUAL error  */
#line 1278 "cfg.y"
                                               { yyerror("boolean value expected"); }
#line 4274 "cfg.tab.c"
    break;

  case 235: /* assign_stm: TCP_PARALLEL_READ_ON_WORKERS EQUAL NUMBER  */
#line 1279 "cfg.y"
                                                            { IFOR();
				tcp_parallel_read_on_workers=!!(yyvsp[0].intval);
		}
#line 4282 "cfg.tab.c"
    break;

  case 236: /* assign_stm: TCP_PARALLEL_READ_ON_WORKERS EQUAL error  */
#line 1282 "cfg.y"
                                                           {
			yyerror("boolean value expected");
		}
#line 4290 "cfg.tab.c"
    break;

  case 237: /* assign_stm: TCP_KEEPCOUNT EQUAL NUMBER  */
#line 1285 "cfg.y"
                                                        { IFOR();
			#ifndef HAVE_TCP_KEEPCNT
				warn("cannot be enabled TCP_KEEPCOUNT (no OS support)");
			#else
				tcp_keepcount=(yyvsp[0].intval);
			#endif
		}
#line 4302 "cfg.tab.c"
    break;

  case 238: /* assign_stm: TCP_KEEPCOUNT EQUAL error  */
#line 1292 "cfg.y"
                                            { yyerror("int value expected"); }
#line 4308 "cfg.tab.c"
    break;

  case 239: /* assign_stm: TCP_KEEPIDLE EQUAL NUMBER  */
#line 1293 "cfg.y"
                                                        { IFOR();
			#ifndef HAVE_TCP_KEEPIDLE
				warn("cannot be enabled TCP_KEEPIDLE (no OS support)");
			#else
				tcp_keepidle=(yyvsp[0].intval);
			#endif
		}
#line 4320 "cfg.tab.c"
    break;

  case 240: /* assign_stm: TCP_KEEPIDLE EQUAL error  */
#line 1300 "cfg.y"
                                           { yyerror("int value expected"); }
#line 4326 "cfg.tab.c"
    break;

  case 241: /* assign_stm: TCP_KEEPINTERVAL EQUAL NUMBER  */
#line 1301 "cfg.y"
                                                { IFOR();
			#ifndef HAVE_TCP_KEEPINTVL
				warn("cannot be enabled TCP_KEEPINTERVAL (no OS support)");
			#else
				tcp_keepinterval=(yyvsp[0].intval);
			 #endif
		}
#line 4338 "cfg.tab.c"
    break;

  case 242: /* assign_stm: TCP_KEEPINTERVAL EQUAL error  */
#line 1308 "cfg.y"
                                               { yyerror("int value expected"); }
#line 4344 "cfg.tab.c"
    break;

  case 243: /* assign_stm: SERVER_SIGNATURE EQUAL NUMBER  */
#line 1309 "cfg.y"
                                                { IFOR();
							server_signature=(yyvsp[0].intval); }
#line 4351 "cfg.tab.c"
    break;

  case 244: /* assign_stm: SERVER_SIGNATURE EQUAL error  */
#line 1311 "cfg.y"
                                               { yyerror("boolean value expected"); }
#line 4357 "cfg.tab.c"
    break;

  case 245: /* assign_stm: SERVER_HEADER EQUAL STRING  */
#line 1312 "cfg.y"
                                             { IFOR();
							server_header->s=(yyvsp[0].strval);
							server_header->len=strlen((yyvsp[0].strval));
							}
#line 4366 "cfg.tab.c"
    break;

  case 246: /* assign_stm: SERVER_HEADER EQUAL error  */
#line 1316 "cfg.y"
                                            { yyerror("string value expected"); }
#line 4372 "cfg.tab.c"
    break;

  case 247: /* assign_stm: USER_AGENT_HEADER EQUAL STRING  */
#line 1317 "cfg.y"
                                                 { user_agent_header->s=(yyvsp[0].strval);
			user_agent_header->len=strlen((yyvsp[0].strval));
									}
#line 4380 "cfg.tab.c"
    break;

  case 248: /* assign_stm: USER_AGENT_HEADER EQUAL error  */
#line 1320 "cfg.y"
                                                { yyerror("string value expected"); }
#line 4386 "cfg.tab.c"
    break;

  case 249: /* assign_stm: PV_PRINT_BUF_SIZE EQUAL NUMBER  */
#line 1321 "cfg.y"
                                                 { IFOR();
							pv_print_buf_size = (yyvsp[0].intval); }
#line 4393 "cfg.tab.c"
    break;

  case 250: /* assign_stm: PV_PRINT_BUF_SIZE EQUAL error  */
#line 1323 "cfg.y"
                                                { yyerror("number expected"); }
#line 4399 "cfg.tab.c"
    break;

  case 251: /* assign_stm: XLOG_BUF_SIZE EQUAL NUMBER  */
#line 1324 "cfg.y"
                                             { IFOR();
							xlog_buf_size = (yyvsp[0].intval); }
#line 4406 "cfg.tab.c"
    break;

  case 252: /* assign_stm: XLOG_FORCE_COLOR EQUAL NUMBER  */
#line 1326 "cfg.y"
                                                { IFOR();
							xlog_force_color = (yyvsp[0].intval); }
#line 4413 "cfg.tab.c"
    break;

  case 253: /* assign_stm: XLOG_PRINT_LEVEL EQUAL NUMBER  */
#line 1328 "cfg.y"
                                                { IFOR();
							xlog_print_level = (yyvsp[0].intval); }
#line 4420 "cfg.tab.c"
    break;

  case 254: /* assign_stm: XLOG_BUF_SIZE EQUAL error  */
#line 1330 "cfg.y"
                                            { yyerror("number expected"); }
#line 4426 "cfg.tab.c"
    break;

  case 255: /* assign_stm: XLOG_FORCE_COLOR EQUAL error  */
#line 1331 "cfg.y"
                                               { yyerror("boolean value expected"); }
#line 4432 "cfg.tab.c"
    break;

  case 256: /* assign_stm: XLOG_PRINT_LEVEL EQUAL error  */
#line 1332 "cfg.y"
                                               { yyerror("number expected"); }
#line 4438 "cfg.tab.c"
    break;

  case 257: /* assign_stm: XLOG_LEVEL EQUAL snumber  */
#line 1333 "cfg.y"
                                           { IFOR();
							*xlog_level = (yyvsp[0].intval); }
#line 4445 "cfg.tab.c"
    break;

  case 258: /* assign_stm: XLOG_LEVEL EQUAL error  */
#line 1335 "cfg.y"
                                         { yyerror("number expected"); }
#line 4451 "cfg.tab.c"
    break;

  case 259: /* assign_stm: SOCKET EQUAL socket_def  */
#line 1336 "cfg.y"
                                          { IFOR();
							if (add_listening_socket((yyvsp[0].sockid))!=0){
								LM_CRIT("cfg. parser: failed"
										" to add listening socket\n");
								break;
							}
						}
#line 4463 "cfg.tab.c"
    break;

  case 260: /* assign_stm: SOCKET EQUAL error  */
#line 1343 "cfg.y"
                                      { yyerror("ip address or hostname "
						"expected (use quotes if the hostname includes"
						" config keywords)"); }
#line 4471 "cfg.tab.c"
    break;

  case 261: /* assign_stm: LISTEN EQUAL socket_def  */
#line 1346 "cfg.y"
                                          { IFOR();
							warn("'listen' is deprecated, use 'socket' instead");
							if (add_listening_socket((yyvsp[0].sockid))!=0){
								LM_CRIT("cfg. parser: failed"
										" to add listen address\n");
								break;
							}
						}
#line 4484 "cfg.tab.c"
    break;

  case 262: /* assign_stm: LISTEN EQUAL error  */
#line 1354 "cfg.y"
                                      { yyerror("ip address or hostname "
						"expected (use quotes if the hostname includes"
						" config keywords)"); }
#line 4492 "cfg.tab.c"
    break;

  case 263: /* assign_stm: MEMGROUP EQUAL STRING COLON multi_string  */
#line 1357 "cfg.y"
                                                           { IFOR();
							/* convert STIRNG ($3) to an ID */
							/* update the memstats type for each module */
							#ifndef SHM_EXTRA_STATS
								LM_CRIT("SHM_EXTRA_STATS not defined");
								YYABORT;
							#else

							#ifdef SHM_SHOW_DEFAULT_GROUP
							if(strcmp((yyvsp[-2].strval), "default") == 0){
								LM_CRIT("default group  name is not allowed");
								YYABORT;
							}
							#endif

							for(tmp_mod = mod_names; tmp_mod; tmp_mod=tmp_mod->next){
								if(strcmp((yyvsp[-2].strval), tmp_mod->s) == 0){
									LM_CRIT("The same mem-group name is used twice: [%s] [%s]\n", (yyvsp[-2].strval), tmp_mod->s);
									YYABORT;
								}
							}

							tmp_mod = pkg_malloc(sizeof(struct multi_str));
							if(!tmp_mod){
								LM_CRIT("out of pkg memory");
								YYABORT;
							}

							tmp_mod->s = (yyvsp[-2].strval);
							tmp_mod->next = mod_names;
							mod_names = tmp_mod;
							for (tmp_mod = (yyvsp[0].multistr); tmp_mod; tmp_mod = tmp_mod->next){
								if(set_mem_idx(tmp_mod->s, mem_free_idx)){
									YYABORT;
								}
							}

							mem_free_idx++;

							if(alloc_group_stat()){
								YYABORT;
							}
							#endif
						}
#line 4541 "cfg.tab.c"
    break;

  case 264: /* assign_stm: MEMGROUP EQUAL STRING COLON error  */
#line 1401 "cfg.y"
                                                    { yyerror("invalid or no module specified"); }
#line 4547 "cfg.tab.c"
    break;

  case 265: /* assign_stm: ALIAS EQUAL id_lst  */
#line 1402 "cfg.y"
                                      { IFOR();
							for(lst_tmp=(yyvsp[0].sockid); lst_tmp; lst_tmp=lst_tmp->next)
								add_alias(lst_tmp->name, strlen(lst_tmp->name),
											lst_tmp->port, lst_tmp->proto);
							  }
#line 4557 "cfg.tab.c"
    break;

  case 266: /* assign_stm: ALIAS EQUAL error  */
#line 1407 "cfg.y"
                                      { yyerror("hostname expected (use quotes"
							" if the hostname includes config keywords)"); }
#line 4564 "cfg.tab.c"
    break;

  case 267: /* assign_stm: AUTO_ALIASES EQUAL NUMBER  */
#line 1409 "cfg.y"
                                            { IFOR();
								auto_aliases=(yyvsp[0].intval); }
#line 4571 "cfg.tab.c"
    break;

  case 268: /* assign_stm: AUTO_ALIASES EQUAL error  */
#line 1411 "cfg.y"
                                            { yyerror("number  expected"); }
#line 4577 "cfg.tab.c"
    break;

  case 269: /* assign_stm: ADVERTISED_ADDRESS EQUAL listen_id  */
#line 1412 "cfg.y"
                                                     { IFOR();
								if ((yyvsp[0].strval)) {
									default_global_address->s=(yyvsp[0].strval);
									default_global_address->len=strlen((yyvsp[0].strval));
								}
								}
#line 4588 "cfg.tab.c"
    break;

  case 270: /* assign_stm: ADVERTISED_ADDRESS EQUAL error  */
#line 1418 "cfg.y"
                                                 {yyerror("ip address or hostname "
												"expected"); }
#line 4595 "cfg.tab.c"
    break;

  case 271: /* assign_stm: ADVERTISED_PORT EQUAL NUMBER  */
#line 1420 "cfg.y"
                                               { IFOR();
								tmp = int2str((yyvsp[0].intval), &i_tmp);
								if (i_tmp > default_global_port->len)
									default_global_port->s =
									pkg_realloc(default_global_port->s, i_tmp);
								if (!default_global_port->s) {
									LM_CRIT("cfg. parser: out of memory.\n");
									YYABORT;
								} else {
									default_global_port->len = i_tmp;
									memcpy(default_global_port->s, tmp,
											default_global_port->len);
								}
								}
#line 4614 "cfg.tab.c"
    break;

  case 272: /* assign_stm: ADVERTISED_PORT EQUAL error  */
#line 1434 "cfg.y"
                                             {yyerror("ip address or hostname "
												"expected"); }
#line 4621 "cfg.tab.c"
    break;

  case 273: /* assign_stm: DISABLE_CORE EQUAL NUMBER  */
#line 1436 "cfg.y"
                                            { IFOR();
										disable_core_dump=(yyvsp[0].intval);
									}
#line 4629 "cfg.tab.c"
    break;

  case 274: /* assign_stm: DISABLE_CORE EQUAL error  */
#line 1439 "cfg.y"
                                           { yyerror("boolean value expected"); }
#line 4635 "cfg.tab.c"
    break;

  case 275: /* assign_stm: OPEN_FD_LIMIT EQUAL NUMBER  */
#line 1440 "cfg.y"
                                             { IFOR();
										open_files_limit=(yyvsp[0].intval);
									}
#line 4643 "cfg.tab.c"
    break;

  case 276: /* assign_stm: OPEN_FD_LIMIT EQUAL error  */
#line 1443 "cfg.y"
                                            { yyerror("number expected"); }
#line 4649 "cfg.tab.c"
    break;

  case 277: /* assign_stm: MCAST_LOOPBACK EQUAL NUMBER  */
#line 1444 "cfg.y"
                                              { IFOR();
								#ifdef USE_MCAST
										mcast_loopback=(yyvsp[0].intval);
								#else
									warn("no multicast support compiled in");
								#endif
		  }
#line 4661 "cfg.tab.c"
    break;

  case 278: /* assign_stm: MCAST_LOOPBACK EQUAL error  */
#line 1451 "cfg.y"
                                             { yyerror("boolean value expected"); }
#line 4667 "cfg.tab.c"
    break;

  case 279: /* assign_stm: MCAST_TTL EQUAL NUMBER  */
#line 1452 "cfg.y"
                                         { IFOR();
								#ifdef USE_MCAST
										mcast_ttl=(yyvsp[0].intval);
								#else
									warn("no multicast support compiled in");
								#endif
		  }
#line 4679 "cfg.tab.c"
    break;

  case 280: /* assign_stm: MCAST_TTL EQUAL error  */
#line 1459 "cfg.y"
                                        { yyerror("number expected as tos"); }
#line 4685 "cfg.tab.c"
    break;

  case 281: /* assign_stm: TOS EQUAL NUMBER  */
#line 1460 "cfg.y"
                                   { IFOR(); tos = (yyvsp[0].intval);
							if (tos<=0)
								yyerror("invalid tos value");
		 }
#line 4694 "cfg.tab.c"
    break;

  case 282: /* assign_stm: TOS EQUAL ID  */
#line 1464 "cfg.y"
                               { IFOR();
							if (strcasecmp((yyvsp[0].strval),"IPTOS_LOWDELAY")) {
								tos=IPTOS_LOWDELAY;
							} else if (strcasecmp((yyvsp[0].strval),"IPTOS_THROUGHPUT")) {
								tos=IPTOS_THROUGHPUT;
							} else if (strcasecmp((yyvsp[0].strval),"IPTOS_RELIABILITY")) {
								tos=IPTOS_RELIABILITY;
#if defined(IPTOS_MINCOST)
							} else if (strcasecmp((yyvsp[0].strval),"IPTOS_MINCOST")) {
								tos=IPTOS_MINCOST;
#endif
#if defined(IPTOS_LOWCOST)
							} else if (strcasecmp((yyvsp[0].strval),"IPTOS_LOWCOST")) {
								tos=IPTOS_LOWCOST;
#endif
							} else {
								yyerror("invalid tos value - allowed: "
									"IPTOS_LOWDELAY,IPTOS_THROUGHPUT,"
									"IPTOS_RELIABILITY"
#if defined(IPTOS_LOWCOST)
									",IPTOS_LOWCOST"
#endif
#if defined(IPTOS_MINCOST)
									",IPTOS_MINCOST"
#endif
									"\n");
							}
		 }
#line 4727 "cfg.tab.c"
    break;

  case 283: /* assign_stm: TOS EQUAL error  */
#line 1492 "cfg.y"
                                  { yyerror("number expected"); }
#line 4733 "cfg.tab.c"
    break;

  case 284: /* assign_stm: MPATH EQUAL STRING  */
#line 1493 "cfg.y"
                                     {IFOR();
				set_mpath((yyvsp[0].strval)); }
#line 4740 "cfg.tab.c"
    break;

  case 285: /* assign_stm: MPATH EQUAL error  */
#line 1495 "cfg.y"
                                     { yyerror("string value expected"); }
#line 4746 "cfg.tab.c"
    break;

  case 286: /* assign_stm: DISABLE_DNS_FAILOVER EQUAL NUMBER  */
#line 1496 "cfg.y"
                                                    { IFOR();
										disable_dns_failover=(yyvsp[0].intval);
									}
#line 4754 "cfg.tab.c"
    break;

  case 287: /* assign_stm: DISABLE_DNS_FAILOVER error  */
#line 1499 "cfg.y"
                                             { yyerror("boolean value expected"); }
#line 4760 "cfg.tab.c"
    break;

  case 288: /* assign_stm: DISABLE_DNS_BLACKLIST EQUAL NUMBER  */
#line 1500 "cfg.y"
                                                     { IFOR();
										disable_dns_blacklist=(yyvsp[0].intval);
									}
#line 4768 "cfg.tab.c"
    break;

  case 289: /* assign_stm: DISABLE_DNS_BLACKLIST error  */
#line 1503 "cfg.y"
                                              { yyerror("boolean value expected"); }
#line 4774 "cfg.tab.c"
    break;

  case 290: /* assign_stm: DST_BLACKLIST EQUAL ID SLASH blst_flags blst_def  */
#line 1504 "cfg.y"
                                                                   { IFOR();
				s_tmp.s = (yyvsp[-3].strval);
				s_tmp.len = strlen((yyvsp[-3].strval));
				if (create_bl_head(_str("script"), (yyvsp[-1].intval),
				    bl_head, bl_tail, &s_tmp)==0) {
					yyerror("failed to create blacklist\n");
					YYABORT;
				}
				bl_head = bl_tail = NULL;
				}
#line 4789 "cfg.tab.c"
    break;

  case 291: /* assign_stm: DST_BLACKLIST EQUAL ID blst_def  */
#line 1514 "cfg.y"
                                                  { IFOR();
				s_tmp.s = (yyvsp[-1].strval);
				s_tmp.len = strlen((yyvsp[-1].strval));
				if (create_bl_head(_str("script"), BL_READONLY_LIST,
				    bl_head, bl_tail, &s_tmp)==0) {
					yyerror("failed to create blacklist\n");
					YYABORT;
				}
				bl_head = bl_tail = NULL;
				}
#line 4804 "cfg.tab.c"
    break;

  case 292: /* assign_stm: DISABLE_STATELESS_FWD EQUAL NUMBER  */
#line 1524 "cfg.y"
                                                     { IFOR();
				sl_fwd_disabled=(yyvsp[0].intval); }
#line 4811 "cfg.tab.c"
    break;

  case 293: /* assign_stm: DB_VERSION_TABLE EQUAL STRING  */
#line 1526 "cfg.y"
                                                { IFOR();
				db_version_table=(yyvsp[0].strval); }
#line 4818 "cfg.tab.c"
    break;

  case 294: /* assign_stm: DB_VERSION_TABLE EQUAL error  */
#line 1528 "cfg.y"
                                               { yyerror("string value expected"); }
#line 4824 "cfg.tab.c"
    break;

  case 295: /* assign_stm: DB_DEFAULT_URL EQUAL STRING  */
#line 1529 "cfg.y"
                                              { IFOR();
				db_default_url=(yyvsp[0].strval); }
#line 4831 "cfg.tab.c"
    break;

  case 296: /* assign_stm: DB_DEFAULT_URL EQUAL error  */
#line 1531 "cfg.y"
                                             { yyerror("string value expected"); }
#line 4837 "cfg.tab.c"
    break;

  case 297: /* assign_stm: DB_MAX_ASYNC_CONNECTIONS EQUAL NUMBER  */
#line 1532 "cfg.y"
                                                        { IFOR();
				db_max_async_connections=(yyvsp[0].intval); }
#line 4844 "cfg.tab.c"
    break;

  case 298: /* assign_stm: DB_MAX_ASYNC_CONNECTIONS EQUAL error  */
#line 1534 "cfg.y"
                                                       {
				yyerror("integer value expected");
				}
#line 4852 "cfg.tab.c"
    break;

  case 299: /* assign_stm: DISABLE_503_TRANSLATION EQUAL NUMBER  */
#line 1537 "cfg.y"
                                                       { IFOR();
				disable_503_translation=(yyvsp[0].intval); }
#line 4859 "cfg.tab.c"
    break;

  case 300: /* assign_stm: DISABLE_503_TRANSLATION EQUAL error  */
#line 1539 "cfg.y"
                                                      {
				yyerror("integer value expected");
				}
#line 4867 "cfg.tab.c"
    break;

  case 301: /* assign_stm: AUTO_SCALING_PROFILE EQUAL auto_scale_profile_def  */
#line 1542 "cfg.y"
                                                                    {}
#line 4873 "cfg.tab.c"
    break;

  case 302: /* assign_stm: AUTO_SCALING_PROFILE EQUAL error  */
#line 1543 "cfg.y"
                                                   {
				yyerror("bad auto-scaling profile definition");
				}
#line 4881 "cfg.tab.c"
    break;

  case 303: /* assign_stm: AUTO_SCALING_CYCLE EQUAL NUMBER  */
#line 1546 "cfg.y"
                                                  { IFOR();
				auto_scaling_cycle=(yyvsp[0].intval); }
#line 4888 "cfg.tab.c"
    break;

  case 304: /* assign_stm: AUTO_SCALING_CYCLE EQUAL error  */
#line 1548 "cfg.y"
                                                 {
				yyerror("integer value expected");
				}
#line 4896 "cfg.tab.c"
    break;

  case 305: /* assign_stm: error EQUAL  */
#line 1551 "cfg.y"
                              { yyerror("unknown config variable"); }
#line 4902 "cfg.tab.c"
    break;

  case 306: /* module_stm: LOADMODULE STRING  */
#line 1554 "cfg.y"
                                        { IFOR();
			if (load_module((yyvsp[0].strval)) < 0)
				yyerrorf("failed to load module %s\n", (yyvsp[0].strval));
		}
#line 4911 "cfg.tab.c"
    break;

  case 307: /* module_stm: LOADMODULE error  */
#line 1558 "cfg.y"
                                        { yyerror("string expected");  }
#line 4917 "cfg.tab.c"
    break;

  case 308: /* module_stm: MODPARAM LPAREN STRING COMMA STRING COMMA STRING RPAREN  */
#line 1559 "cfg.y"
                                                                          { IFOR();
				if (set_mod_param_regex((yyvsp[-5].strval), (yyvsp[-3].strval), STR_PARAM, (yyvsp[-1].strval)) != 0) {
					yyerrorf("Parameter <%s> not found in module <%s> - "
						"can't set", (yyvsp[-3].strval), (yyvsp[-5].strval));
				}
			}
#line 4928 "cfg.tab.c"
    break;

  case 309: /* module_stm: MODPARAM LPAREN STRING COMMA STRING COMMA folded_string RPAREN  */
#line 1565 "cfg.y"
                                                                                 { IFOR();
				if (set_mod_param_regex((yyvsp[-5].strval), (yyvsp[-3].strval), STR_PARAM, (yyvsp[-1].strval)) != 0) {
					yyerrorf("Parameter <%s> not found in module <%s> - "
						"can't set", (yyvsp[-3].strval), (yyvsp[-5].strval));
				}
			}
#line 4939 "cfg.tab.c"
    break;

  case 310: /* module_stm: MODPARAM LPAREN STRING COMMA STRING COMMA snumber RPAREN  */
#line 1571 "cfg.y"
                                                                           { IFOR();
				if (set_mod_param_regex((yyvsp[-5].strval), (yyvsp[-3].strval), INT_PARAM, (void*)(yyvsp[-1].intval)) != 0) {
					yyerrorf("Parameter <%s> not found in module <%s> - "
						"can't set", (yyvsp[-3].strval), (yyvsp[-5].strval));
				}
			}
#line 4950 "cfg.tab.c"
    break;

  case 311: /* module_stm: MODPARAM error  */
#line 1577 "cfg.y"
                                 { yyerror("Invalid arguments"); }
#line 4956 "cfg.tab.c"
    break;

  case 312: /* ip: ipv4  */
#line 1581 "cfg.y"
                       { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 4962 "cfg.tab.c"
    break;

  case 313: /* ip: ipv6  */
#line 1582 "cfg.y"
                       { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 4968 "cfg.tab.c"
    break;

  case 314: /* ipv4: IPV4ADDR  */
#line 1585 "cfg.y"
                 {
					(yyval.ipaddr)=pkg_malloc(sizeof(struct ip_addr));
					if ((yyval.ipaddr)==0){
						LM_CRIT("ERROR: cfg. parser: out of memory.\n");
						YYABORT;
					}else{
						memset((yyval.ipaddr), 0, sizeof(struct ip_addr));
						(yyval.ipaddr)->af=AF_INET;
						(yyval.ipaddr)->len=16;
						if (inet_pton(AF_INET, (yyvsp[0].strval), (yyval.ipaddr)->u.addr)<=0){
							yyerror("bad ipv4 address");
						}
					}
				}
#line 4987 "cfg.tab.c"
    break;

  case 315: /* ipv6addr: IPV6ADDR  */
#line 1601 "cfg.y"
                         {
					(yyval.ipaddr)=pkg_malloc(sizeof(struct ip_addr));
					if ((yyval.ipaddr)==0){
						LM_CRIT("ERROR: cfg. parser: out of memory.\n");
						YYABORT;
					}else{
						memset((yyval.ipaddr), 0, sizeof(struct ip_addr));
						(yyval.ipaddr)->af=AF_INET6;
						(yyval.ipaddr)->len=16;
						if (inet_pton(AF_INET6, (yyvsp[0].strval), (yyval.ipaddr)->u.addr)<=0){
							yyerror("bad ipv6 address");
						}
					}
				}
#line 5006 "cfg.tab.c"
    break;

  case 316: /* ipv6: ipv6addr  */
#line 1617 "cfg.y"
                 { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 5012 "cfg.tab.c"
    break;

  case 317: /* ipv6: LBRACK ipv6addr RBRACK  */
#line 1618 "cfg.y"
                                 {(yyval.ipaddr)=(yyvsp[-1].ipaddr); }
#line 5018 "cfg.tab.c"
    break;

  case 318: /* ipnet: IPNET  */
#line 1621 "cfg.y"
                {
				if (parse_ipnet((yyvsp[0].strval), strlen((yyvsp[0].strval)), &net_tmp) < 0)
					yyerror("unable to parse ip and/or netmask\n");

				(yyval.ipnet) = net_tmp;
			}
#line 5029 "cfg.tab.c"
    break;

  case 319: /* ipnet: ip  */
#line 1627 "cfg.y"
                        {
				(yyval.ipnet)=mk_net_bitlen((yyvsp[0].ipaddr), (yyvsp[0].ipaddr)->len*8);
				pkg_free((yyvsp[0].ipaddr));
			}
#line 5038 "cfg.tab.c"
    break;

  case 320: /* folded_string: STRING STRING  */
#line 1637 "cfg.y"
                              {
				(yyval.strval) = pkg_malloc( strlen((yyvsp[-1].strval)) + strlen((yyvsp[0].strval)) + 1);
				if ((yyval.strval)==0){
					yyerror("cfg. parser: out of memory");
					YYABORT;
				} else {
					strcpy((yyval.strval),(yyvsp[-1].strval)); strcat((yyval.strval),(yyvsp[0].strval));
					pkg_free((yyvsp[-1].strval)); pkg_free((yyvsp[0].strval));
				}
			}
#line 5053 "cfg.tab.c"
    break;

  case 321: /* folded_string: folded_string STRING  */
#line 1647 "cfg.y"
                                       {
				(yyval.strval) = pkg_malloc( strlen((yyvsp[-1].strval)) + strlen((yyvsp[0].strval)) + 1);
				if ((yyval.strval)==0){
					LM_CRIT("ERROR: cfg. parser: out of memory.\n");
					YYABORT;
				} else {
					strcpy((yyval.strval),(yyvsp[-1].strval)); strcat((yyval.strval),(yyvsp[0].strval));
					pkg_free((yyvsp[-1].strval)); pkg_free((yyvsp[0].strval));
				}
			}
#line 5068 "cfg.tab.c"
    break;

  case 322: /* route_name: ID  */
#line 1658 "cfg.y"
                {
				(yyval.strval) = (yyvsp[0].strval);
				}
#line 5076 "cfg.tab.c"
    break;

  case 323: /* route_name: NUMBER  */
#line 1661 "cfg.y"
                         {
				tmp=int2str((yyvsp[0].intval), &i_tmp);
				if (((yyval.strval)=pkg_malloc(i_tmp+1))==0) {
					yyerror("cfg. parser: out of memory.\n");
					YYABORT;
				}
				memcpy( (yyval.strval), tmp, i_tmp);
				(yyval.strval)[i_tmp] = 0;
				}
#line 5090 "cfg.tab.c"
    break;

  case 324: /* route_name: STRING  */
#line 1670 "cfg.y"
                        {
				(yyval.strval) = (yyvsp[0].strval);
		}
#line 5098 "cfg.tab.c"
    break;

  case 325: /* route_name_var: route_name  */
#line 1675 "cfg.y"
                           {
				/* check to see if there are any "$" in the string name */
				tmp = strchr((yyvsp[0].strval), '$');
				if (!tmp) {
					/* route name is a cosntant string - search for the route */
					rn_tmp.data = 0;
					rn_tmp.iname = get_script_route_idx((yyvsp[0].strval), sroutes->request,
							RT_NO, 0);
					if (rn_tmp.iname==-1)
						yyerror("too many script routes");
					(yyval.intval) = NUMBER_ST;
				} else {
					tstr.s = (yyvsp[0].strval);
					tstr.len = strlen(tstr.s);
					if (pv_parse_format(&tstr, &elem) < 0) {
						yyerror("cannot parse format");
						YYABORT;
					}
					/* the route name is a format, so we can't evaluate it now */
					rn_tmp.ename = elem;
					(yyval.intval) = SCRIPTVAR_ELEM_ST;
				}
			}
#line 5126 "cfg.tab.c"
    break;

  case 326: /* route_name_var: script_var  */
#line 1698 "cfg.y"
                             {
				rn_tmp.sname = (yyvsp[0].specval);
				(yyval.intval) = SCRIPTVAR_ST;
		}
#line 5135 "cfg.tab.c"
    break;

  case 327: /* route_stm: ROUTE LBRACE actions RBRACE  */
#line 1703 "cfg.y"
                                        {
						if (sroutes->request[DEFAULT_RT].a!=0) {
							yyerror("overwriting default "
								"request routing table");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->request[DEFAULT_RT].a);
					}
#line 5148 "cfg.tab.c"
    break;

  case 328: /* route_stm: ROUTE LBRACK route_name RBRACK LBRACE actions RBRACE  */
#line 1711 "cfg.y"
                                                                       {
						if ( strtol((yyvsp[-4].strval),&tmp,10)==0 && *tmp==0) {
							/* route[0] detected */
							if (sroutes->request[DEFAULT_RT].a!=0) {
								yyerror("overwriting(2) default "
									"request routing table");
								YYABORT;
							}
							push((yyvsp[-1].action), &sroutes->request[DEFAULT_RT].a);
						} else {
							i_tmp = get_script_route_idx( (yyvsp[-4].strval),
								sroutes->request, RT_NO,1);
							if (i_tmp==-1) YYABORT;
							push((yyvsp[-1].action), &sroutes->request[i_tmp].a);
						}
					}
#line 5169 "cfg.tab.c"
    break;

  case 329: /* route_stm: ROUTE error  */
#line 1727 "cfg.y"
                              { yyerror("invalid  route  statement"); }
#line 5175 "cfg.tab.c"
    break;

  case 330: /* failure_route_stm: ROUTE_FAILURE LBRACK route_name RBRACK LBRACE actions RBRACE  */
#line 1730 "cfg.y"
                                                                                {
						i_tmp = get_script_route_idx( (yyvsp[-4].strval), sroutes->failure,
							FAILURE_RT_NO,1);
						if (i_tmp==-1) YYABORT;
						push((yyvsp[-1].action), &sroutes->failure[i_tmp].a);
					}
#line 5186 "cfg.tab.c"
    break;

  case 331: /* failure_route_stm: ROUTE_FAILURE error  */
#line 1736 "cfg.y"
                                      { yyerror("invalid failure_route statement"); }
#line 5192 "cfg.tab.c"
    break;

  case 332: /* onreply_route_stm: ROUTE_ONREPLY LBRACE actions RBRACE  */
#line 1739 "cfg.y"
                                                       {
						if (sroutes->onreply[DEFAULT_RT].a!=0) {
							yyerror("overwriting default "
								"onreply routing table");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->onreply[DEFAULT_RT].a);
					}
#line 5205 "cfg.tab.c"
    break;

  case 333: /* onreply_route_stm: ROUTE_ONREPLY LBRACK route_name RBRACK LBRACE actions RBRACE  */
#line 1747 "cfg.y"
                                                                               {
						i_tmp = get_script_route_idx( (yyvsp[-4].strval), sroutes->onreply,
							ONREPLY_RT_NO,1);
						if (i_tmp==-1) YYABORT;
						push((yyvsp[-1].action), &sroutes->onreply[i_tmp].a);
					}
#line 5216 "cfg.tab.c"
    break;

  case 334: /* onreply_route_stm: ROUTE_ONREPLY error  */
#line 1753 "cfg.y"
                                      { yyerror("invalid onreply_route statement"); }
#line 5222 "cfg.tab.c"
    break;

  case 335: /* branch_route_stm: ROUTE_BRANCH LBRACK route_name RBRACK LBRACE actions RBRACE  */
#line 1756 "cfg.y"
                                                                              {
						i_tmp = get_script_route_idx( (yyvsp[-4].strval), sroutes->branch,
							BRANCH_RT_NO,1);
						if (i_tmp==-1) YYABORT;
						push((yyvsp[-1].action), &sroutes->branch[i_tmp].a);
					}
#line 5233 "cfg.tab.c"
    break;

  case 336: /* branch_route_stm: ROUTE_BRANCH error  */
#line 1762 "cfg.y"
                                     { yyerror("invalid branch_route statement"); }
#line 5239 "cfg.tab.c"
    break;

  case 337: /* error_route_stm: ROUTE_ERROR LBRACE actions RBRACE  */
#line 1765 "cfg.y"
                                                    {
						if (sroutes->error.a!=0) {
							yyerror("overwriting default "
								"error routing table");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->error.a);
					}
#line 5252 "cfg.tab.c"
    break;

  case 338: /* error_route_stm: ROUTE_ERROR error  */
#line 1773 "cfg.y"
                                    { yyerror("invalid error_route statement"); }
#line 5258 "cfg.tab.c"
    break;

  case 339: /* local_route_stm: ROUTE_LOCAL LBRACE actions RBRACE  */
#line 1776 "cfg.y"
                                                    {
						if (sroutes->local.a!=0) {
							yyerror("re-definition of local "
								"route detected");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->local.a);
					}
#line 5271 "cfg.tab.c"
    break;

  case 340: /* local_route_stm: ROUTE_LOCAL error  */
#line 1784 "cfg.y"
                                    { yyerror("invalid local_route statement"); }
#line 5277 "cfg.tab.c"
    break;

  case 341: /* startup_route_stm: ROUTE_STARTUP LBRACE actions RBRACE  */
#line 1787 "cfg.y"
                                                        {
						if (sroutes->startup.a!=0) {
							yyerror("re-definition of startup "
								"route detected");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->startup.a);
					}
#line 5290 "cfg.tab.c"
    break;

  case 342: /* startup_route_stm: ROUTE_STARTUP error  */
#line 1795 "cfg.y"
                                      { yyerror("invalid startup_route statement"); }
#line 5296 "cfg.tab.c"
    break;

  case 343: /* timer_route_stm: ROUTE_TIMER LBRACK route_name COMMA NUMBER RBRACK LBRACE actions RBRACE  */
#line 1798 "cfg.y"
                                                                                          {
						i_tmp = 0;
						while(i_tmp<TIMER_RT_NO && sroutes->timer[i_tmp].a!=0){
							i_tmp++;
						}
						if(i_tmp == TIMER_RT_NO) {
							yyerror("Too many timer routes defined\n");
							YYABORT;
						}
						sroutes->timer[i_tmp].name = (yyvsp[-6].strval);
						sroutes->timer[i_tmp].interval = (yyvsp[-4].intval);
						push((yyvsp[-1].action), &sroutes->timer[i_tmp].a);
					}
#line 5314 "cfg.tab.c"
    break;

  case 344: /* timer_route_stm: ROUTE_TIMER error  */
#line 1811 "cfg.y"
                                    { yyerror("invalid timer_route statement"); }
#line 5320 "cfg.tab.c"
    break;

  case 345: /* event_route_stm: ROUTE_EVENT LBRACK route_name RBRACK LBRACE actions RBRACE  */
#line 1814 "cfg.y"
                                                                            {
						i_tmp = get_script_route_idx((yyvsp[-4].strval), sroutes->event,
								EVENT_RT_NO,1);
						if (i_tmp==-1) YYABORT;
						push((yyvsp[-1].action), &sroutes->event[i_tmp].a);
					}
#line 5331 "cfg.tab.c"
    break;

  case 346: /* event_route_stm: ROUTE_EVENT error  */
#line 1820 "cfg.y"
                                    { yyerror("invalid event_route statement"); }
#line 5337 "cfg.tab.c"
    break;

  case 347: /* exp: exp AND exp  */
#line 1825 "cfg.y"
                        { (yyval.expr)=mk_exp(AND_OP, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 5343 "cfg.tab.c"
    break;

  case 348: /* exp: exp OR exp  */
#line 1826 "cfg.y"
                                { (yyval.expr)=mk_exp(OR_OP, (yyvsp[-2].expr), (yyvsp[0].expr));  }
#line 5349 "cfg.tab.c"
    break;

  case 349: /* exp: NOT exp  */
#line 1827 "cfg.y"
                                        { (yyval.expr)=mk_exp(NOT_OP, (yyvsp[0].expr), 0);  }
#line 5355 "cfg.tab.c"
    break;

  case 350: /* exp: LPAREN exp RPAREN  */
#line 1828 "cfg.y"
                                { (yyval.expr)=mk_exp(EVAL_OP, (yyvsp[-1].expr), 0); }
#line 5361 "cfg.tab.c"
    break;

  case 351: /* exp: LBRACK assignexp RBRACK  */
#line 1829 "cfg.y"
                                  { (yyval.expr)=(yyvsp[-1].expr); }
#line 5367 "cfg.tab.c"
    break;

  case 352: /* exp: exp_elem  */
#line 1830 "cfg.y"
                                        { (yyval.expr)=(yyvsp[0].expr); }
#line 5373 "cfg.tab.c"
    break;

  case 353: /* equalop: EQUAL_T  */
#line 1833 "cfg.y"
                          {(yyval.intval)=EQUAL_OP; }
#line 5379 "cfg.tab.c"
    break;

  case 354: /* equalop: DIFF  */
#line 1834 "cfg.y"
                                {(yyval.intval)=DIFF_OP; }
#line 5385 "cfg.tab.c"
    break;

  case 355: /* compop: GT  */
#line 1837 "cfg.y"
                {(yyval.intval)=GT_OP; }
#line 5391 "cfg.tab.c"
    break;

  case 356: /* compop: LT  */
#line 1838 "cfg.y"
                        {(yyval.intval)=LT_OP; }
#line 5397 "cfg.tab.c"
    break;

  case 357: /* compop: GTE  */
#line 1839 "cfg.y"
                        {(yyval.intval)=GTE_OP; }
#line 5403 "cfg.tab.c"
    break;

  case 358: /* compop: LTE  */
#line 1840 "cfg.y"
                        {(yyval.intval)=LTE_OP; }
#line 5409 "cfg.tab.c"
    break;

  case 359: /* matchop: MATCH  */
#line 1842 "cfg.y"
                {(yyval.intval)=MATCH_OP; }
#line 5415 "cfg.tab.c"
    break;

  case 360: /* matchop: NOTMATCH  */
#line 1843 "cfg.y"
                                {(yyval.intval)=NOTMATCH_OP; }
#line 5421 "cfg.tab.c"
    break;

  case 361: /* intop: equalop  */
#line 1846 "cfg.y"
                {(yyval.intval)=(yyvsp[0].intval); }
#line 5427 "cfg.tab.c"
    break;

  case 362: /* intop: compop  */
#line 1847 "cfg.y"
                        {(yyval.intval)=(yyvsp[0].intval); }
#line 5433 "cfg.tab.c"
    break;

  case 363: /* strop: equalop  */
#line 1850 "cfg.y"
                {(yyval.intval)=(yyvsp[0].intval); }
#line 5439 "cfg.tab.c"
    break;

  case 364: /* strop: compop  */
#line 1851 "cfg.y"
                     {(yyval.intval)=(yyvsp[0].intval); }
#line 5445 "cfg.tab.c"
    break;

  case 365: /* strop: matchop  */
#line 1852 "cfg.y"
                                {(yyval.intval)=(yyvsp[0].intval); }
#line 5451 "cfg.tab.c"
    break;

  case 366: /* script_var: SCRIPTVAR  */
#line 1855 "cfg.y"
                                {
				spec = (pv_spec_t*)pkg_malloc(sizeof(pv_spec_t));
				if (spec==NULL){
					yyerror("no more pkg memory\n");
					YYABORT;
				}
				memset(spec, 0, sizeof(pv_spec_t));
				tstr.s = (yyvsp[0].strval);
				tstr.len = strlen(tstr.s);
				if(pv_parse_spec(&tstr, spec)==NULL)
				{
					yyerror("unknown script variable");
				}

				(yyval.specval) = spec;
			}
#line 5472 "cfg.tab.c"
    break;

  case 367: /* script_var: SCRIPTVARERR  */
#line 1871 "cfg.y"
                               {
			(yyval.specval)=0; yyerror("invalid script variable name");
		}
#line 5480 "cfg.tab.c"
    break;

  case 368: /* exp_elem: exp_cond  */
#line 1876 "cfg.y"
                                {(yyval.expr)=(yyvsp[0].expr); }
#line 5486 "cfg.tab.c"
    break;

  case 369: /* exp_elem: exp_stm  */
#line 1877 "cfg.y"
                                        {(yyval.expr)=mk_elem( NO_OP, ACTION_O, 0, ACTIONS_ST, (yyvsp[0].action) ); }
#line 5492 "cfg.tab.c"
    break;

  case 370: /* exp_elem: snumber  */
#line 1878 "cfg.y"
                                        {(yyval.expr)=mk_elem( NO_OP, NUMBER_O, 0, NUMBER_ST,
											(void*)(yyvsp[0].intval) ); }
#line 5499 "cfg.tab.c"
    break;

  case 371: /* exp_elem: script_var  */
#line 1880 "cfg.y"
                                {
				(yyval.expr)=mk_elem(NO_OP, SCRIPTVAR_O,0,SCRIPTVAR_ST,(void*)(yyvsp[0].specval));
			}
#line 5507 "cfg.tab.c"
    break;

  case 372: /* exp_cond: script_var strop script_var  */
#line 1885 "cfg.y"
                                      {
				(yyval.expr)=mk_elem( (yyvsp[-1].intval), SCRIPTVAR_O,(void*)(yyvsp[-2].specval),SCRIPTVAR_ST,(void*)(yyvsp[0].specval));
			}
#line 5515 "cfg.tab.c"
    break;

  case 373: /* exp_cond: script_var strop STRING  */
#line 1888 "cfg.y"
                                          {
				(yyval.expr)=mk_elem( (yyvsp[-1].intval), SCRIPTVAR_O,(void*)(yyvsp[-2].specval),STR_ST,(yyvsp[0].strval));
			}
#line 5523 "cfg.tab.c"
    break;

  case 374: /* exp_cond: script_var intop snumber  */
#line 1891 "cfg.y"
                                           {
				(yyval.expr)=mk_elem( (yyvsp[-1].intval), SCRIPTVAR_O,(void*)(yyvsp[-2].specval),NUMBER_ST,(void *)(yyvsp[0].intval));
			}
#line 5531 "cfg.tab.c"
    break;

  case 375: /* exp_cond: script_var equalop NULLV  */
#line 1894 "cfg.y"
                                                {
				(yyval.expr)=mk_elem( (yyvsp[-1].intval), SCRIPTVAR_O,(void*)(yyvsp[-2].specval), NULLV_ST, 0);
			}
#line 5539 "cfg.tab.c"
    break;

  case 376: /* exp_cond: script_var equalop ipnet  */
#line 1897 "cfg.y"
                                           {
				(yyval.expr)=mk_elem((yyvsp[-1].intval), SCRIPTVAR_O, (void*)(yyvsp[-2].specval), NET_ST, (yyvsp[0].ipnet));
			}
#line 5547 "cfg.tab.c"
    break;

  case 377: /* assignop: EQUAL  */
#line 1903 "cfg.y"
              { (yyval.intval) = EQ_T; }
#line 5553 "cfg.tab.c"
    break;

  case 378: /* assignop: COLONEQ  */
#line 1904 "cfg.y"
                  { (yyval.intval) = COLONEQ_T; }
#line 5559 "cfg.tab.c"
    break;

  case 379: /* assignop: PLUSEQ  */
#line 1905 "cfg.y"
                 { (yyval.intval) = PLUSEQ_T; }
#line 5565 "cfg.tab.c"
    break;

  case 380: /* assignop: MINUSEQ  */
#line 1906 "cfg.y"
                  { (yyval.intval) = MINUSEQ_T;}
#line 5571 "cfg.tab.c"
    break;

  case 381: /* assignop: SLASHEQ  */
#line 1907 "cfg.y"
                  { (yyval.intval) = DIVEQ_T; }
#line 5577 "cfg.tab.c"
    break;

  case 382: /* assignop: MULTEQ  */
#line 1908 "cfg.y"
                 { (yyval.intval) = MULTEQ_T; }
#line 5583 "cfg.tab.c"
    break;

  case 383: /* assignop: MODULOEQ  */
#line 1909 "cfg.y"
                   { (yyval.intval) = MODULOEQ_T; }
#line 5589 "cfg.tab.c"
    break;

  case 384: /* assignop: BANDEQ  */
#line 1910 "cfg.y"
                 { (yyval.intval) = BANDEQ_T; }
#line 5595 "cfg.tab.c"
    break;

  case 385: /* assignop: BOREQ  */
#line 1911 "cfg.y"
                { (yyval.intval) = BOREQ_T; }
#line 5601 "cfg.tab.c"
    break;

  case 386: /* assignop: BXOREQ  */
#line 1912 "cfg.y"
                 { (yyval.intval) = BXOREQ_T; }
#line 5607 "cfg.tab.c"
    break;

  case 387: /* assignexp: snumber  */
#line 1916 "cfg.y"
                { (yyval.expr) = mk_elem(VALUE_OP, NUMBERV_O, (void*)(yyvsp[0].intval), 0, 0); }
#line 5613 "cfg.tab.c"
    break;

  case 388: /* assignexp: STRING  */
#line 1917 "cfg.y"
                 { (yyval.expr) = mk_elem(VALUE_OP, STRINGV_O, (yyvsp[0].strval), 0, 0); }
#line 5619 "cfg.tab.c"
    break;

  case 389: /* assignexp: script_var  */
#line 1918 "cfg.y"
                     { (yyval.expr) = mk_elem(VALUE_OP, SCRIPTVAR_O, (yyvsp[0].specval), 0, 0); }
#line 5625 "cfg.tab.c"
    break;

  case 390: /* assignexp: exp_cond  */
#line 1919 "cfg.y"
                   { (yyval.expr)= (yyvsp[0].expr); }
#line 5631 "cfg.tab.c"
    break;

  case 391: /* assignexp: cmd  */
#line 1920 "cfg.y"
              { (yyval.expr)=mk_elem( NO_OP, ACTION_O, 0, ACTIONS_ST, (yyvsp[0].action) ); }
#line 5637 "cfg.tab.c"
    break;

  case 392: /* assignexp: assignexp PLUS assignexp  */
#line 1921 "cfg.y"
                                   {
				(yyval.expr) = mk_elem(PLUS_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5645 "cfg.tab.c"
    break;

  case 393: /* assignexp: assignexp MINUS assignexp  */
#line 1924 "cfg.y"
                                    {
				(yyval.expr) = mk_elem(MINUS_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5653 "cfg.tab.c"
    break;

  case 394: /* assignexp: assignexp MULT assignexp  */
#line 1927 "cfg.y"
                                   {
				(yyval.expr) = mk_elem(MULT_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5661 "cfg.tab.c"
    break;

  case 395: /* assignexp: assignexp SLASH assignexp  */
#line 1930 "cfg.y"
                                    {
				(yyval.expr) = mk_elem(DIV_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5669 "cfg.tab.c"
    break;

  case 396: /* assignexp: assignexp MODULO assignexp  */
#line 1933 "cfg.y"
                                     {
				(yyval.expr) = mk_elem(MODULO_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5677 "cfg.tab.c"
    break;

  case 397: /* assignexp: assignexp BAND assignexp  */
#line 1936 "cfg.y"
                                   {
				(yyval.expr) = mk_elem(BAND_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5685 "cfg.tab.c"
    break;

  case 398: /* assignexp: assignexp BOR assignexp  */
#line 1939 "cfg.y"
                                  {
				(yyval.expr) = mk_elem(BOR_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5693 "cfg.tab.c"
    break;

  case 399: /* assignexp: assignexp BXOR assignexp  */
#line 1942 "cfg.y"
                                   {
				(yyval.expr) = mk_elem(BXOR_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5701 "cfg.tab.c"
    break;

  case 400: /* assignexp: assignexp BLSHIFT assignexp  */
#line 1945 "cfg.y"
                                      {
				(yyval.expr) = mk_elem(BLSHIFT_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5709 "cfg.tab.c"
    break;

  case 401: /* assignexp: assignexp BRSHIFT assignexp  */
#line 1948 "cfg.y"
                                      {
				(yyval.expr) = mk_elem(BRSHIFT_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5717 "cfg.tab.c"
    break;

  case 402: /* assignexp: BNOT assignexp  */
#line 1951 "cfg.y"
                         {
				(yyval.expr) = mk_elem(BNOT_OP, EXPR_O, (yyvsp[0].expr), 0, 0);
			}
#line 5725 "cfg.tab.c"
    break;

  case 403: /* assignexp: LPAREN assignexp RPAREN  */
#line 1954 "cfg.y"
                                  { (yyval.expr) = (yyvsp[-1].expr); }
#line 5731 "cfg.tab.c"
    break;

  case 404: /* assign_cmd: script_var assignop assignexp  */
#line 1957 "cfg.y"
                                          {
			if(!pv_is_w((yyvsp[-2].specval)))
				yyerror("invalid left operand in assignment");
			if((yyvsp[-2].specval)->trans!=0)
				yyerror("transformations not accepted in left side "
					"of assignment");

			mk_action2( (yyval.action), (yyvsp[-1].intval),
					SCRIPTVAR_ST,
					EXPR_ST,
					(yyvsp[-2].specval),
					(yyvsp[0].expr));
		}
#line 5749 "cfg.tab.c"
    break;

  case 405: /* assign_cmd: script_var EQUAL NULLV  */
#line 1970 "cfg.y"
                                  {
			if(!pv_is_w((yyvsp[-2].specval)))
				yyerror("invalid left operand in assignment");
			if((yyvsp[-2].specval)->trans!=0)
				yyerror("transformations not accepted in left side "
					"of assignment");

			mk_action2( (yyval.action), EQ_T,
					SCRIPTVAR_ST,
					NULLV_ST,
					(yyvsp[-2].specval),
					0);
		}
#line 5767 "cfg.tab.c"
    break;

  case 406: /* assign_cmd: script_var COLONEQ NULLV  */
#line 1983 "cfg.y"
                                    {
			if(!pv_is_w((yyvsp[-2].specval)))
				yyerror("invalid left operand in assignment");
			/* not all can get NULL with := */
			switch((yyvsp[-2].specval)->type) {
				case PVT_AVP:
				break;
				default:
					yyerror("invalid left operand in NULL assignment");
			}
			if((yyvsp[-2].specval)->trans!=0)
				yyerror("transformations not accepted in left side "
					"of assignment");

			mk_action2( (yyval.action), COLONEQ_T,
					SCRIPTVAR_ST,
					NULLV_ST,
					(yyvsp[-2].specval),
					0);
		}
#line 5792 "cfg.tab.c"
    break;

  case 407: /* exp_stm: cmd  */
#line 2005 "cfg.y"
                                                                { (yyval.action)=(yyvsp[0].action); }
#line 5798 "cfg.tab.c"
    break;

  case 408: /* exp_stm: if_cmd  */
#line 2006 "cfg.y"
                                                                { (yyval.action)=(yyvsp[0].action); }
#line 5804 "cfg.tab.c"
    break;

  case 409: /* exp_stm: assign_cmd  */
#line 2007 "cfg.y"
                                                                { (yyval.action)=(yyvsp[0].action); }
#line 5810 "cfg.tab.c"
    break;

  case 410: /* exp_stm: LBRACE actions RBRACE  */
#line 2008 "cfg.y"
                                                { (yyval.action)=(yyvsp[-1].action); }
#line 5816 "cfg.tab.c"
    break;

  case 411: /* exp_stm: LBRACE RBRACE  */
#line 2009 "cfg.y"
                                                        { (yyval.action)=0; }
#line 5822 "cfg.tab.c"
    break;

  case 412: /* brk_stm: brk_action  */
#line 2012 "cfg.y"
                                                                { (yyval.action)=(yyvsp[0].action); }
#line 5828 "cfg.tab.c"
    break;

  case 413: /* brk_stm: LBRACE brk_actions RBRACE  */
#line 2013 "cfg.y"
                                                        { (yyval.action)=(yyvsp[-1].action); }
#line 5834 "cfg.tab.c"
    break;

  case 414: /* brk_stm: LBRACE RBRACE  */
#line 2014 "cfg.y"
                                                        { (yyval.action)=0; }
#line 5840 "cfg.tab.c"
    break;

  case 415: /* stm: action  */
#line 2017 "cfg.y"
                                                        { (yyval.action)=(yyvsp[0].action); }
#line 5846 "cfg.tab.c"
    break;

  case 416: /* stm: LBRACE actions RBRACE  */
#line 2018 "cfg.y"
                                                { (yyval.action)=(yyvsp[-1].action); }
#line 5852 "cfg.tab.c"
    break;

  case 417: /* stm: LBRACE RBRACE  */
#line 2019 "cfg.y"
                                                        { (yyval.action)=0; }
#line 5858 "cfg.tab.c"
    break;

  case 418: /* actions: actions action  */
#line 2022 "cfg.y"
                                {(yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 5864 "cfg.tab.c"
    break;

  case 419: /* actions: action  */
#line 2023 "cfg.y"
                                                {(yyval.action)=(yyvsp[0].action);}
#line 5870 "cfg.tab.c"
    break;

  case 420: /* actions: actions error  */
#line 2024 "cfg.y"
                                { (yyval.action)=0; yyerror("bad command!)"); }
#line 5876 "cfg.tab.c"
    break;

  case 421: /* brk_actions: brk_actions brk_action  */
#line 2028 "cfg.y"
                                        {(yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 5882 "cfg.tab.c"
    break;

  case 422: /* brk_actions: brk_action  */
#line 2029 "cfg.y"
                                                {(yyval.action)=(yyvsp[0].action);}
#line 5888 "cfg.tab.c"
    break;

  case 423: /* brk_actions: brk_actions error  */
#line 2030 "cfg.y"
                                    { (yyval.action)=0; yyerror("bad command!)"); }
#line 5894 "cfg.tab.c"
    break;

  case 424: /* action: cmd SEMICOLON  */
#line 2033 "cfg.y"
                              {(yyval.action)=(yyvsp[-1].action);}
#line 5900 "cfg.tab.c"
    break;

  case 425: /* action: if_cmd  */
#line 2034 "cfg.y"
                         {(yyval.action)=(yyvsp[0].action);}
#line 5906 "cfg.tab.c"
    break;

  case 426: /* action: while_cmd  */
#line 2035 "cfg.y"
                            {(yyval.action)=(yyvsp[0].action);}
#line 5912 "cfg.tab.c"
    break;

  case 427: /* action: foreach_cmd  */
#line 2036 "cfg.y"
                              {(yyval.action)=(yyvsp[0].action);}
#line 5918 "cfg.tab.c"
    break;

  case 428: /* action: switch_cmd  */
#line 2037 "cfg.y"
                             {(yyval.action)=(yyvsp[0].action);}
#line 5924 "cfg.tab.c"
    break;

  case 429: /* action: assign_cmd SEMICOLON  */
#line 2038 "cfg.y"
                                       {(yyval.action)=(yyvsp[-1].action);}
#line 5930 "cfg.tab.c"
    break;

  case 430: /* action: SEMICOLON  */
#line 2039 "cfg.y"
                                              {(yyval.action)=0;}
#line 5936 "cfg.tab.c"
    break;

  case 431: /* action: cmd error  */
#line 2040 "cfg.y"
                            { (yyval.action)=0; yyerror("bad command: missing ';'?"); }
#line 5942 "cfg.tab.c"
    break;

  case 432: /* brk_action: BREAK SEMICOLON  */
#line 2043 "cfg.y"
                            { mk_action0((yyval.action), BREAK_T);}
#line 5948 "cfg.tab.c"
    break;

  case 433: /* brk_action: cmd SEMICOLON  */
#line 2044 "cfg.y"
                                {(yyval.action)=(yyvsp[-1].action);}
#line 5954 "cfg.tab.c"
    break;

  case 434: /* brk_action: brk_if_cmd  */
#line 2045 "cfg.y"
                             {(yyval.action)=(yyvsp[0].action);}
#line 5960 "cfg.tab.c"
    break;

  case 435: /* brk_action: while_cmd  */
#line 2046 "cfg.y"
                            {(yyval.action)=(yyvsp[0].action);}
#line 5966 "cfg.tab.c"
    break;

  case 436: /* brk_action: foreach_cmd  */
#line 2047 "cfg.y"
                              {(yyval.action)=(yyvsp[0].action);}
#line 5972 "cfg.tab.c"
    break;

  case 437: /* brk_action: switch_cmd  */
#line 2048 "cfg.y"
                             {(yyval.action)=(yyvsp[0].action);}
#line 5978 "cfg.tab.c"
    break;

  case 438: /* brk_action: assign_cmd SEMICOLON  */
#line 2049 "cfg.y"
                                       {(yyval.action)=(yyvsp[-1].action);}
#line 5984 "cfg.tab.c"
    break;

  case 439: /* brk_action: SEMICOLON  */
#line 2050 "cfg.y"
                                              {(yyval.action)=0;}
#line 5990 "cfg.tab.c"
    break;

  case 440: /* brk_action: cmd error  */
#line 2051 "cfg.y"
                            { (yyval.action)=0; yyerror("bad command: missing ';'?"); }
#line 5996 "cfg.tab.c"
    break;

  case 441: /* brk_if_cmd: IF LPAREN exp RPAREN brk_stm  */
#line 2054 "cfg.y"
                                                                { mk_action3( (yyval.action), IF_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 NOSUBTYPE,
													 (yyvsp[-2].expr),
													 (yyvsp[0].action),
													 0);
									}
#line 6009 "cfg.tab.c"
    break;

  case 442: /* brk_if_cmd: IF LPAREN exp RPAREN brk_stm ELSE brk_stm  */
#line 2062 "cfg.y"
                                                                        { mk_action3( (yyval.action), IF_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 ACTIONS_ST,
													 (yyvsp[-4].expr),
													 (yyvsp[-2].action),
													 (yyvsp[0].action));
									}
#line 6022 "cfg.tab.c"
    break;

  case 443: /* if_cmd: IF LPAREN exp RPAREN stm  */
#line 2072 "cfg.y"
                                                                        { mk_action3( (yyval.action), IF_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 NOSUBTYPE,
													 (yyvsp[-2].expr),
													 (yyvsp[0].action),
													 0);
									}
#line 6035 "cfg.tab.c"
    break;

  case 444: /* if_cmd: IF LPAREN exp RPAREN stm ELSE stm  */
#line 2080 "cfg.y"
                                                                { mk_action3( (yyval.action), IF_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 ACTIONS_ST,
													 (yyvsp[-4].expr),
													 (yyvsp[-2].action),
													 (yyvsp[0].action));
									}
#line 6048 "cfg.tab.c"
    break;

  case 445: /* while_cmd: WHILE LPAREN exp RPAREN brk_stm  */
#line 2090 "cfg.y"
                                                        { mk_action2( (yyval.action), WHILE_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 (yyvsp[-2].expr),
													 (yyvsp[0].action));
									}
#line 6059 "cfg.tab.c"
    break;

  case 446: /* foreach_cmd: FOR LPAREN script_var IN script_var RPAREN brk_stm  */
#line 2098 "cfg.y"
                                                                   {
					if ((yyvsp[-4].specval)->type != PVT_SCRIPTVAR &&
					    (yyvsp[-4].specval)->type != PVT_AVP &&
						pv_type((yyvsp[-4].specval)->type) != PVT_JSON) {
						yyerror("\nfor-each statement: only \"var\", \"avp\" "
					            "and \"json\" iterators are supported!");
					}

					mk_action3( (yyval.action), FOR_EACH_T,
					            SCRIPTVAR_ST,
					            SCRIPTVAR_ST,
					            ACTIONS_ST,
					            (yyvsp[-4].specval),
					            (yyvsp[-2].specval),
					            (yyvsp[0].action));
					}
#line 6080 "cfg.tab.c"
    break;

  case 447: /* switch_cmd: SWITCH LPAREN script_var RPAREN LBRACE switch_stm RBRACE  */
#line 2116 "cfg.y"
                                                                                        {
											mk_action2( (yyval.action), SWITCH_T,
														SCRIPTVAR_ST,
														ACTIONS_ST,
														(yyvsp[-4].specval),
														(yyvsp[-1].action));
									}
#line 6092 "cfg.tab.c"
    break;

  case 448: /* switch_stm: case_stms default_stm  */
#line 2125 "cfg.y"
                                  { (yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 6098 "cfg.tab.c"
    break;

  case 449: /* switch_stm: case_stms  */
#line 2126 "cfg.y"
                                                { (yyval.action)=(yyvsp[0].action); }
#line 6104 "cfg.tab.c"
    break;

  case 450: /* case_stms: case_stms case_stm  */
#line 2128 "cfg.y"
                                        {(yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 6110 "cfg.tab.c"
    break;

  case 451: /* case_stms: case_stm  */
#line 2129 "cfg.y"
                                                {(yyval.action)=(yyvsp[0].action);}
#line 6116 "cfg.tab.c"
    break;

  case 452: /* case_stm: CASE snumber COLON brk_actions  */
#line 2132 "cfg.y"
                                         { mk_action2( (yyval.action), CASE_T,
													NUMBER_ST,
													ACTIONS_ST,
													(void*)(yyvsp[-2].intval),
													(yyvsp[0].action));
											}
#line 6127 "cfg.tab.c"
    break;

  case 453: /* case_stm: CASE snumber COLON  */
#line 2138 "cfg.y"
                                     { mk_action2( (yyval.action), CASE_T,
													NUMBER_ST,
													ACTIONS_ST,
													(void*)(yyvsp[-1].intval),
													NULL);
							}
#line 6138 "cfg.tab.c"
    break;

  case 454: /* case_stm: CASE STRING COLON brk_actions  */
#line 2144 "cfg.y"
                                                { mk_action2( (yyval.action), CASE_T,
													STR_ST,
													ACTIONS_ST,
													(void*)(yyvsp[-2].strval),
													(yyvsp[0].action));
											}
#line 6149 "cfg.tab.c"
    break;

  case 455: /* case_stm: CASE STRING COLON  */
#line 2150 "cfg.y"
                                    { mk_action2( (yyval.action), CASE_T,
													STR_ST,
													ACTIONS_ST,
													(void*)(yyvsp[-1].strval),
													NULL);
							}
#line 6160 "cfg.tab.c"
    break;

  case 456: /* default_stm: DEFAULT COLON brk_actions  */
#line 2158 "cfg.y"
                                       { mk_action1( (yyval.action), DEFAULT_T,
													ACTIONS_ST, (yyvsp[0].action));
									}
#line 6168 "cfg.tab.c"
    break;

  case 457: /* default_stm: DEFAULT COLON  */
#line 2161 "cfg.y"
                                { mk_action1( (yyval.action), DEFAULT_T, ACTIONS_ST, NULL); }
#line 6174 "cfg.tab.c"
    break;

  case 458: /* func_param: STRING  */
#line 2164 "cfg.y"
                   {
										elems[1].type = STR_ST;
										elems[1].u.data = (yyvsp[0].strval);
										(yyval.intval)=1;
										}
#line 6184 "cfg.tab.c"
    break;

  case 459: /* func_param: func_param COMMA STRING  */
#line 2169 "cfg.y"
                                          {
										if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
											yyerror("too many arguments "
												"in function\n");
											(yyval.intval)=0;
										}
										elems[(yyvsp[-2].intval)+1].type = STR_ST;
										elems[(yyvsp[-2].intval)+1].u.data = (yyvsp[0].strval);
										(yyval.intval)=(yyvsp[-2].intval)+1;
										}
#line 6199 "cfg.tab.c"
    break;

  case 460: /* func_param: COMMA  */
#line 2179 "cfg.y"
                        {
										elems[1].type = NULLV_ST;
										elems[1].u.data = NULL;
										elems[2].type = NULLV_ST;
										elems[2].u.data = NULL;
										(yyval.intval)=2;
										}
#line 6211 "cfg.tab.c"
    break;

  case 461: /* func_param: COMMA STRING  */
#line 2186 "cfg.y"
                               {
										elems[1].type = NULLV_ST;
										elems[1].u.data = NULL;
										elems[2].type = STR_ST;
										elems[2].u.data = (yyvsp[0].strval);
										(yyval.intval)=2;
										}
#line 6223 "cfg.tab.c"
    break;

  case 462: /* func_param: func_param COMMA  */
#line 2193 "cfg.y"
                                   {
										if ((yyvsp[-1].intval)+1>=MAX_ACTION_ELEMS) {
											yyerror("too many arguments "
												"in function\n");
											(yyval.intval)=0;
										}
										elems[(yyvsp[-1].intval)+1].type = NULLV_ST;
										elems[(yyvsp[-1].intval)+1].u.data = NULL;
										(yyval.intval)=(yyvsp[-1].intval)+1;
										}
#line 6238 "cfg.tab.c"
    break;

  case 463: /* func_param: snumber  */
#line 2203 "cfg.y"
                          {
										elems[1].type = NUMBER_ST;
										elems[1].u.number = (yyvsp[0].intval);
										(yyval.intval)=1;
										}
#line 6248 "cfg.tab.c"
    break;

  case 464: /* func_param: COMMA snumber  */
#line 2208 "cfg.y"
                                {
										elems[1].type = NULLV_ST;
										elems[1].u.data = NULL;
										elems[2].type = NUMBER_ST;
										elems[2].u.number = (yyvsp[0].intval);
										(yyval.intval)=2;
										}
#line 6260 "cfg.tab.c"
    break;

  case 465: /* func_param: func_param COMMA snumber  */
#line 2215 "cfg.y"
                                           {
										if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
											yyerror("too many arguments "
												"in function\n");
											(yyval.intval)=0;
										}
										elems[(yyvsp[-2].intval)+1].type = NUMBER_ST;
										elems[(yyvsp[-2].intval)+1].u.number = (yyvsp[0].intval);
										(yyval.intval)=(yyvsp[-2].intval)+1;
										}
#line 6275 "cfg.tab.c"
    break;

  case 466: /* func_param: script_var  */
#line 2225 "cfg.y"
                             {
										elems[1].type = SCRIPTVAR_ST;
										elems[1].u.data = (yyvsp[0].specval);
										(yyval.intval)=1;
										}
#line 6285 "cfg.tab.c"
    break;

  case 467: /* func_param: COMMA script_var  */
#line 2230 "cfg.y"
                                   {
										elems[1].type = NULLV_ST;
										elems[1].u.data = NULL;
										elems[2].type = SCRIPTVAR_ST;
										elems[2].u.data = (yyvsp[0].specval);
										(yyval.intval)=2;
										}
#line 6297 "cfg.tab.c"
    break;

  case 468: /* func_param: func_param COMMA script_var  */
#line 2237 "cfg.y"
                                              {
										if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
											yyerror("too many arguments "
												"in function\n");
											(yyval.intval)=0;
										}
										elems[(yyvsp[-2].intval)+1].type = SCRIPTVAR_ST;
										elems[(yyvsp[-2].intval)+1].u.data = (yyvsp[0].specval);
										(yyval.intval)=(yyvsp[-2].intval)+1;
										}
#line 6312 "cfg.tab.c"
    break;

  case 469: /* route_param: STRING  */
#line 2249 "cfg.y"
                    {
						route_elems[0].type = STRING_ST;
						route_elems[0].u.string = (yyvsp[0].strval);
						(yyval.intval)=1;
			}
#line 6322 "cfg.tab.c"
    break;

  case 470: /* route_param: snumber  */
#line 2254 "cfg.y"
                          {
						route_elems[0].type = NUMBER_ST;
						route_elems[0].u.number = (long)(yyvsp[0].intval);
						(yyval.intval)=1;
			}
#line 6332 "cfg.tab.c"
    break;

  case 471: /* route_param: NULLV  */
#line 2259 "cfg.y"
                        {
						route_elems[0].type = NULLV_ST;
						route_elems[0].u.data = 0;
						(yyval.intval)=1;
			}
#line 6342 "cfg.tab.c"
    break;

  case 472: /* route_param: script_var  */
#line 2264 "cfg.y"
                             {
						route_elems[0].type = SCRIPTVAR_ST;
						route_elems[0].u.data = (yyvsp[0].specval);
						(yyval.intval)=1;
			}
#line 6352 "cfg.tab.c"
    break;

  case 473: /* route_param: route_param COMMA STRING  */
#line 2269 "cfg.y"
                                           {
						if ((yyvsp[-2].intval)>=MAX_ACTION_ELEMS) {
							yyerror("too many arguments in function\n");
							(yyval.intval)=-1;
						} else {
							route_elems[(yyvsp[-2].intval)].type = STRING_ST;
							route_elems[(yyvsp[-2].intval)].u.data = (yyvsp[0].strval);
							(yyval.intval)=(yyvsp[-2].intval)+1;
						}
			}
#line 6367 "cfg.tab.c"
    break;

  case 474: /* route_param: route_param COMMA snumber  */
#line 2279 "cfg.y"
                                            {
						if ((yyvsp[-2].intval)>=MAX_ACTION_ELEMS) {
							yyerror("too many arguments in function\n");
							(yyval.intval)=-1;
						} else {
							route_elems[(yyvsp[-2].intval)].type = NUMBER_ST;
							route_elems[(yyvsp[-2].intval)].u.data = (void*)(long)(yyvsp[0].intval);
							(yyval.intval)=(yyvsp[-2].intval)+1;
						}
			}
#line 6382 "cfg.tab.c"
    break;

  case 475: /* route_param: route_param COMMA script_var  */
#line 2289 "cfg.y"
                                               {
						if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
							yyerror("too many arguments in function\n");
							(yyval.intval)=-1;
						} else {
							route_elems[(yyvsp[-2].intval)].type = SCRIPTVAR_ST;
							route_elems[(yyvsp[-2].intval)].u.data = (yyvsp[0].specval);
							(yyval.intval)=(yyvsp[-2].intval)+1;
						}
			}
#line 6397 "cfg.tab.c"
    break;

  case 476: /* route_param: route_param COMMA NULLV  */
#line 2299 "cfg.y"
                                          {
						if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
							yyerror("too many arguments in function\n");
							(yyval.intval)=-1;
						} else {
							route_elems[(yyvsp[-2].intval)].type = NULLV_ST;
							route_elems[(yyvsp[-2].intval)].u.data = 0;
							(yyval.intval)=(yyvsp[-2].intval)+1;
						}
			}
#line 6412 "cfg.tab.c"
    break;

  case 477: /* async_func: ID LPAREN RPAREN  */
#line 2311 "cfg.y"
                             {
				const acmd_export_t* acmd_tmp=find_mod_acmd_export_t((yyvsp[-2].strval));
				if (acmd_tmp==0){
					yyerrorf("unknown async command <%s>, "
						"missing loadmodule?", (yyvsp[-2].strval));
					(yyval.action)=0;
				}else{
					if (check_acmd_call_params(acmd_tmp,elems,0)<0) {
						yyerrorf("too few parameters "
							"for command <%s>\n", (yyvsp[-2].strval));
						(yyval.action)=0;
					} else {
						elems[0].type = ACMD_ST;
						elems[0].u.data_const = acmd_tmp;
						mk_action_((yyval.action), AMODULE_T, 1, elems);
					}
				}
			}
#line 6435 "cfg.tab.c"
    break;

  case 478: /* async_func: ID LPAREN func_param RPAREN  */
#line 2329 "cfg.y"
                                                      {
				const acmd_export_t* acmd_tmp=find_mod_acmd_export_t((yyvsp[-3].strval));
				if (acmd_tmp==0){
					yyerrorf("unknown async command <%s>, "
						"missing loadmodule?", (yyvsp[-3].strval));
					(yyval.action)=0;
				}else{
					rc = check_acmd_call_params(acmd_tmp,elems,(yyvsp[-1].intval));
					switch (rc) {
					case -1:
						yyerrorf("too few parameters "
							"for async command <%s>\n", (yyvsp[-3].strval));
						(yyval.action)=0;
						break;
					case -2:
						yyerrorf("too many parameters "
							"for async command <%s>\n", (yyvsp[-3].strval));
						(yyval.action)=0;
						break;
					case -3:
						yyerrorf("mandatory parameter "
							" omitted for async command <%s>\n", (yyvsp[-3].strval));
						(yyval.action)=0;
						break;
					default:
						elems[0].type = ACMD_ST;
						elems[0].u.data_const = acmd_tmp;
						mk_action_((yyval.action), AMODULE_T, (yyvsp[-1].intval)+1, elems);
					}
				}
			}
#line 6471 "cfg.tab.c"
    break;

  case 479: /* async_func: ID LPAREN error RPAREN  */
#line 2360 "cfg.y"
                                                 {
				(yyval.action)=0;
				yyerrorf("bad arguments for command <%s>", (yyvsp[-3].strval));
			}
#line 6480 "cfg.tab.c"
    break;

  case 480: /* async_func: ID error  */
#line 2364 "cfg.y"
                                   {
				(yyval.action)=0;
				yyerrorf("bare word <%s> found, command calls need '()'", (yyvsp[-1].strval));
			}
#line 6489 "cfg.tab.c"
    break;

  case 481: /* cmd: ASSERT LPAREN exp COMMA STRING RPAREN  */
#line 2370 "cfg.y"
                                                 {
			mk_action2( (yyval.action), ASSERT_T, EXPR_ST, STRING_ST, (yyvsp[-3].expr), (yyvsp[-1].strval));
			}
#line 6497 "cfg.tab.c"
    break;

  case 482: /* cmd: DROP  */
#line 2373 "cfg.y"
                                                 {mk_action0( (yyval.action), DROP_T); }
#line 6503 "cfg.tab.c"
    break;

  case 483: /* cmd: DROP LPAREN RPAREN  */
#line 2374 "cfg.y"
                                     {mk_action0( (yyval.action), DROP_T); }
#line 6509 "cfg.tab.c"
    break;

  case 484: /* cmd: EXIT  */
#line 2375 "cfg.y"
                                                 {mk_action0( (yyval.action), EXIT_T); }
#line 6515 "cfg.tab.c"
    break;

  case 485: /* cmd: EXIT LPAREN RPAREN  */
#line 2376 "cfg.y"
                                     {mk_action0( (yyval.action), EXIT_T); }
#line 6521 "cfg.tab.c"
    break;

  case 486: /* cmd: RETURN script_var  */
#line 2378 "cfg.y"
                                                         {mk_action1( (yyval.action), RETURN_T, SCRIPTVAR_ST, (void*)(yyvsp[0].specval)); }
#line 6527 "cfg.tab.c"
    break;

  case 487: /* cmd: RETURN LPAREN script_var RPAREN  */
#line 2380 "cfg.y"
                                                         {mk_action1( (yyval.action), RETURN_T, SCRIPTVAR_ST, (void*)(yyvsp[-1].specval)); }
#line 6533 "cfg.tab.c"
    break;

  case 488: /* cmd: RETURN snumber  */
#line 2382 "cfg.y"
                                                         {mk_action1( (yyval.action), RETURN_T, NUMBER_ST, (void*)(yyvsp[0].intval)); }
#line 6539 "cfg.tab.c"
    break;

  case 489: /* cmd: RETURN LPAREN snumber RPAREN  */
#line 2384 "cfg.y"
                                                         {mk_action1( (yyval.action), RETURN_T, NUMBER_ST, (void*)(yyvsp[-1].intval)); }
#line 6545 "cfg.tab.c"
    break;

  case 490: /* cmd: RETURN LPAREN RPAREN  */
#line 2386 "cfg.y"
                                                         {mk_action1( (yyval.action), RETURN_T, NUMBER_ST, (void*)1); }
#line 6551 "cfg.tab.c"
    break;

  case 491: /* cmd: RETURN  */
#line 2387 "cfg.y"
                                                 {mk_action1( (yyval.action), RETURN_T, NUMBER_ST, (void*)1); }
#line 6557 "cfg.tab.c"
    break;

  case 492: /* cmd: LOG_TOK LPAREN STRING RPAREN  */
#line 2388 "cfg.y"
                                                {mk_action2( (yyval.action), LOG_T, NUMBER_ST,
													STRING_ST,(void*)4,(yyvsp[-1].strval));
									}
#line 6565 "cfg.tab.c"
    break;

  case 493: /* cmd: LOG_TOK LPAREN snumber COMMA STRING RPAREN  */
#line 2391 "cfg.y"
                                                                {mk_action2( (yyval.action), LOG_T,
																NUMBER_ST,
																STRING_ST,
																(void*)(yyvsp[-3].intval),
																(yyvsp[-1].strval));
												}
#line 6576 "cfg.tab.c"
    break;

  case 494: /* cmd: LOG_TOK error  */
#line 2397 "cfg.y"
                                { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 6582 "cfg.tab.c"
    break;

  case 495: /* cmd: LOG_TOK LPAREN error RPAREN  */
#line 2398 "cfg.y"
                                              { (yyval.action)=0; yyerror("bad log"
									"argument"); }
#line 6589 "cfg.tab.c"
    break;

  case 496: /* cmd: ERROR LPAREN STRING COMMA STRING RPAREN  */
#line 2400 "cfg.y"
                                                          {mk_action2( (yyval.action), ERROR_T,
																STRING_ST,
																STRING_ST,
																(yyvsp[-3].strval),
																(yyvsp[-1].strval));
												  }
#line 6600 "cfg.tab.c"
    break;

  case 497: /* cmd: ERROR error  */
#line 2406 "cfg.y"
                              { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 6606 "cfg.tab.c"
    break;

  case 498: /* cmd: ERROR LPAREN error RPAREN  */
#line 2407 "cfg.y"
                                            { (yyval.action)=0; yyerror("bad error"
														"argument"); }
#line 6613 "cfg.tab.c"
    break;

  case 499: /* cmd: ROUTE LPAREN route_name_var RPAREN  */
#line 2409 "cfg.y"
                                                        {
						mk_action2( (yyval.action), ROUTE_T, (yyvsp[-1].intval), 0, rn_tmp.data, 0);
					}
#line 6621 "cfg.tab.c"
    break;

  case 500: /* cmd: ROUTE LPAREN route_name_var COMMA route_param RPAREN  */
#line 2413 "cfg.y"
                                                                        {
						if ((yyvsp[-1].intval) <= 0) yyerror("too many route parameters");

						/* duplicate the list */
						a_tmp = pkg_malloc((yyvsp[-1].intval) * sizeof(action_elem_t));
						if (!a_tmp) {
							yyerror("no more pkg memory");
							YYABORT;
						}
						memcpy(a_tmp, route_elems, (yyvsp[-1].intval)*sizeof(action_elem_t));

						mk_action3( (yyval.action), ROUTE_T, (yyvsp[-3].intval),	/* route idx */
							NUMBER_ST,					/* number of params */
							SCRIPTVAR_ST,				/* parameters */
							rn_tmp.data,
							(void*)(long)(yyvsp[-1].intval),
							(void*)a_tmp);
					}
#line 6644 "cfg.tab.c"
    break;

  case 501: /* cmd: ROUTE error  */
#line 2432 "cfg.y"
                              { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 6650 "cfg.tab.c"
    break;

  case 502: /* cmd: ROUTE LPAREN error RPAREN  */
#line 2433 "cfg.y"
                                            { (yyval.action)=0; yyerror("bad route"
						"argument"); }
#line 6657 "cfg.tab.c"
    break;

  case 503: /* cmd: ID LPAREN RPAREN  */
#line 2435 "cfg.y"
                                        {
								const cmd_export_t* cmd_tmp=find_cmd_export_t((yyvsp[-2].strval), rt);
								if (cmd_tmp==0){
									if (find_cmd_export_t((yyvsp[-2].strval), 0)) {
										yyerrorf("Command <%s> cannot be "
											"used in the block\n", (yyvsp[-2].strval));
									} else {
										yyerrorf("unknown command <%s>, "
											"missing loadmodule?", (yyvsp[-2].strval));
									}
									(yyval.action)=0;
								}else{
									if (check_cmd_call_params(cmd_tmp,elems,0)<0) {
										yyerrorf("too few parameters "
											"for command <%s>\n", (yyvsp[-2].strval));
										(yyval.action)=0;
									} else {
										elems[0].type = CMD_ST;
										elems[0].u.data_const = cmd_tmp;
										mk_action_((yyval.action), CMD_T, 1, elems);
									}
								}
							}
#line 6685 "cfg.tab.c"
    break;

  case 504: /* cmd: ID LPAREN func_param RPAREN  */
#line 2458 "cfg.y"
                                                {
								const cmd_export_t* cmd_tmp=find_cmd_export_t((yyvsp[-3].strval), rt);
								if (cmd_tmp==0){
									if (find_cmd_export_t((yyvsp[-3].strval), 0)) {
										yyerrorf("Command <%s> cannot be "
											"used in the block\n", (yyvsp[-3].strval));
									} else {
										yyerrorf("unknown command <%s>, "
											"missing loadmodule?", (yyvsp[-3].strval));
									}
									(yyval.action)=0;
								}else{
									rc = check_cmd_call_params(cmd_tmp,elems,(yyvsp[-1].intval));
									switch (rc) {
									case -1:
										yyerrorf("too few parameters "
											"for command <%s>\n", (yyvsp[-3].strval));
										(yyval.action)=0;
										break;
									case -2:
										yyerrorf("too many parameters "
											"for command <%s>\n", (yyvsp[-3].strval));
										(yyval.action)=0;
										break;
									case -3:
										yyerrorf("mandatory parameter "
											"omitted for command <%s>\n", (yyvsp[-3].strval));
										(yyval.action)=0;
										break;
									default:
										elems[0].type = CMD_ST;
										elems[0].u.data_const = cmd_tmp;
										mk_action_((yyval.action), CMD_T, (yyvsp[-1].intval)+1, elems);
									}
								}
							}
#line 6726 "cfg.tab.c"
    break;

  case 505: /* cmd: ID LPAREN error RPAREN  */
#line 2494 "cfg.y"
                                         { (yyval.action)=0; yyerrorf("bad arguments for "
												"command <%s>", (yyvsp[-3].strval)); }
#line 6733 "cfg.tab.c"
    break;

  case 506: /* cmd: ID error  */
#line 2496 "cfg.y"
                           { (yyval.action)=0;
			yyerrorf("bare word <%s> found, command calls need '()'", (yyvsp[-1].strval));
			}
#line 6741 "cfg.tab.c"
    break;

  case 507: /* cmd: XDBG LPAREN STRING RPAREN  */
#line 2499 "cfg.y"
                                            {
				mk_action1((yyval.action), XDBG_T, STR_ST, (yyvsp[-1].strval));	}
#line 6748 "cfg.tab.c"
    break;

  case 508: /* cmd: XDBG LPAREN folded_string RPAREN  */
#line 2501 "cfg.y"
                                                   {
				mk_action1((yyval.action), XDBG_T, STR_ST, (yyvsp[-1].strval));	}
#line 6755 "cfg.tab.c"
    break;

  case 509: /* cmd: XLOG LPAREN STRING RPAREN  */
#line 2503 "cfg.y"
                                            {
				mk_action1((yyval.action), XLOG_T, STR_ST, (yyvsp[-1].strval)); }
#line 6762 "cfg.tab.c"
    break;

  case 510: /* cmd: XLOG LPAREN folded_string RPAREN  */
#line 2505 "cfg.y"
                                                   {
				mk_action1((yyval.action), XLOG_T, STR_ST, (yyvsp[-1].strval)); }
#line 6769 "cfg.tab.c"
    break;

  case 511: /* cmd: XLOG LPAREN STRING COMMA STRING RPAREN  */
#line 2507 "cfg.y"
                                                         {
				mk_action2((yyval.action), XLOG_T, STR_ST, STR_ST, (yyvsp[-3].strval), (yyvsp[-1].strval)); }
#line 6776 "cfg.tab.c"
    break;

  case 512: /* cmd: XLOG LPAREN STRING COMMA folded_string RPAREN  */
#line 2509 "cfg.y"
                                                                {
				mk_action2((yyval.action), XLOG_T, STR_ST, STR_ST, (yyvsp[-3].strval), (yyvsp[-1].strval)); }
#line 6783 "cfg.tab.c"
    break;

  case 513: /* cmd: ASYNC_TOKEN LPAREN async_func COMMA route_name RPAREN  */
#line 2511 "cfg.y"
                                                                        {
				rt_ref = ref_script_route_by_name( (yyvsp[-1].strval), sroutes->request,
					RT_NO, REQUEST_ROUTE, 0);
				if (rt_ref==NULL) yyerror("fail to create route reference");
				mk_action2((yyval.action), ASYNC_T, ACTIONS_ST, ROUTE_REF_ST,
						(yyvsp[-3].action), (void*)rt_ref);
				}
#line 6795 "cfg.tab.c"
    break;

  case 514: /* cmd: ASYNC_TOKEN LPAREN async_func COMMA route_name COMMA NUMBER RPAREN  */
#line 2518 "cfg.y"
                                                                                     {
				rt_ref = ref_script_route_by_name( (yyvsp[-3].strval), sroutes->request,
					RT_NO, REQUEST_ROUTE, 0);
				if (rt_ref==NULL) yyerror("fail to create route reference");
				mk_action3((yyval.action), ASYNC_T, ACTIONS_ST, ROUTE_REF_ST, NUMBER_ST,
						(yyvsp[-5].action), (void*)rt_ref, (void*)(long)(yyvsp[-1].intval));
				}
#line 6807 "cfg.tab.c"
    break;

  case 515: /* cmd: LAUNCH_TOKEN LPAREN async_func COMMA route_name COMMA STRING RPAREN  */
#line 2525 "cfg.y"
                                                                                      {
				rt_ref = ref_script_route_by_name( (yyvsp[-3].strval), sroutes->request,
					RT_NO, REQUEST_ROUTE, 0);
				if (rt_ref==NULL) yyerror("fail to create route reference");
				mk_action3((yyval.action), LAUNCH_T, ACTIONS_ST, ROUTE_REF_ST, STRING_ST,
						(yyvsp[-5].action), (void*)rt_ref, (yyvsp[-1].strval));
				}
#line 6819 "cfg.tab.c"
    break;

  case 516: /* cmd: LAUNCH_TOKEN LPAREN async_func COMMA route_name RPAREN  */
#line 2532 "cfg.y"
                                                                         {
				rt_ref = ref_script_route_by_name( (yyvsp[-1].strval), sroutes->request,
					RT_NO, REQUEST_ROUTE, 0);
				if (rt_ref==NULL) yyerror("fail to create route reference");
				mk_action2((yyval.action), LAUNCH_T, ACTIONS_ST, ROUTE_REF_ST,
						(yyvsp[-3].action), (void*)rt_ref);
				}
#line 6831 "cfg.tab.c"
    break;

  case 517: /* cmd: LAUNCH_TOKEN LPAREN async_func RPAREN  */
#line 2539 "cfg.y"
                                                        {
				mk_action2((yyval.action), LAUNCH_T, ACTIONS_ST, ROUTE_REF_ST,
						(yyvsp[-1].action), (void*)NULL);
				}
#line 6840 "cfg.tab.c"
    break;


#line 6844 "cfg.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 2546 "cfg.y"


static inline void ALLOW_UNUSED warn(char* s)
{
	LM_WARN("warning in config file %s, line %d, column %d-%d: %s\n",
			get_cfg_file_name, line, startcolumn, column, s);
}

static void yyerror(char* s)
{
	cfg_dump_backtrace();
	LM_CRIT("parse error in %s:%d:%d-%d: %s\n",
			get_cfg_file_name, line, startcolumn, column, s);
	_cfg_dump_context(get_cfg_file_name, line, startcolumn, column, 1);
	cfg_errors++;
}

#define ERROR_MAXLEN 1024
static void yyerrorf(char *fmt, ...)
{
	char *tmp = pkg_malloc(ERROR_MAXLEN);
	va_list ap;
	va_start(ap, fmt);

	vsnprintf(tmp, ERROR_MAXLEN, fmt, ap);
	yyerror(tmp);

	pkg_free(tmp);
	va_end(ap);
}


static struct socket_id* mk_listen_id(char* host, enum sip_protos proto,
																	int port)
{
	struct socket_id* l;
	l=pkg_malloc(sizeof(struct socket_id));
	if (l==0){
		LM_CRIT("cfg. parser: out of memory.\n");
	}else{
		memset(l, 0, sizeof(*l));
		l->name     = host;
		l->proto    = proto;
		l->port     = port;
	}

	return l;
}

static void fill_socket_id(struct listen_param *param, struct socket_id *s)
{
	s->flags |= param->flags;
	s->workers = param->workers;
	s->auto_scaling_profile = param->auto_scaling_profile;
	if (param->socket)
		set_listen_id_adv(s, param->socket->name, param->socket->port);
	s->tag = param->tag;
}

static struct multi_str *new_string(char *s)
{
	struct multi_str *ms = pkg_malloc(sizeof(struct multi_str));
	if (!ms) {
		LM_CRIT("cfg. parser: out of memory.\n");
	}else{
		ms->s    = s;
		ms->next = NULL;
	}
	return ms;
}

static struct socket_id* set_listen_id_adv(struct socket_id* sock,
											char *adv_name,
											int adv_port)
{
	sock->adv_name=adv_name;
	sock->adv_port=adv_port;
	return sock;
}

static int parse_ipnet(char *in, int len, struct net **ipnet)
{
	char *p = NULL;
	str ip_s, mask_s;
	struct ip_addr *ip = NULL, *mask = NULL, *ip_tmp;
	int af;
	unsigned int bitlen;

	p = q_memchr(in, '.', len);
	if (p)
		af = AF_INET;
	else if (q_memchr(in, ':', len)) {
		af = AF_INET6;
	} else {
		LM_ERR("Not an IP");
		return -1;
	}

	p = q_memchr(in, '/', len);
	if (!p) {
		LM_ERR("No netmask\n");
		return -1;
	}
	ip_s.s = in;
	ip_s.len = p - in;

	mask_s.s = p + 1;
	mask_s.len = len - ip_s.len - 1;
	if (!mask_s.s || mask_s.len == 0) {
		LM_ERR("Empty netmask\n");
		return -1;
	}

	ip_tmp = (af == AF_INET) ? str2ip(&ip_s) : str2ip6(&ip_s);
	if (!ip_tmp) {
		LM_ERR("Invalid IP\n");
		return -1;
	}
	ip = pkg_malloc(sizeof *ip);
	if (!ip) {
		LM_CRIT("No more pkg memory\n");
		return -1;
	}
	memcpy(ip, ip_tmp, sizeof *ip);

	p = (af == AF_INET) ? q_memchr(p, '.', len-(p-in)+1) : q_memchr(p, ':', len-(p-in)+1);
	if (p) {
		ip_tmp = (af == AF_INET) ? str2ip(&mask_s) : str2ip6(&mask_s);
		if (!ip_tmp) {
			LM_ERR("Invalid netmask\n");
			return -1;
		}
		mask = pkg_malloc(sizeof *mask);
		if (!mask) {
			LM_CRIT("No more pkg memory\n");
			return -1;
		}
		memcpy(mask, ip_tmp, sizeof *mask);

		*ipnet = mk_net(ip, mask);
	} else {
		if (str2int(&mask_s, &bitlen) < 0) {
			LM_ERR("Invalid netmask bitlen\n");
			return -1;
		}

		*ipnet = mk_net_bitlen(ip, bitlen);
	}

	pkg_free(ip);
	pkg_free(mask);

	if (*ipnet == NULL)
			return -1;

	return 0;
}
